unit Atmos_BC;

interface

uses
{$ifdef Linux}
  SysUtils, Classes, QGraphics, QControls, QForms, 
  QDialogs, QStdCtrls, QExtCtrls, QButtons, QMenus, 
  IniFiles;
{$else}
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls, Buttons, Menus, IniFiles;
{$endif}

type
  TAtmosBC = class(TForm)
    Panel1: TPanel;
    Execute: TButton;
    Next: TButton;
    Back: TButton;
    Label1: TLabel;
    Edit1: TEdit;
    Label2: TLabel;
    Edit2: TEdit;
    Label3: TLabel;
    Edit3: TEdit;
    Label4: TLabel;
    Edit4: TEdit;
    OpenDialog1: TOpenDialog;
    BitBtn1: TBitBtn;
    GroupBox1: TGroupBox;
    Label5: TLabel;
    Label6: TLabel;
    Label7: TLabel;
    cbLBC: TComboBox;
    Edit5: TEdit;
    Label8: TLabel;
    BitBtn2: TBitBtn;
    BitBtn3: TBitBtn;
    cbABC: TComboBox;
    Label9: TLabel;
    Label10: TLabel;
    Bevel1: TBevel;
    procedure ExecuteClick(Sender: TObject);
    procedure BackClick(Sender: TObject);
    procedure NextClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure BitBtn1Click(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure cbLBCChange(Sender: TObject);
    procedure BitBtn2Click(Sender: TObject);
    procedure BitBtn3Click(Sender: TObject);
    procedure Edit2Change(Sender: TObject);
    procedure cbABCChange(Sender: TObject);
    procedure FormShow(Sender: TObject);
  private
  public
  end;

var
  AtmosBC: TAtmosBC;

implementation

uses WASH1dMain, StringGrid, Simulation, Recent;

{$R *.xfm}
//--------------------------------------------------------------
procedure TAtmosBC.FormCreate(Sender: TObject);
begin
  DialogBox := -1;
  if Mode = 2 then
  begin
    case IPET_type of
    1: abc_type := 2;
    2: abc_type := 1;
    4: abc_type := 3;
    end;
    cbABC.Enabled := False;
  end;
  Edit2.Text := FloatToStr(Tini-273.2);
  Edit5.Text := Edit2.Text;
  cbABC.ItemIndex := abc_type -1;
  if heat = 1 then
  begin
   // cbABC.Enabled := False;
    cbLBC.ItemIndex := h_l_bc_type - 1;
    Label2.Caption := 'Initial soil temperature=';
    Edit5.Enabled := True;
  end
  else
  begin
    BitBtn1.Enabled :=True;
    cbLBC.Enabled := False;
    cbLBC.ItemIndex := 0;
    Edit5.Enabled := False;
  end;
  cbABCChange(Sender);
  cbLBCChange(sender);
end;
//--------------------------------------------------------------
procedure TAtmosBC.ExecuteClick(Sender: TObject);
begin
  DialogBox := 0; Close;
end;
//--------------------------------------------------------------
procedure TAtmosBC.BackClick(Sender: TObject);
begin
  GoAhead:=False; DialogBox:=8; Close;
end;
//--------------------------------------------------------------
procedure TAtmosBC.NextClick(Sender: TObject);
begin
  GoAhead:=True; DialogBox:=10; Close;
end;
//--------------------------------------------------------------
procedure TAtmosBC.cbLBCChange(Sender: TObject);
begin
  Case cbLBC.ItemIndex of
  0:begin
    Label6.Enabled := True;
    Label7.Enabled := True;
    Edit5 .Enabled := True;
    end;
  1:begin
    Label6.Enabled := False;
    Label7.Enabled := False;
    Edit5 .Enabled := False;
    end;
  end;
end;
//--------------------------------------------------------------
procedure TAtmosBC.BitBtn1Click(Sender: TObject);
begin
  if heat <> 1 then
    ShowMessage('Since heat flow is not simulated, soil temperature is assumed equal to air temperature.')
end;
//--------------------------------------------------------------
procedure TAtmosBC.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  case abc_type of
    1:begin
        Tini := StrToFloat(Edit2.Text) + 273.2;
        Tair := Tini;
      end;
    2:begin
        ra   :=StrToFloat(Edit1.Text);
        Tair :=StrToFloat(Edit2.Text) + 273.2;
        RHair:=StrToFloat(Edit3.Text)/100;
        h_l_bc_type := cbLBC.ItemIndex + 1;
        if h_l_bc_type = 1 then
          Tbot := StrToFloat(Edit5.Text) + 273.2;
      end;
    3:begin
        Tair :=StrToFloat(Edit2.Text) + 273.2;
        fl_CumEvap := Main.GetAbsoluteDirectory(BaseDir, Edit4.Text);
      end;
    4:begin
        Tini := StrToFloat(Edit2.Text) + 273.2;
        h_l_bc_type := cbLBC.ItemIndex + 1;
        if h_l_bc_type = 1 then
          Tbot := StrToFloat(Edit5.Text) + 273.2;
      end;
  end;
end;
//----------------------------------------------------------
procedure TAtmosBC.BitBtn3Click(Sender: TObject);
var
  i,j: Integer;
  SL1, SL2: TStringList;
  f: TextFile;
begin
  SL1 := TStringList.Create;
  SL2 := TStringList.Create;
  i := 0;
  try
    SL1.LoadFromFile(fl_clmtc_con);
    for j := 1 to SL1.Count do
    begin
      SL2.CommaText := SL1[j-1];
      try
        t_clm_con[i] := StrToFloat(SL2[0]);
        wv[i]        := StrToFloat(SL2[1]);
        Ta[i]        := StrToFloat(SL2[2]);
        RHa[i]       := StrToFloat(SL2[3]);
        CPR[i]       := StrToFloat(SL2[4]);
        CRg[i]       := StrToFloat(SL2[5]);
        i := i + 1;
      except
      end;
    end;
  finally
    SL1.Free;
    SL2.Free;
  end;
  Table.StringGrid1.ColCount := 6;
  Table.StringGrid1.RowCount := i+2;
  Table.StringGrid1.FixedRows := 2;
  Table.StringGrid1.Cells[0,0] := '   time';
  Table.StringGrid1.Cells[1,0] := ' Wind V.';
  Table.StringGrid1.Cells[2,0] := ' T. of air';
  Table.StringGrid1.Cells[3,0] := 'R.H. of air';
  Table.StringGrid1.Cells[4,0] := 'Cum. Prec.';
  Table.StringGrid1.Cells[5,0] := 'Cum. Rs.';
  case t_unit of
      1:dumstr:='second';
     60:dumstr:='min';
   3600:dumstr:='hour';
  86400:dumstr:='day';
  end;
  Table.StringGrid1.Cells[0,1] := '   '+dumstr;
  Table.StringGrid1.Cells[1,1] := '   m/s';
  Table.StringGrid1.Cells[2,1] := '   C';
  Table.StringGrid1.Cells[3,1] := '    %';
  Table.StringGrid1.Cells[4,1] := '    mm';
  Table.StringGrid1.Cells[5,1] := '   MJ/m2';
  for j:=0 to i do
    begin
    Table.StringGrid1.Cells[0,j+2] := FormatFloat('######0.00',t_clm_con[j]);
    Table.StringGrid1.Cells[1,j+2] := FormatFloat('#0.0',wv[j]);
    Table.StringGrid1.Cells[2,j+2] := FormatFloat('#0.0',Ta[j]);
    Table.StringGrid1.Cells[3,j+2] := FormatFloat('#0',RHa[j]);
    Table.StringGrid1.Cells[4,j+2] := FormatFloat('##0.0',CPR[j]);
    Table.StringGrid1.Cells[5,j+2] := FormatFloat('#0.00',CRg[j]);
    end;
  Table.StringGrid1.Width := 28;
  for j:=0 to 5 do Table.StringGrid1.Width := Table.StringGrid1.Width + Table.StringGrid1.ColWidths[j];
  Table.Width := Table.StringGrid1.Width + 32 * 2 ;
  Table.Panel1.Left := Table.Width div 2 - Table.Panel1.Width div 2;
  Table.Caption := 'Climatic Condition';
  if Table.ShowModal = mrOK then
  begin
    AssignFile(f, ExeDir + fl_clmtc_con);
    Rewrite(f);
    for j:=0 to Table.StringGrid1.RowCount-3 do
    begin
      t_clm_con[j] := StrToFloat(Table.StringGrid1.Cells[0,j+2]);
      wv[j]        := StrToFloat(Table.StringGrid1.Cells[1,j+2]);
      Ta[j]        := StrToFloat(Table.StringGrid1.Cells[2,j+2]);
      RHa[j]       := StrToFloat(Table.StringGrid1.Cells[3,j+2]);
      CPR[j]       := StrToFloat(Table.StringGrid1.Cells[4,j+2]);
      CRg[j]       := StrToFloat(Table.StringGrid1.Cells[5,j+2]);
      Writeln(f,
      Simulator.SetLengthRJ(FormatFloat('######0.00',t_clm_con[j]), 11)+
      Simulator.SetLengthRJ(FormatFloat('#0.0',wv[j]),6)+
      Simulator.SetLengthRJ(FormatFloat('#0.0',Ta[j]),6)+
      Simulator.SetLengthRJ(FormatFloat('#0',RHa[j]), 8)+
      Simulator.SetLengthRJ(FormatFloat('##0.0',CPR[j]),8)+
      Simulator.SetLengthRJ(FormatFloat('#0.00',CRg[j]),8) )
    end;
    CloseFile(f);
  end;
end;

procedure TAtmosBC.BitBtn2Click(Sender: TObject);
begin
  if abc_type = 3 then
    ShowMessage('Please input name of the file which holds time change of measured cumulative evaporation amount.')
  else
    ShowMessage('Please input name of the file which holds the climatic data');
  with OpenDialog1 do
  begin
    InitialDir := BaseDir;
    if abc_type = 3 then
      FileName := fl_CumEvap
    else
      FileName := fl_clmtc_con;
    if FileName = '' then
      FileName := 'Please double-click the file above.';
    if Execute = True then
    begin
      Edit4.Text := Main.GetRelativeDirectory(BaseDir, FileName);
      if abc_type = 3 then
        fl_CumEvap := FileName
      else
        fl_clmtc_con := FileName;
    end;
  end;
end;


procedure TAtmosBC.Edit2Change(Sender: TObject);
begin
  if Mode = 2 then
    Edit5.Text := Edit2.Text;
end;

procedure TAtmosBC.cbABCChange(Sender: TObject);
begin
  abc_type := cbABC.ItemIndex +1;
  {
  if abc_type = 3 then
    Edit2.Left := 21
  else
    Edit2.Left := 71;
  }
  Label8.Left := Edit2.Left + 42;
  if Mode = 1 then
    Edit2.Text := FloatToStr(Tair-273.2);
  case abc_type of
    1:begin
        if (Mode <> 2) or (IPET_type <> 1) then
          fl_CumEvap := '';
        Label1.Enabled := False;
      //  Label2.Enabled := False;
        Label3.Enabled := False;
        Label6.Enabled := False;
        Label8.Enabled := False;
        Edit1.Enabled := False;
      //  Edit2.Enabled := False;
        Edit3.Enabled := False;
        Edit5.Enabled := False;
        //Execute.SetFocus;
        Edit4.Enabled := False;
        Label4.Enabled := False;
        BitBtn1.Enabled :=False;
        BitBtn2.Enabled :=False;
        BitBtn3.Enabled :=False;
      end;
    2:begin
        if (Mode <> 2) or (IPET_type <> 1) then
          fl_CumEvap := '';
        Edit1.Text := FloatToStr(ra);
    //    Edit2.Text := FloatToStr(Tair-273.2);
        Edit3.Text := FloatToStr(RHair*100);
        {
        if (Mode = 2) and (IPET_type = 1) then
        begin
          Label1.Enabled := False;
          Edit1.Enabled  := False
        end
        else
        begin
        }
          Label1.Enabled := True;
          Edit1.Enabled := True;
        //end;
        Label2.Enabled := True;
        Label3.Enabled := True;
        Label8.Enabled := True;
        Edit2.Enabled := True;
        Edit3.Enabled := True;
        Edit4.Enabled := False;
        Label4.Enabled := False;
        BitBtn1.Enabled :=True;
        BitBtn2.Enabled :=False;
        BitBtn3.Enabled :=False;
      end;
    3:begin
      //  Edit2.Text := FloatToStr(Tair-273.2);
        Label1.Enabled := False;
        Label2.Enabled := True;
        Label3.Enabled := False;
        Label8.Enabled := True;
        Edit1.Enabled := False;
        Edit2.Enabled := True;
        Edit3.Enabled := False;
        BitBtn1.Enabled :=True;
        BitBtn2.Enabled :=True;
        BitBtn3.Enabled :=False;
        fl_CumEvap := TrimLeft(fl_CumEvap);
        if fl_CumEvap = '' then
          BitBtn2Click(Sender)
        else
          Edit4.Text := Main.GetRelativeDirectory(BaseDir, fl_CumEvap);
        Edit4.Enabled := True;
        Label4.Enabled := True;
      end;
    4:begin
        if heat <> 1 then
        begin
          ShowMessage('This option is not valid unless heat movement is simulated.');
          Exit;
        end;
        if (Mode <> 2) or (IPET_type <> 1) then
          fl_CumEvap := '';
        Label1.Enabled := False;
        Label2.Enabled := True;
        Label3.Enabled := False;
        Label8.Enabled := True;
        Edit1.Enabled := False;
        Edit2.Enabled := True;
        Edit3.Enabled := False;
        BitBtn1.Enabled := False;
        BitBtn2.Enabled := True;
        BitBtn3.Enabled := True;
        fl_clmtc_con := TrimLeft(fl_clmtc_con);
        if fl_clmtc_con = '' then
          BitBtn1Click(Sender)
        else
          Edit4.Text := Main.GetRelativeDirectory(BaseDir, fl_clmtc_con);
        Edit4.Enabled := True;
        Label4.Enabled := True;
      end;
  end;
end;

procedure TAtmosBC.FormShow(Sender: TObject);
var
  IniFile: TIniFile;
  S, ResourceFileName: String;
  i: Integer;
  procedure GetComboBoxItems(CB: TComboBox );
  begin
    i := CB.ItemIndex;
    CB.Items.Text := StringReplace(IniFile.ReadString(S, CB.Name +  '.Items.Text', ''), '<br>', #13#10, [rfReplaceAll, rfIgnoreCase]);
    CB.ItemIndex := i;
  end;
begin
  S := Self.Name;
  ResourceFileName := ChangeFileExt(Application.ExeName, '.lng');
  Font.Assign(Main.Font);
  if FileExists(ResourceFileName) then
  begin
    IniFile := TIniFile.Create(ResourceFileName);
    with IniFile do
      try
        Caption             := ReadString(S, 'AtmosBC.Caption', '');
        Label1.Caption      := ReadString(S, 'Label1.Caption', '');
        Label2.Caption      := ReadString(S, 'Label2.Caption', '');
        Label3.Caption      := ReadString(S, 'Label3.Caption', '');
        Label4.Caption      := ReadString(S, 'Label4.Caption', '');
        Label8.Caption      := ReadString(S, 'Label8.Caption', '');
        Label9.Caption      := ReadString(S, 'Label9.Caption', '');
        Label10.Caption     := ReadString(S, 'Label10.Caption', '');
        Panel1.Caption      := ReadString(S, 'Panel1.Caption', '');
        Execute.Caption     := ReadString(S, 'Execute.Caption', '');
        Next.Caption        := ReadString(S, 'Next.Caption', '');
        Back.Caption        := ReadString(S, 'Back.Caption', '');
        GroupBox1.Caption   := ReadString(S, 'GroupBox1.Caption', '');
        Label5.Caption      := ReadString(S, 'Label5.Caption', '');
        Label6.Caption      := ReadString(S, 'Label6.Caption', '');
        Label7.Caption      := ReadString(S, 'Label7.Caption', '');
        Hint                := ReadString(S, 'BitBtn2.Hint', '');
        BitBtn3.Hint        := ReadString(S, 'BitBtn3.Hint', '');
        Font.Name           := ReadString(S, 'AtmosBC.Font.Name', '');
        Label8.Font.Name    := ReadString(S, 'Label8.Font.Name', '');
        Label7.Font.Name    := ReadString(S, 'Label7.Font.Name', '');
        GetComboBoxItems(cbABC);
        GetComboBoxItems(cbLBC);
      finally
        Free;
      end;
  end;
end;

end.
