{
_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/

        WASH_1D version 1.35

        Copyright(C) 2000-2004 Haruyuki FUJIMAKI and Mitsuhiro INOUE
        fujimaki@sakura.cc.tsukuba.ac.jp
        URL: http://www.geocities.jp/fujimaki691202/
        Distributed under the GPL

_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/
}

unit En_Factor;

interface

uses
{$ifdef Linux}
  SysUtils, Classes, QGraphics, QControls, QForms, 
  QDialogs, QStdCtrls, QExtCtrls, QGrids, QComCtrls, 
  QButtons;
{$else}  
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls, Grids, jpeg, ComCtrls, Buttons, Spin;
{$endif}

type
  TEnFactor = class(TForm)
    Panel1: TPanel;
    Execute: TButton;
    Back: TButton;
    Next: TButton;
    Edit1: TEdit;
    Edit2: TEdit;
    Edit3: TEdit;
    Edit4: TEdit;
    Edit5: TEdit;
    Image1: TImage;
    Label6: TLabel;
    BitBtn1: TBitBtn;
    seLayerNumber: TSpinEdit;
    procedure ExecuteClick(Sender: TObject);
    procedure BackClick(Sender: TObject);
    procedure NextClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure BitBtn1Click(Sender: TObject);
    {$ifdef Linux}
    procedure seLayerNumberChanged(Sender: TObject; NewValue: Integer);
    {$else}
    procedure seLayerNumberChange(Sender: TObject);
    {$endif}
  private
    { Private  }
    procedure ShowEquation;
    procedure GetParameters;
  public
    { Public  }
  end;

var
  EnFactor: TEnFactor;
  j: Shortint;

implementation

uses WASH1dMAIN, RC_Params;

{$R *.xfm}

//------------------------------------------------------
procedure TEnFactor.FormCreate(Sender: TObject);
begin
  dialogbox := -1;
  seLayerNumber.Value := 1;
  j := 1;
  {$ifdef Linux}
  seLayerNumber.Max := NumLayer;
  {$else}
  seLayerNumber.MaxValue := NumLayer;
  {$endif}
  if NumLayer = 1 then
    seLayerNumber.Enabled := False;
  ShowEquation;
end;
//------------------------------------------------------
procedure TEnFactor.ExecuteClick(Sender: TObject);
begin
  dialogbox:=0; Close();
end;
//------------------------------------------------------
procedure TEnFactor.BackClick(Sender: TObject);
begin
  GoAhead:=false; dialogbox:=6; Close();
end;
//------------------------------------------------------
procedure TEnFactor.NextClick(Sender: TObject);
begin
  GoAhead:=true; dialogbox:=8; Close();
end;
//------------------------------------------------------
procedure TEnFactor.ShowEquation();
begin
  dumstr:='McInnes_en0.jpg';
  if j = 0 then j := 1;
  Edit1.Text := FloatToStr(Soil.Aen[j]);
  Edit2.Text := FloatToStr(Soil.Ben[j]);
  Edit3.Text := FloatToStr(Soil.Cen[j]);
  Edit5.Text := FloatToStr(Soil.Een[j]);
  dumstr := ExeDir + Slash + 'Equations' + Slash + dumstr;
  image1.picture.loadfromfile(dumstr);
  end;
//------------------------------------------------------
procedure TEnFactor.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  GetParameters;
end;
//--------------------------------------------------------------------
procedure TEnFactor.GetParameters;
begin
  if j = 0 then j := 1;
  Soil.Aen[j] := StrToFloat(Edit1.Text);
  Soil.Ben[j] := StrToFloat(Edit2.Text);
  Soil.Cen[j] := StrToFloat(Edit3.Text);
  Soil.Den[j] := StrToFloat(Edit4.Text);
  Soil.Een[j] := StrToFloat(Edit5.Text);
end;
//--------------------------------------------------------------------
procedure TEnFactor.BitBtn1Click(Sender: TObject);
begin
  GetParameters;
  Main.ExecuteXYGrapher(6, j);
end;

{$ifdef Linux}
procedure TEnFactor.seLayerNumberChanged(Sender: TObject; NewValue: Integer);
{$else}
procedure TEnFactor.seLayerNumberChange(Sender: TObject);
{$endif}
begin
  if (Edit1.Text <> '1') or (Edit2.Text <> '1') then
  begin
    GetParameters;
    j := seLayerNumber.Value;
    ShowEquation;
  end;
end;


end.
