{
_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/

        WASH_1D version 1.35

        Copyright(C) 2000-2004 Haruyuki FUJIMAKI and Mitsuhiro INOUE
        fujimaki@sakura.cc.tsukuba.ac.jp
        URL: http://www.geocities.jp/fujimaki691202/
        Distributed under the GPL

_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/
}

unit G_Information;

interface

uses
{$ifdef Linux}
  SysUtils, Classes, QGraphics, QControls, QForms, 
  QDialogs, QStdCtrls, QExtCtrls, QButtons, QMenus, IniFiles
  
  
  
  
  ;
{$else}
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls, Buttons, Menus, IniFiles;
{$endif}

type
  TGeneralInfo = class(TForm)
    GroupBox1: TGroupBox;
    chkWater: TCheckBox;
    Label1: TLabel;
    edComment: TEdit;
    chkSolute: TCheckBox;
    chkHeat: TCheckBox;
    Panel1: TPanel;
    Execute: TButton;
    Next: TButton;
    chkRoot: TCheckBox;
    GroupBox3: TGroupBox;
    cbTimeUnit: TComboBox;
    Label6: TLabel;
    Label7: TLabel;
    ed_t_end: TEdit;
    Label8: TLabel;
    ed_dt_ini: TEdit;
    Label9: TLabel;
    ed_dt_max: TEdit;
    Label10: TLabel;
    ed_int_rec: TEdit;
    chkRec: TCheckBox;
    Label11: TLabel;
    CBobjective: TComboBox;
    SpeedButton2: TSpeedButton;
    SpeedButton1: TSpeedButton;
    procedure FormCreate(Sender: TObject);
    procedure ExecuteClick(Sender: TObject);
    procedure NextClick(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure CBobjectiveChange(Sender: TObject);
    procedure SpeedButton2Click(Sender: TObject);
    procedure cbTimeUnitChange(Sender: TObject);
    procedure ed_t_endExit(Sender: TObject);
    procedure Language;
    procedure chkSoluteClick(Sender: TObject);
    procedure chkWaterClick(Sender: TObject);
  private
    { Private  }
  public
    { Public  }
  end;

var
  GeneralInfo: TGeneralInfo;
  AllowModified :Boolean;
  tunit: Integer;

//---------------------------------------------------------------------------
implementation

uses WASH1dMAIN, MyMsgDlg;

{$R *.xfm}
//---------------------------------------------------------------------------
procedure TGeneralInfo.FormCreate(Sender: TObject);
begin
  Language;
  DialogBox := -1;
  CBobjective.ItemIndex := Mode - 1;
  CBobjectiveChange(Sender);
  edComment.Text := comment;
  ed_dt_max.Text  := FloatToStr(dt_max);
  if dt_ini <> 0 then
    ed_dt_ini.Text  := FloatToStr(dt_ini)
  else
    ed_dt_ini.Text := FormatFloat('#0.#######', 1 / t_unit);
  ed_int_rec.Text := FloatToStr(int_rec);
  if water = 1 then chkWater.Checked:=true else chkWater.Checked:=false;
  if solute = 1 then chkSolute.Checked:=true else chkSolute.Checked:=false;
  if heat = 1 then chkHeat.Checked:=true else chkHeat.Checked:=false;
  if CaseName = BaseDir + Slash + 'Untitled' then
    chkWater.Checked := true;
  case t_unit of
      1: cbTimeUnit.ItemIndex := 0;
     60: cbTimeUnit.ItemIndex := 1;
   3600: cbTimeUnit.ItemIndex := 2;
  86400: cbTimeUnit.ItemIndex := 3;
  end;
  if rec=1 then
    chkRec.Checked := True
  else
    chkRec.Checked := False;
  AllowModified := False;
  cbTimeUnitChange(Sender);
end;
//---------------------------------------------------------------------------
procedure TGeneralInfo.ExecuteClick(Sender: TObject);
begin
  DialogBox := 0;
  Close;
end;
//---------------------------------------------------------------------------
procedure TGeneralInfo.NextClick(Sender: TObject);
begin
  DialogBox := 2;
  Mode := CBobjective.ItemIndex + 1;
  if Mode = 2 then
    DialogBox := 11;
  Close;
end;
//---------------------------------------------------------------------------
procedure TGeneralInfo.FormClose(Sender: TObject;
var Action: TCloseAction);
begin
  comment := edComment.Text;
  Main.StatusBar1.SimpleText := '  ' + comment;
  /// Objective process ///
  if chkWater.Checked =true then water :=1 else water :=0;
  if chkSolute.Checked=true then solute:=1 else solute:=0;
  if chkHeat.Checked  =true then heat  :=1 else heat  :=0;
  if (water = 0) and (heat = 1) then
  begin
    ShowMessage('Water flow must be simulated whenever heat movement is simulated in this software.');
    chkWater.Checked := True;
    Exit;
  end;
  /// Time Discretization ///
  if cbTimeUnit.ItemIndex <> -1 then
  begin
    Case cbTimeUnit.ItemIndex of
      0: t_unit:=    1;
      1: t_unit:=   60;
      2: t_unit:= 3600;
      3: t_unit:=86400;
    end;
  end;
  dt_max := StrToFloat(ed_dt_max.Text);
  dt_ini := StrToFloat(ed_dt_ini.Text);
  int_rec:= StrToFloat(ed_int_rec.Text);
  if (Mode <> 2) or (Solute = 1) then
    t_end  := StrToFloat(ed_t_end.Text);
  if chkRec.Checked=true then
    rec := 1
  else
    rec := 0;
  if int_rec = 0 then
    int_rec := t_end / 100;
  if (Mode <> 2) and (t_end / int_rec >= 3000) then
  begin
    ShowMessage('Number of record must be within 3000. Please increase interval of record.');
    DialogBox := 1;
  end;
end;

//----------------------------------------------------------
procedure TGeneralInfo.CBobjectiveChange(Sender: TObject);
begin
  Mode := CBobjective.ItemIndex + 1;
  if Mode = 3 then
  begin
    ShowMessage('Sorry, under construction  m(__)m');
    CBobjective.ItemIndex := 0;
  end;
  if (Mode = 2) and (Solute = 0) then
  begin
    ed_t_end.Enabled := False;
    ed_t_end.Text := 'Auto';
    chkHeat.Checked := False;
    chkHeat.Enabled := False;
  end
  else
  begin
    ed_t_end.Enabled := True;
    ed_t_end.Text := FloatToStr(t_end);
  end;
end;
//----------------------------------------------------------
procedure TGeneralInfo.SpeedButton2Click(Sender: TObject);
begin
  {$ifdef Linux}
  if Application.MessageBox('Is this run numerical experiment?','Hidden function', [smbYes, smbNo])
    = smbYes then
  {$else}
  if Application.MessageBox('Is this run numerical experiment?','Hidden function',MB_YESNO +MB_ICONQUESTION)
    = id_Yes then
  {$endif}
  begin
    NumExp := 1;
    LowestPbot  := MyMessageDlg.ReceiveFloat('','Please input lowest/highest pressure head at the bottom.', 'cm', -160, 50, 1);
    ChgCriteria := MyMessageDlg.ReceiveFloat('','Please input criteria for step-wise change of pressure head at the bottom.', 'mm/d', 0.5, 50, 1);
    {$ifdef Linux}
    if Application.MessageBox('Do you simulate the Two-Stage Method?','', [smbYes, smbNo])
      = smbYes then
    {$else}
    if Application.MessageBox('Do you simulate the Two-Stage Method?','',MB_YESNO +MB_ICONQUESTION)
      = id_Yes then
    {$endif}
    begin
      MultiStep := 0;
      ShowMessage('Please set space increment at 0.05cm.');
      ArtSTEOutflow := MyMessageDlg.ReceiveFloat('Setting of Artificial error', 'What is the standard error of outflow?', 'cm', 0.003, 60, 3);
      ArtSTEEvap    := MyMessageDlg.ReceiveFloat('Setting of Artificial error', 'What is the standard error of evaporation?', 'cm', 0.003, 60, 3);
      ArtCEVWC      := MyMessageDlg.ReceiveFloat('Setting of Artificial error', 'What is the coefficient of error of volumetric water content?', ' ', 0.05, 60, 3);
      ArtCEPsychro  := MyMessageDlg.ReceiveFloat('Setting of Artificial error', 'What is the coefficient of error of matric potential measured using psycrometer?', '  ', 0.05, 60, 3);
      Randomize;
    end
    else
      {$ifdef Linux}
      if Application.MessageBox('Do you simulate the MultiStep-Outflow Method?','', [smbYes, smbNo])
        = smbYes then
      {$else}
      if Application.MessageBox('Do you simulate the MultiStep-Outflow Method?','',MB_YESNO +MB_ICONQUESTION)
        = id_Yes then
      {$endif}
        MultiStep := 1
      else
        MultiStep := 2;
  end;
end;
//----------------------------------------------------------
{$WARNINGS OFF}
procedure TGeneralInfo.cbTimeUnitChange(Sender: TObject);
var
  dtmax, dtini, tend, intrec: Double;
begin
  Case cbTimeUnit.ItemIndex of
    0: tunit:=    1;
    1: tunit:=   60;
    2: tunit:= 3600;
    3: tunit:=86400;
  end;
  dtmax := StrToFloat(ed_dt_max.Text) * tunit;
  dtini := StrToFloat(ed_dt_ini.Text) * tunit;
  intrec:= StrToFloat(ed_int_rec.Text) * tunit;
  if Mode <> 2 then
    tend  := StrToFloat(ed_t_end.Text) * tunit;
  ed_dt_max.Text  := FloatToStr(dtmax / tunit);
  ed_int_rec.Text := FloatToStr(intrec / tunit);
  if Mode <> 2 then
    ed_t_end.Text   := FloatToStr(tend / tunit);
  if dtini <> 0 then
  begin
    dumstr := FormatFloat('#0.000000', dtini / tunit);
    ed_dt_ini.Text := dumstr;
  end;
  if dt_max = 0 then
  begin
    dumstr := FloatToStr(600 / tunit);
   // SetLength(dumstr, 9);
    ed_dt_max.Text := dumstr;
  end;
  if (Mode <> 2) or (Solute = 1) then
    ed_t_end.Text := FloatToStr(t_end)
  else
    ed_t_end.Text := 'Auto';
end;
{$WARNINGS ON}
//----------------------------------------------------------
procedure TGeneralInfo.ed_t_endExit(Sender: TObject);
begin
  if (int_rec <> 0) and (ed_int_rec.Text <> '') then Exit;
  t_end := StrToFloat(ed_t_end.Text);
  int_rec := t_end / 100;
  ed_int_rec.Text := FloatToStr(int_rec);
end;
//----------------------------------------------------------
procedure TGeneralInfo.Language;
var
  IniFile: TIniFile;
  S, ResourceFileName: String;
  i: Integer;
begin
  S := Self.Name;
  ResourceFileName := ChangeFileExt(Application.ExeName, '.lng');
  Font.Assign(Main.Font);
  if FileExists(ResourceFileName) then
  begin
    IniFile := TIniFile.Create(ResourceFileName);
    with IniFile do
      try
        Caption            := ReadString(S, 'Caption', '');
        Label1.Caption     := ReadString(S, 'Label1.Caption', '');
        Label10.Caption    := ReadString(S, 'Label10.Caption', '');
        Label11.Caption    := ReadString(S, 'Label11.Caption', '');
        GroupBox1.Caption  := ReadString(S, 'GroupBox1.Caption', '');
        chkWater.Caption   := ReadString(S, 'chkWater.Caption', '');
        chkSolute.Caption  := ReadString(S, 'chkSolute.Caption', '');
        chkHeat.Caption    := ReadString(S, 'chkHeat.Caption', '');
        chkRoot.Caption    := ReadString(S, 'chkRoot.Caption', '');
        Execute.Caption    := ReadString(S, 'Execute.Caption', '');
        Next.Caption       := ReadString(S, 'Next.Caption', '');
        GroupBox3.Caption  := ReadString(S, 'GroupBox3.Caption', '');
        Label6.Caption     := ReadString(S, 'Label6.Caption', '');
        Label7.Caption     := ReadString(S, 'Label7.Caption', '');
        Label8.Caption     := ReadString(S, 'Label8.Caption', '');
        Label9.Caption     := ReadString(S, 'Label9.Caption', '');
        chkRec.Caption     := ReadString(S, 'chkRec.Caption', '');
        Execute.Hint       := ReadString(S, 'Execute.Hint', '');
        i := CBobjective.ItemIndex;
        CBobjective.Items.Text := StringReplace(ReadString(S, 'CBobjective.Items.Text', ''), '<br>', #13#10, [rfReplaceAll, rfIgnoreCase]);
        CBobjective.ItemIndex := i;
      finally
        IniFile.Free;
      end;
    end;
    if LANG = 128 then
    begin
      ed_dt_ini.Left := 160;
      ed_dt_max.Left := 160;
      ed_t_end.Left  := 160;
    end;
  end;
procedure TGeneralInfo.chkSoluteClick(Sender: TObject);
begin
  if (Mode = 2) and (chkSolute.Checked) then
    chkWater.Checked := False;
end;

procedure TGeneralInfo.chkWaterClick(Sender: TObject);
begin
  if (Mode = 2) and (chkWater.Checked) then
    chkSolute.Checked := False;
end;

end.

