unit Help_Search;

interface

uses
{$ifdef Linux}
  SysUtils, Classes, QGraphics, QControls, QForms, 
  QDialogs, QStdCtrls, QExtCtrls, 
  HelpTreeView, QComCtrls;
{$else}
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls, ComCtrls, HelpTreeView;
{$endif}

type
  THelpSearch = class(TForm)
    TabControl: TTabControl;
    edSearch: TEdit;
    btnSearch: TButton;
    lblPrompt: TLabel;
    HelpTreeView: THelpTreeView;
    procedure FormShow(Sender: TObject);
    procedure TabControlChange(Sender: TObject);
    procedure btnSearchClick(Sender: TObject);
    procedure edSearchKeyUp(Sender: TObject; var Key: Word;
      Shift: TShiftState);
  private

  public
  end;

var
  HelpSearch: THelpSearch;

implementation

{$R *.xfm}

procedure THelpSearch.FormShow(Sender: TObject);
begin
  btnSearch.Enabled := False;
  TabControlChange(Sender);
end;

procedure THelpSearch.TabControlChange(Sender: TObject);
begin
  btnSearch.Enabled := False;
  case TabControl.TabIndex of
  0:begin
      HelpTreeView.ShowContents;
      {$ifdef Linux}
      HelpKeyword := '7';
      {$else}
      HelpContext := 7;
      {$endif}
      edSearch.Enabled := False;
    end;
  1:begin
      HelpTreeView.ShowIndex;
      {$ifdef Linux}
      HelpKeyword := '4';
      {$else}
      HelpContext := 4;
      {$endif}
      edSearch.Enabled := True;
    end;
  2:begin
      btnSearch.Enabled := True;
      {$ifdef Linux}
      HelpKeyword := '5';
      {$else}
      HelpContext := 5;
      {$endif}
      edSearch.Enabled := True;
      HelpTreeView.Items.Clear;
    end;
  end;
end;

procedure THelpSearch.btnSearchClick(Sender: TObject);
begin
  HelpTreeView.SearchText(edSearch.Text);
end;

procedure THelpSearch.edSearchKeyUp(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  HelpTreeView.SearchIndex(edSearch.Text);
end;

end.
