{
_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/

        WASH_1D version 1.35

        Copyright(C) 2000-2004 Haruyuki FUJIMAKI and Mitsuhiro INOUE
        fujimaki@sakura.cc.tsukuba.ac.jp
        URL: http://www.geocities.jp/fujimaki691202/
        Distributed under the GPL

_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/
}

unit I_s_Information;

interface

uses
{$ifdef Linux}
  SysUtils, Classes, QGraphics, QControls, QForms, 
  QDialogs, QStdCtrls, QExtCtrls, QComCtrls, QButtons, Buttons, StdCtrls,
  Controls, ExtCtrls;
{$else}
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls, jpeg, ComCtrls, Spin, Buttons;
{$endif}

type
  TSoluteInverseInfo = class(TForm)
    Back: TButton;
    Execute: TButton;
    Next: TButton;
    Panel1: TPanel;
    Label1: TLabel;
    Edit1: TEdit;
    Select1: TBitBtn;
    Label2: TLabel;
    Edit2: TEdit;
    Select2: TBitBtn;
    Label3: TLabel;
    Edit3: TEdit;
    Label4: TLabel;
    procedure ExecuteClick(Sender: TObject);
    procedure BackClick(Sender: TObject);
    procedure NextClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure ShowParams;
    procedure Select1Click(Sender: TObject);
    procedure Select2Click(Sender: TObject);
  private
    procedure GetParameters;
    { Private  }
  public
    { Public  }
  end;

var
  SoluteInverseInfo: TSoluteInverseInfo;
  j: Shortint;

implementation

uses WASH1dMAIN, RC_Params;

{$R *.xfm}
//----------------------------------------------------------
procedure TSoluteInverseInfo.FormCreate(Sender: TObject);
begin
  dialogbox := -1;
  ShowParams;
end;
//----------------------------------------------------------
procedure TSoluteInverseInfo.ShowParams;
begin
  fl_c_profile := TrimLeft(fl_c_profile);
  fl_profile   := TrimLeft(fl_profile);
  Edit1.Text := Main.GetRelativeDirectory(BaseDir, fl_c_profile);
  Edit2.Text := Main.GetRelativeDirectory(BaseDir, fl_profile);
  case t_unit of
      1: Label4.caption := 'cm/s';
     60: Label4.caption := 'cm/min';
   3600: Label4.caption := 'cm/h';
  86400: Label4.caption := 'cm/d';
  end;
  Edit3.Text :=  FloatToStr( - ql_top);
end;
//----------------------------------------------------------
procedure TSoluteInverseInfo.ExecuteClick(Sender: TObject);
begin
  DialogBox := 0;
  Close;
end;
//------------------------------------------------------
procedure TSoluteInverseInfo.BackClick(Sender: TObject);
begin
  GoAhead  := False;
  DialogBox:= 1;
  Close;
end;
//------------------------------------------------------
procedure TSoluteInverseInfo.NextClick(Sender: TObject);
begin
  GoAhead   := True;
  DialogBox := 2;
  Close;
end;
//------------------------------------------------------
procedure TSoluteInverseInfo.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  GetParameters;
end;
//----------------------------------------------------------
procedure TSoluteInverseInfo.GetParameters;
begin
  ql_top := - StrToFloat(Edit3.Text);
  ic_type     := 4;
  s_ic_type   := 1;
  s_u_bc_type := 1;
  s_l_bc_type := 1;
  ic_type     := 4;
  u_bc_type   := 1;
  SoilName[1] := 'IPE';
  C_ini := 0;
  C_irg := 0;
  C_bot := 1;
end;

procedure TSoluteInverseInfo.Select1Click(Sender: TObject);
begin
  Main.SelectFile(fl_c_profile, Edit1);
  IPET_type := 11;
end;

procedure TSoluteInverseInfo.Select2Click(Sender: TObject);
begin
  Main.SelectFile(fl_profile, Edit2);
end;

end.
