{
_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/

        WASH_1D version 1.35

        Copyright(C) 2000-2004 Haruyuki FUJIMAKI and Mitsuhiro INOUE
        fujimaki@sakura.cc.tsukuba.ac.jp
        URL: http://www.geocities.jp/fujimaki691202/
        Distributed under the GPL

_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/
}

unit Numerical_Detail_of_Water_Flow;

interface

uses
{$ifdef Linux}
  SysUtils, Classes, QGraphics, QControls, QForms, 
  QDialogs, QStdCtrls, QExtCtrls, QComCtrls
  ;
{$else}  
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Spin, StdCtrls, ExtCtrls;
{$endif}

type
  TNumericalDetailOfWaterFlow = class(TForm)
    btnOK: TButton;
    btnCancel: TButton;
    RadioGroup1: TRadioGroup;
    Label1: TLabel;
    Edit1: TEdit;
    Label3: TLabel;
    SpinEdit1: TSpinEdit;
    SpinEdit2: TSpinEdit;
    Label4: TLabel;
    Edit3: TEdit;
    Label5: TLabel;
    Edit2: TEdit;
    RadioGroup2: TRadioGroup;
    CheckBox1: TCheckBox;
    Label6: TLabel;
    SpinEdit3: TSpinEdit;
    procedure RadioGroup1Click(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure btnOKClick(Sender: TObject);
    {$ifdef Linux}
    procedure SpinEdit1Changed(Sender: TObject; NewValue: Integer);
    {$else}
    procedure SpinEdit1Change(Sender: TObject);
    {$endif}
  private
    { Private  }
  public
    { Public  }
  end;

var
  NumericalDetailOfWaterFlow: TNumericalDetailOfWaterFlow;

implementation

uses Simulation, WASH1DMain;

{$R *.xfm}

procedure TNumericalDetailOfWaterFlow.RadioGroup1Click(Sender: TObject);
begin
  if RadioGroup1.ItemIndex < 2 then
  begin
    SpinEdit1.Enabled := False;
    SpinEdit2.Enabled := False;
    Edit2.Enabled := True;
    Edit3.Enabled := False;
  end
  else
  begin
    SpinEdit1.Enabled := True;
    SpinEdit2.Enabled := True;
    Edit2.Enabled := False;
    Edit3.Enabled := True;
  end;
end;

procedure TNumericalDetailOfWaterFlow.FormShow(Sender: TObject);
begin
  RadioGroup1.ItemIndex := IterationScheme ;
  RadioGroup2.ItemIndex := InterHyCon;
  RadioGroup1Click(Sender);
  Edit1.Text := FloatToStr(TargetMaxDiff_logP);
  SpinEdit1.Value := LowerTargetIteration;
  SpinEdit2.Value := UpperTargetIteration;
  SpinEdit3.Value := Angle;
  Edit2.Text := FloatToStr(TargetESRErrorW);
  Edit3.Text := FloatToStr(CriteriaForCeliasIteration);
  if ConsiderHysteresis = 1 then
    CheckBox1.Checked := True
  else
    CheckBox1.Checked := False;
end;

procedure TNumericalDetailOfWaterFlow.btnOKClick(Sender: TObject);
begin
  IterationScheme := RadioGroup1.ItemIndex;
  InterHyCon      := RadioGroup2.ItemIndex;
  TargetMaxDiff_logP := StrToFloat(Edit1.Text);
  LowerTargetIteration := SpinEdit1.Value;
  UpperTargetIteration := SpinEdit2.Value;
  Angle                := SpinEdit3.Value;
  TargetESRErrorW := StrToFloat(Edit2.Text);
  CriteriaForCeliasIteration := StrToFloat(Edit3.Text);
  if CheckBox1.Checked then
    ConsiderHysteresis := 1
  else
    ConsiderHysteresis := 0;
end;

{$ifdef Linux}
procedure TNumericalDetailOfWaterFlow.SpinEdit1Changed(Sender: TObject;
  NewValue: Integer);
begin
  if SpinEdit2.Value > 0 then
    SpinEdit1.Max := SpinEdit2.Value - 1;
  if SpinEdit1.Value > 0 then
    SpinEdit2.Min := SpinEdit1.Value + 1;
end;
{$else}
procedure TNumericalDetailOfWaterFlow.SpinEdit1Change(Sender: TObject);
begin
  SpinEdit1.MaxValue := SpinEdit2.Value - 1;
  SpinEdit2.MinValue := SpinEdit1.Value + 1;
end;
{$endif}

end.
