{
_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/

        WASH_1D version 1.36

        Copyright(C) 2000-2004 Haruyuki FUJIMAKI and Mitsuhiro INOUE
        fujimaki@sakura.cc.tsukuba.ac.jp
        URL: http://www.geocities.jp/fujimaki691202/
        Distributed under the GPL

_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/
}

unit P_Estimator;

interface

uses
{$ifdef Linux}
  SysUtils, Classes, QGraphics, QControls, QForms, 
  QDialogs, QExtCtrls, QMenus, Math, QStdCtrls, IniFiles;
{$else}
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ExtCtrls, Menus, Math, StdCtrls, IniFiles;
{$endif}
//  Const alamda_min = 0.00001;
  {$define LinearFlux}
//Const ma = 3;
const
  ChangeResistance = False;

type
  glndata  = array [1..4000] of Double;    // Notice for this number !!
  glma     = array [1..8] of Double;
  glmabyma = array [1..8,1..8] of Double;
  TParamEstimator = class(TForm)
    procedure FormCreate(Sender: TObject);
    procedure FormShow(Sender: TObject);
  private
    { Private  }
    procedure Marquadt(var a, ia: glma);
    procedure mrqmin(x, y, sig: glndata; var a, ia: glma; var covar, alpha_: glmabyma; var ObjFunc, fgauss, alamda: Double; ndata: Integer);
    procedure mrqcof(x, y, sig: glndata; var a, ia: glma; var alpha_: glmabyma; var beta_: array of Double; var ObjFunc: Double; ndata: Integer);
    procedure gaussj(var a, b: glmabyma; n, m: Integer);
    procedure RetentionFunction(a: glma; x: glndata);
    procedure GetSimulationResults(a: glma; x: glndata);
    procedure Report(a, ia : glma; alamda, ObjFunc: Double);
    procedure SayGoodBye; // 00/01/21
    procedure OutputResults(Param, IsFitted: glma);
    function FlexVariance(dumarray: array of double; IniValue, FinValue: Integer): Double;
  public
    { Public  }
  end;

var
  ParamEstimator: TParamEstimator;
  NumPerform, ma: Integer;
  beta_: array[0..20] of Double;
  a_min, a_max: array[1..8] of Double;
  ObjFunc_, RMSE: array[1..3] of Double;
  ndata, sn : Integer;
  ymod, ymod0: glndata;
  StrList1, StrList2, StrList3: TStringList;
  ParamName, FittedParamName: array[0..10] of String;
  Yavg: Double;
  GSM: Boolean;
  p_bot_limit, t_limit: Double;
  Msg: array[1..20] of String;

implementation

uses WASH1dMAIN, StringGrid, Simulation, RC_Params, K_Params, ST_params; //줬ɬ

{$R *.xfm}

procedure TParamEstimator.FormCreate(Sender: TObject);
var
  i, i2, i3, i4, NumDirectKdata, NumDirectKdata_parabolic: Integer;
  x1, x2, y1, y2, Campbell_b, zeta_, alpha_: Double;
  h1, h2, h_, q_, a_, z_, z1, z2, Grad: Double;
  SL1, SL2: TStringList;
  Param, IsFitted: glma;
  aBSM, bBSM, cBSM, fa, fc: Double;
  IniFile: TIniFile;
  S, ResourceFileName: String;

  procedure LoadOutflowData;
  var
    i: Integer;
  begin
    SL1 := TStringList.Create;
    SL2 := TStringList.Create;
    i2 := 1;
    try
      SL1.LoadFromFile(fl_outflow);
      for i := 1 to SL1.Count do
      begin
        SL2.CommaText := SL1[i-1];
        try
          if (StrToFloat(SL2[0]) < t_outflow[i2-1]) then
            Break;
          t_outflow[i2] := StrToFloat(SL2[0]);
          CumOutFlow[i2]:= sn * StrToFloat(SL2[1]);
          //if Tensio = 2 then
          //  CumOutFlow[i2] := z_lb / (z_lb + HC_filter) * CumOutFlow[i2];
          i2 := i2 + 1;
        except
        end;
      end;
    finally
      SL1.Free;
      SL2.Free;
    end;
    NumOutflowData := i2 - 1;
    Weight[1] := Sqrt(OutflowWeight / (NumOutflowData * FlexVariance(CumOutFlow, 1, NumOutflowData)));
    t_end := MaxValue(t_outflow); // [NumOutflowData];
  end;

  procedure LoadMeasuredCumulativeEvaporation;
  var i: Integer;
  begin
    SL1 := TStringList.Create;
    SL2 := TStringList.Create;
    i2 := 1;
    try
      SL1.LoadFromFile(fl_CumEvap);
      for i := 1 to SL1.Count do
      begin
        SL2.CommaText := SL1[i-1];
        try
          t_evaporation[i2] := StrToFloat(SL2[0]);
          CumEvaporation[i2]:= StrToFloat(SL2[1]);
          {
          if t_evaporation[i2] = 0 then
          begin;
            i2 := i2 - 1;
            break;
          end;
          }
          if UseOutFlowForK = 0 then
            t_evaporation[i2] := t_evaporation[i2] - t_outflow[NumOutflowData];
          i2 := i2 + 1;
        except
        end;
      end;
    finally
      SL1.Free;
      SL2.Free;
    end;
    NumEvapData := i2 - 1;
  end;

  procedure LoadTensiometerReadings;
  var i: Integer;
  begin
    SL1 := TStringList.Create;
    SL2 := TStringList.Create;
    i2 := 1;
    try
      SL1.LoadFromFile(fl_pressure);
      for i := 1 to SL1.Count do
      begin
        SL2.CommaText := SL1[i-1];
        try
          t_tensio[i2] := StrToFloat(SL2[0]);
          Ptens1[i2]   := StrToFloat(SL2[1]);
          if Tensio = 2 then
            Ptens2[i2] := StrToFloat(SL2[2]);
          if IPET_type = 6 then
          begin
            Pret[i2] := Ptens1[i2];
            Wret[i2] := StrToFloat(SL2[2]);
          end;
          i2 := i2 + 1;
        except
        end;
      end;
    finally
      SL1.Free;
      SL2.Free;
    end;
    NumTensioData := i2 - 1;
    Weight[2] := Sqrt(1 / (NumTensioData * FlexVariance(Ptens1, 1, NumTensioData)));
    t_end := MaxValue(t_tensio);
  end;

  function LoadMeasuredWaterContentProfile: Double;
  var i: Integer;
  begin
    Result := 0;
    SL1 := TStringList.Create;
    SL2 := TStringList.Create;
    i2 := 1;
    try
      SL1.LoadFromFile(fl_profile);
      for i := 1 to SL1.Count do
      begin
        SL2.CommaText := SL1[i-1];
        try
          zmb[i2] := StrToFloat(SL2[0]);
          Wm[i2]  := StrToFloat(SL2[1]);
          if zmb[i2] = 0 then
          begin;
            i2 := i2 - 1;
            break;
          end;
          zm[i2] := zmb[i2-1] + (zmb[i2] - zmb[i2-1]) / 2;
          Result := Result + Wm[i2] * (zmb[i2] - zmb[i2-1]);
          i2 := i2 + 1;
        except
        end;
      end;
    finally
      SL1.Free;
      SL2.Free;
    end;
    NumSampling := i2 - 1;
    Weight[3] := Sqrt(1 / (NumSampling * FlexVariance(Wm, 1, NumSampling)));    // "dum" is mean value of Wm[i] here.
  end;

  function LoadMeasuredConcentrationProfile: Double;
  var i: Integer;
  begin
    Result := 0;
    SL1 := TStringList.Create;
    SL2 := TStringList.Create;
    i2 := 1;
    try
      SL1.LoadFromFile(fl_c_profile);
      for i := 1 to SL1.Count do
      begin
        SL2.CommaText := SL1[i-1];
        try
          zmb[i2] := StrToFloat(SL2[0]);
          Cm[i2]  := StrToFloat(SL2[1]);
          if zmb[i2] = 0 then begin; i2 := i2 - 1; break; end;
          zms[i2] := zmb[i2-1] + (zmb[i2] - zmb[i2-1]) / 2;
          Result := Result + Cm[i2] * (zmb[i2] - zmb[i2-1]);
          i2 := i2 + 1;
        except
        end;
      end;
    finally
      SL1.Free;
      SL2.Free;
    end;
    NumSampling := i2 - 1;
    Weight[3] := Sqrt(1 / (NumSampling * FlexVariance(Cm, 1, NumSampling)));
  end;

  procedure GetHydraulicConductivityDirectly_with_the_LinearMethod(TheOutflow: Double);
  var
    i: Integer;
    t_prev, t_next: Double;
  begin
    i3 := 0;
    i4 := 0;
    z_ := 0.5 * (z1 + z2);
    repeat
      i3 := i3 + 1
    until CumOutflow[i3+1] >= TheOutflow;
    if i3 >= 3 then
      q_ := (CumOutFlow[i3-2] - CumOutFlow[i3]) / (t_outflow[i3-2] - t_outflow[i3]) * z_ / z_lb / t_unit;
    repeat
      i4 := i4 + 1
    until t_tensio[i4] >= t_outflow[i3];
    h1 := Ptens1[i4-1];
    if Tensio > 1 then
    begin
      h2 := Ptens2[i4-1];
      a_ := (z1 - z2 + h2 - h1) / (z2 * z2 - z1 * z1);
    end
    else
    begin
      i := 0;
      repeat
        i := i + 1;
      until t_p_bot[i] >= t_tensio[i4-1];
      t_prev := t_p_bot[i-1];
      t_next := t_p_bot[i];
      if t_next > t_prev then
        P[n+1] := (Pbot[i-1] * ( t_next - time_ ) + Pbot[i]* ( time_ - t_prev )) / ( t_next - t_prev );
      h2 := P[n+1] + q_ / HC_filter;
    end;
    if h2 < h1 - 4 then
    begin
      i2 := i2 + 1;
      t_direct[i2] := t_outflow[i3-1];
      {$ifdef LinearFlux}
      Grad := (h2 - h1) / (z2 - z1);
      {$else}
      Grad := 2 * a_ * z_ + 1;
      {$endif}
      K_direct[i2] := - q_ / (Grad - 1);
      h_ := a_ * (z_ * z_ - z1 * z1) + z_ + h1 - z1;
      with Soil do
        W_direct[i2] := Water_Content(h_, Tref[1], Wsat[1], zeta[1], Wr[1], 1, True);
    end;
  end;

  procedure GetHydraulicConductivityDirectly_with_the_ParabolicMethod;
  var
    Wstore: array [1..1000] of Double;
    i: Integer;
    qbot_ : Double;
    function GetStoredWater(h1, h2, Boundary: Double): Double;
    var
      dz, sigma1, sigma2: Double;
      i, Division: Integer;
      function f(z: Double): Double;
      begin
        h_ := a_ * (z * z - z1 * z1) + z_ + h1 - z1;
        with Soil do
          Result := Water_Content(h_, Tref[1], Wsat[1], zeta[1], Wr[1], 1, True);
      end;
    begin
      a_ := (z1 - z2 + h2 - h1) / (z2 * z2 - z1 * z1);
      Division := 10;
      dz := z_ / Division;
      sigma1 := 0;
      for i := 2 to (Division div 2) do
        sigma1 := sigma1 + f(0 + (2 * i - 2) * dz);
      sigma2 := 0;
      for i := 1 to (Division div 2) do
        sigma2 := sigma2 + f(0 + (2 * i - 1) * dz);
      Result := dz / 3 * (f(0) + 2 * sigma1 + 4 * sigma2 + f(z_));
    end;
  begin
    for i := 1 to NumTensioData do
      Wstore[i] := 0;
    i2 := 0;
    i3 := 0;
    z_ := 0.5 * (z1 + z2);
    for i := 1 to NumTensioData do
    begin
      if Ptens2[i] < Ptens1[i] - 4 then
      begin
        i2 := i2 + 1;
        //-- check of flux --//
        Wstore[i-1] := GetStoredWater(Ptens1[i-1], Ptens2[i-1], z_lb);
        Wstore[i+1] := GetStoredWater(Ptens1[i+1], Ptens2[i+1], z_lb);
        q_ := (Wstore[i-1] - Wstore[i+1]) / (t_tensio[i+1] - t_tensio[i-1]) / t_unit;
        repeat
          i3 := i3 + 1
        until t_outflow[i3] >= t_tensio[i];
        qbot_ := (CumOutFlow[i3-1] - CumOutFlow[i3+1]) / (t_outflow[i3-1] - t_outflow[i3+1]) / t_unit;
        //-------------------//
        if (q_ > 0) and (qbot_ > 0) and (Abs(ln(q_) - ln(qbot_)) < 0.4) then
        begin
          Wstore[i-1] := GetStoredWater(Ptens1[i-1], Ptens2[i-1], z_);
          Wstore[i+1] := GetStoredWater(Ptens1[i+1], Ptens2[i+1], z_);
          t_direct_p[i2] := 0.5 * (t_tensio[i+1] + t_tensio[i-1]);
          q_ := (Wstore[i-1] - Wstore[i+1]) / (t_tensio[i+1] - t_tensio[i-1]) / t_unit;
          h1 := Ptens1[i];
          h2 := Ptens2[i];
          a_ := (z1 - z2 + h2 - h1) / (z2 * z2 - z1 * z1);
          Grad := 2 * a_ * z_ + 1;
          K_direct_p[i2] := - q_ / (Grad - 1);
          h_ := a_ * (z_ * z_ - z1 * z1) + z_ + h1 - z1;
          with Soil do
            W_direct_p[i2] := Water_Content(h_, Tref[1], Wsat[1], zeta[1], Wr[1], 1, True);
        end;
      end;
    end;
    NumDirectKdata_parabolic := i2;
  end;

  function f(x: Double): Double;
  var d, m: Double;
  begin
    m := 1 - 1 / x;
    d :=(Wret[i2+2] - zeta_) / (y1 - zeta_ * (1 - Sqr(ln(- x1 + 1) / 16.118)));
    alpha_:= - 1 / x1 * Power(Power(d, 1 / m) - 1, 1 / x);
    d := (Wret[i2+2] - zeta_) / Power(1 + Power(- alpha_* x2, x), m)  + zeta_ * (1 - Sqr(ln(- x2 + 1) / 16.118));
    Result := y2 - d;
  end;

begin
  Hide;
  Msg[1] := '>>>>>>  Trajectory and Results of Inverse Parameter Estimation <<<<<<<';
  Msg[2] := 'sine of pressure head at the bottom is opposite.';
  Msg[3] := 'Did you use unit of [cm] for cumulative outflow/inflow?';
  Msg[4] := 'Please have a coffee break! The inverse parameter estimation may take several minutes.';
  Msg[5] := '---  Standard Deviation of the Parameters ---';
  Msg[6] := 'objective function, OF = ';
  Msg[7] := 'contribution of 1st term to OF';
  Msg[8] := 'contribution of 2nd term to OF';
  Msg[9] := 'contribution of 3rd term to OF';
  S := Self.Name;
  ResourceFileName := ChangeFileExt(Application.ExeName, '.lng');
  if FileExists(ResourceFileName) then
  begin
    IniFile := TIniFile.Create(ResourceFileName);
    with IniFile do
      try
        for i := 1 to 9 do
          Msg[i] := StringReplace(ReadString(S, 'Msg' + IntToStr(i), ''), '<br>', #13#10, [rfReplaceAll, rfIgnoreCase]);
      finally
        Free;
      end;
  end;
  //ShowMode := 1;
  StopCalc := 0; AllowRecord := 0;
  NumAddHyConData := 0;
  NumDirectKdata := 0;
  p_bot_limit := -160;
  t_limit := 0;
  GSM := False;
 //-----------------------------
  if (IPET_type = 3) or (IPET_type = 5) then
    sn := -1
  else
    sn := 1;
  StrList1 := TStringList.Create;
  StrList2 := TStringList.Create;
  if not ChangeResistance then
    parlb_a := 0;
  StrList1.Add(Msg[1]);
  for i := 1 to 8 do
  begin
    a_min[i] := -10000000000;
    a_max[i] :=  10000000000;
  end;
  if rec = 1 then
  begin
    rec := 0;
    rec0 := 1;
  end
  else
    rec0 := 0;
  if water = 1 then
  begin
    //================= Data Loading Section ===================//
    case IPET_Type of
    1,2,3:begin
            if ExtractFileName(fl_p_bot) <> '' then
            begin
              SL1 := TStringList.Create;
              SL2 := TStringList.Create;
              i2 := 0;
              try
                SL1.LoadFromFile(fl_p_bot);
                for i := 1 to SL1.Count do
                begin
                  SL2.CommaText := SL1[i-1];
                  try
                    t_p_bot[i2] := StrToFloat(SL2[0]);
                    Pbot[i2]    := StrToFloat(SL2[1]);
                    if (IPET_Type = 3) and (t_limit = 0) and (Pbot[i2] > p_bot_limit) then
                      t_limit := t_p_bot[i2];
                    i2 := i2 + 1;
                  except
                  end;
                end;
              finally
                SL1.Free;
                SL2.Free;
              end;
              if t_limit = 0 then
                t_limit := 100000000000;
              NumPbotData := i2 - 1;
              if (Pbot[i2-1] > 10) and ((IPET_type = 2) or (IPET_type = 2)) then
              begin
                ShowMessage(Msg[2]);
                Application.Terminate;
              end;
            end;
          //----------------------------------------------------------
          if ExtractFileName(fl_outflow) <> '' then
            LoadOutflowData;
          NumOutflowData_for_DP := NumOutflowData;
          if ((IPET_type = 2) or (IPET_type = 2)) then
          begin
            if Abs(CumOutFlow[i2-1]) > 10 then
            begin
              {$ifdef Linux}
              if Application.MessageBox(PChar(Msg[3]),'Please confirm.',
                 [smbYes, smbNo]) = smbNo then
              {$else}
              if Application.MessageBox(PChar(Msg[3]),'Please confirm.',
                 mb_yesno or mb_iconquestion) = id_no then
              {$endif}
              begin
                ShowMessage('Please correct unit of the datafile and retry.');
                Application.Terminate;
              end;
            end;
          end;
        end;
    4  :begin
          NumPbotData := 0;
          NumOutflowData := 0;
        end;
    5  :begin
          NumPbotData := 0;
          LoadOutflowData;
       //   NumOutflowData_for_DP := NumOutflowData;
        end;
    6  :begin
          NumPbotData := 0;
          LoadOutflowData;
          NumOutflowData_for_DP := NumOutflowData;
        end;
    end;
    //----------------------------------------------------------
    if (IPET_type = 1) or (AddRetData = 1) then
    begin
      SL1 := TStringList.Create;
      SL2 := TStringList.Create;
      i2 := 1;
      try
        SL1.LoadFromFile(fl_retention);
        for i := 1 to SL1.Count do
        begin
          SL2.CommaText := SL1[i-1];
          try
            Wretm[i2] := StrToFloat(SL2[0]);
            Pretm[i2] := StrToFloat(SL2[1]);
            if Wretm[i2] = 0 then
            begin
              i2 := i2 - 1;
              Break;
            end;
            i2 := i2 + 1;
          except
          end;
        end;
      finally
        SL1.Free;
        SL2.Free;
      end;
      NumAddRetData := i2 - 1;
    end
    else
      NumAddRetData := 0;
    //----------------------------------------------------------
    case IPET_type of
    1:begin
        LoadMeasuredCumulativeEvaporation;
        t_end := MaxValue(t_evaporation); // [NumOutflowData];
        //dum := 0;
        //for i :=1 to NumEvapData do
        //  dum := dum + CumEvaporation[i] / NumEvapData;
        Weight[2] := Sqrt(1 / (NumEvapData * FlexVariance(CumEvaporation, 1, NumEvapData)));    // "dum" is mean value of CumEvaporation[i] here.
        if ra = 0 then
        begin
          i := 1;
          repeat
            i := i + 1;
          until (i > 2) and ((t_evaporation[i] - t_evaporation[1]) * t_unit > 3600);
          i := i - 1;
          dum := (CumEvaporation[i] - CumEvaporation[1]) / ( t_evaporation[i] - t_evaporation[1]) / t_unit; // "dum" is evaporation rate(cm/s) here.
          ra := exp(6 - 4976 / Tair) * (1 - RHair) / dum;
        end;
        W_end := LoadMeasuredWaterContentProfile / z_lb;
        //ra := 0.45;
        //ShowMessage('Aerodynamic resistance is set at ' + FormatFloat('0.000', ra));
      //----------------------------------------------------------
        //dum := 0;
        //for i :=1 to NumSampling do
        //  dum := dum + Wm[i] / NumSampling;
        if UseAdditionalHyConData = 1 then
        begin
          SL1 := TStringList.Create;
          SL2 := TStringList.Create;
          i2 := 1;
          try
            SL1.LoadFromFile(fl_HyConData);
            for i := 1 to SL1.Count do
              begin
              SL2.CommaText := SL1[i-1];
              try
                Wkm[i2] := StrToFloat(SL2[0]);
                LogKm[i2] := Log10(StrToFloat(SL2[1]));
                i2 := i2 + 1;
              except
              end;
              end;
          finally
            SL1.Free;
            SL2.Free;
          end;
          NumAddHyConData := i2 - 1;
          Weight[4] := Sqrt(1 / (NumAddHyConData * FlexVariance(LogKm, 1, NumAddHyConData)));
        end;
      end;
    2:begin
        CumEvaporation[0] := 0;
        if Tensio >= 1 then
          LoadTensiometerReadings;
        if independent <> 1 then
        begin
          i := NumAddRetData;
          if Tensio >= 1 then
          begin
            i := i + 1;
            Pretm[i] := Ptens1[NumTensioData];
            Wretm[i] := W_end;
          end;
          i := i + 1;
          Pretm[i] := p_top_ini + z_lb / 2;
          if Pretm[i] > 0 then Pretm[i] := -1.1;
          Wretm[i] := W_end + CumOutFlow[NumOutflowData]/ z_lb;
          Weight[3] := Sqrt(1 / (i * FlexVariance(Wretm, 1, i)));
        end;
      end;
    4:begin
        LoadMeasuredCumulativeEvaporation;
        LoadTensiometerReadings;
      end;
    5:begin
        if fl_front <> '' then
        begin
          SL1 := TStringList.Create;
          SL2 := TStringList.Create;
          i2 := 1;
          try
            SL1.LoadFromFile(fl_front);
            for i := 1 to SL1.Count do
            begin
              SL2.CommaText := SL1[i-1];
              try
                t_front[i2] := StrToFloat(SL2[0]);
                MeasuredFront[i2]:= StrToFloat(SL2[1]);
                i2 := i2 + 1;
              except
              end;
            end;
          finally
            SL1.Free;
            SL2.Free;
          end;
          NumFrontData := i2 - 1;
          Weight[2] := Sqrt(1 / (NumFrontData * FlexVariance(MeasuredFront, 1, NumFrontData)));    // "dum" is mean value of Wm[i] here.
        end
        else
          NumFrontData := 0;
        NumSampling := 0;
        if fl_profile <> '' then
          LoadMeasuredWaterContentProfile;
      end;
    6:begin
        LoadTensiometerReadings;
      end;
    end;
    //============  Independent Determination of the Retention Function =====================//
    Soil.ShowMode := 1;
    if independent = 1 then
    begin
      if Tensio = 0 then
      begin
        i2 := 0;
        if NumPbotData > 0 then
        begin
          for i := 1 to NumPbotData do
          begin
            if t_p_bot[i+1] <> t_p_bot[i] then
              if (Abs(Pbot[i+1] - Pbot[i]) / (t_p_bot[i+1] - t_p_bot[i])/ t_unit * 60 > -1 ) or (sn * Pbot[i+1] > sn * 1.2 * Pbot[i]) then
                Continue;
            i2 := i2 + 1;
            Pret[i2] := Pbot[i] - z_lb / 2;
            i3 := 0;
            repeat
              i3 := i3 + 1
            until t_outflow[i3+1] >= t_p_bot[i];
            if IPET_type <> 3 then
              Wret[i2] := W_end + (CumEvaporation[NumEvapData] + CumOutFlow[NumOutflowData] - CumOutFlow[i3]) / z_lb
            else
              Wret[i2] := W_ini - (CumOutFlow[i3] + W_slice * z_slice ) / (z_lb - z_slice);
          end;
          Pret[i2+1] := Pbot[NumPbotData] - z_lb / 2;
          case IPET_type of
          1:begin
              Wret[i2+1] := W_end + CumEvaporation[NumEvapData] / z_lb;
              if UseOutFlowForK = 0 then
                W_ini := Wret[i2+1];
            end;
          2,4:Wret[i2+1] := W_end;
          3:  Wret[i2+1] := W_ini - (CumOutFlow[NumOutflowData] + W_slice * z_slice ) / (z_lb - z_slice);
          end;
          if (IPET_type <> 3) and (NumOutflowData > 0) then
          begin
            Pret[i2+2] := p_top_ini + z_lb / 2;
            Wret[i2+2] := W_end + (CumEvaporation[NumEvapData] + CumOutFlow[NumOutflowData]) / z_lb;
            NumRetData := i2 + 2;
          end
          else
            NumRetData := i2 + 1;
        end
        else
        begin
          NumRetData := 0;
          W_ini := W_end + CumEvaporation[NumEvapData] / z_lb;
        end;
        if (Soil.RF[1] = 1) and (IPET_Type = 1) and (NumOutflowData > 0) then
        begin
          //------- Estimation of initial zeta ------//
         // theta_r := Wretm[1] / (1 - Sqr(ln(-Pretm[1] + 1) / Soil.LogOfLlambda[1]));
          zeta_ := Wretm[NumAddRetData];
          //------- Estimation of tentative "lambda" and air entry value in Brooks and Corey equation -------//
          i := 1;
          repeat
            i := i + 1;
          until Pret[i] < - 100;
          {
        //  ShowMessage(FloatToStr(Wret[i]));
          y1 := ln((Wret[i]   - dum) / (Wret[i2+2] + 0.01 - dum));
          y2 := ln((Wret[i-1] - dum) / (Wret[i2+2] + 0.01 - dum));
          x1 := ln(-Pret[i]);
          x2 := ln(-Pret[i-1]);
          BClambda := - (y2 - y1) / (x2 - x1);
          BCAEV := exp(x1 + y1/ BClambda);
        //  dum := 1 / BClambda + 1;
          ShowMessage('Recommended initial values are: theta_sat =' + FormatFloat('0.00', Wret[i2+2] + 0.01) + ', zeta = ' + FormatFloat('0.00', dum) + ', n = ' + FormatFloat('0.00', 1 + BClambda) + ', alpha = ' + FormatFloat('0.000', 1 / BCAEV));
          }
          //------- Estimation of optimal initial parameter values in van Genuchten equation -------//
          y1 := Wret[i]; //(Wret[i]   - theta_r) / (Wret[i2+2] + 0.01 - theta_r);
          y2 := Wret[i-1]; //(Wret[i-1] - theta_r) / (Wret[i2+2] + 0.01 - theta_r);
          x1 := Pret[i];
          x2 := Pret[i-1];
          {
          if y1 > 0.8 then
          begin
            y1 := (Wret[i] - theta_r) / (Wret[i] + 0.01 - theta_r);
            y2 := (Wretm[NumAddRetData] - theta_r) / (Wret[i] + 0.01 - theta_r);
            x1 := Pret[i];
            x2 := Pretm[NumAddRetData];
          end;
          }
          aBSM := 1.05;  //Bi Section Mehod
          bBSM := 20;
          cBSM := 0; // to avoid warning
          //dum := - 1 / x1 * Power(Power(1 / y1, 1 / (1 - 1 / aBSM)) - 1 , 1 / aBSM);
          //fa := y2 - 1 / Power(1 + Power(- dum * x2, aBSM), 1 - 1 / aBSM);
          fa := f(aBSM);
          for i := 1 to Trunc(ln(Abs(bBSM - aBSM) / 0.00001) / ln(2)) do
          begin
            cBSM := (aBSM + bBSM) / 2;
           // dum := - 1 / x1 * Power(Power(1 / y1, 1 / (1 - 1 / cBSM)) - 1 , 1 / cBSM);
           // fc :=  y2 - 1 / Power(1 + Power(- dum * x2, cBSM), 1 - 1 / cBSM);
            fc := f(cBSM);
            if fa * fc < 0 then
              bBSM := cBSM
            else
            begin
              aBSM := cBSM;
              fa := fc;
            end;
          end;
          ShowMessage('Recommended initial values are: ' + #13#10 + 'theta_sat =' + FormatFloat('0.00', Wret[i2+2] + 0.01) + ', zeta = ' + FormatFloat('0.00', zeta_) + ', n = ' + FormatFloat('0.00', cBSM) + ', alpha = ' + FormatFloat('0.#######', alpha_));
         //------- Estimation of tentative "lambda" and air entry value in Campbell equation -------//
          i := 1;
          repeat
            i := i + 1;
          until (Wret[i] < Wret[i2+2] / 2) or (i = i2);
          if i = i2 then
          begin
            x1 := ln(Wret[i2 + 1]        / Wret[i2+2]);
            x2 := ln(Wretm[NumAddRetData]/ Wret[i2+2]);
            y1 := ln(-Pret[i2+1]);
            y2 := ln(-Pretm[NumAddRetData]);
            {
            y1 := ln(Wret[i2 + 1]        / (Wret[i2+2] + 0.01));
            y2 := ln(Wretm[NumAddRetData]/ (Wret[i2+2] + 0.01));
            x1 := ln(-Pret[i2+1]);
            x2 := ln(-Pretm[NumAddRetData]);
            }
          end
          else
          begin
           // y1 := ln(Wret[i]  / (Wret[i2+2] + 0.01));
           // y2 := ln(Wret[i-1]/ (Wret[i2+2] + 0.01));
            x1 := ln(Wret[i]  / Wret[i2+2]);
            x2 := ln(Wret[i-1]/ Wret[i2+2]);
            y1 := ln(-Pret[i]);
            y2 := ln(-Pret[i-1]);
          end;
          Campbell_b := - (y2 - y1) / (x2 - x1);
          if Soil.KF[1] = 1 then
            ShowMessage('Recommended c value is ' + FormatFloat('0.0', 1.5 * Campbell_b + 10 / 3) + ' or ' + FormatFloat('0.0', 2 * Campbell_b + 2.5));
          //-------------------------------//
        end;
      end
      else
      begin
        i2 := 0; i4 := 0;
        case IPET_type of
        2:begin
            for i := 0 to NumPbotData do
              if Pbot[i] = Pbot[i+1] then
              begin
                i2 := i2 + 1;
                repeat i4 := i4 + 1
                until t_tensio[i4] >= t_p_bot[i];
                Pret[i2] := Ptens1[i4-1];
                i3 := 0;
                repeat i3 := i3 + 1
                until t_outflow[i3+1] >= t_p_bot[i];
                Wret[i2] := W_end + (CumOutFlow[NumOutflowData] - CumOutFlow[i3-1]) / z_lb;
              end;
            Pret[i2+1] := Ptens1[NumTensioData];
            Wret[i2+1] := W_end;
            NumRetData := i2 + 1;
          end;
        4:begin
            for i := 1 to NumEvapData do
            begin
              if Tensio = 1 then
              begin
                repeat i2 := i2 + 1
                until t_tensio[i2] > t_evaporation[i];
                Pret[i] := Ptens1[i2-1];
              end;
              Wret[i]:= W_end + (CumEvaporation[NumEvapData] - CumEvaporation[i]) / z_lb;
            end;
            NumRetData := NumEvapData;
          end;
        6:begin
            NumRetData := NumTensioData;
          end;
        end;
      end;
      //----------------------------------------------------------
      if IPET_type <> 5 then
      begin
        FitMode := 1;
        StrList1.Add('');
        StrList1.Add('=====  Fitting of Water Retention Curve =====');
        ParamName[1]   := '    Wsat  ';
        if Soil.RF[1] = 1 then
        begin
          ParamName[2] := '   zeta   ';
          ParamName[3] := '   alpha  ';
          ParamName[4] := '    n     ';
          ParamName[5] := '    m     ';
          ParamName[6] := '  Llambda   ';
        end
        else
        begin
          ParamName[2] := '    sp    ';
          ParamName[3] := '  alpha1  ';
          ParamName[4] := '    np1   ';
          ParamName[5] := '  alpha2  ';
          ParamName[6] := '    np2   ';
        end;
      //------------------//
        Marquadt(Param, IsFitted);
      //------------------//
        OutputResults(Param, IsFitted);
        StrList3 := TStringList.Create;
        try
          with StrList3 do
          begin
            Add('Water retention data estimated from the experiment');
            Add('   VWC    presure head(cm)');
            for i := 1 to NumRetData do
            begin
              if Pret[i] < 0 then dum := Pret[i] else dum := -1.1;
              Add('    ' + Simulator.SetLengthRJ(FormatFloat('0.0000', Wret[i]) + '    ' + FormatFloat('########.0',dum), 8));
            end;
            SaveToFile(CaseName + '_RetData.out');
          end;
        finally
          StrList3.Free;
        end;
      //  Soil := TSoil.Create(self);
      //  Main.SendDataToSoil;
        Soil.num_ret_data := NumRetData;
        Soil.num_add_ret_data := NumAddRetData;
        Soil.ShowModal;
      //  Soil.Release;
        dialogbox := Soil.dialogbox;
        if dialogbox = -1 then
          Exit;
        NumDirectKdata := NumRetData;
      end;
    //==========================  Estimating Hydraulic Conductivity =======================//
      //---------  Direct Method for MSO --------------
      if (IPET_type = 2) and (Tensio >= 1) and (independent = 1) then
      begin
        i2 := 0;
        if Tensio > 1 then
        begin
          z1 := z_obs[1];
          z2 := z_obs[2];
        end
        else
        begin
          z1 := 0; //Forrowing Eching et al., 1994  z_obs[1];
          z2 := z_lb;
        end;
        for i := 1 to NumRetData - 1 do
        begin
          dum := CumOutFlow[NumOutflowData] - ((Wret[i] - 0.5 * (Wret[i] - Wret[i+1])) - W_end) * z_lb;
          GetHydraulicConductivityDirectly_with_the_LinearMethod(dum);
        end;
        NumDirectKdata := i2;
        if Tensio > 1 then
          GetHydraulicConductivityDirectly_with_the_ParabolicMethod;
      end;
      StrList3 := TStringList.Create;
      try
        with StrList3 do
        begin
          if (IPET_type = 4) or ((IPET_type = 2) and (Tensio >= 1) and (independent = 1)) then
          begin
            Clear;
            Add('Directly estimated hydraulic conductivities with the Linear Method');
            Add('   VWC    K(cm/s)       log10(K)       time');
            for i := 1 to NumDirectKdata do
              if K_direct[i] > 0 then
                Add('    ' + Simulator.SetLengthRJ(FormatFloat('0.0000', W_direct[i]) + '   ' + FormatFloat('0.000000000', K_direct[i]) + '    ' + FormatFloat('##0.000', log10(Abs(K_direct[i]))), 8) + '   ' + FormatFloat('########.000', t_direct[i]));
            SaveToFile(CaseName + '_direct_K.out');
            Clear;
            Add('Directly estimated hydraulic conductivities with the Parabolic Interporation Method');
            Add('   VWC    K(cm/s)       log10(K)       time');
            for i := 1 to NumDirectKdata_parabolic do
              if K_direct_p[i] > 0 then
                Add('    ' + Simulator.SetLengthRJ(FormatFloat('0.0000', W_direct_p[i]) + '   ' + FormatFloat('0.000000000', K_direct_p[i]) + '    ' + FormatFloat('##0.000', log10(Abs(K_direct_p[i]))), 8) + '   ' + FormatFloat('########.000', t_direct_p[i]));
            SaveToFile(CaseName + '_direct_K_parabolic.out');
          end;
        end;
      finally
        StrList3.Free;
      end;
      //---------------------------------------------------------
      Application.ProcessMessages;
      StrList2.Clear;
      StrList1.Add('');
      if (IPET_type = 1) and (OutflowWeight<> 1) then
        StrList1.Add('Weight of outflow in the objective function is corrected as' + FloatToStr(OutflowWeight) + 'times');
      StrList1.Add('=====  Parameter Estimation of Hydraulic Conductivity =====');
      ParamName[1] := 'log10(Ksat)';
      ParamName[2] := '    ak    ';
      ParamName[3] := '    bk    ';
      ParamName[4] := '    ck    ';
      ParamName[5] := '';
      ParamName[6] := '';
    end
    else // independent
    begin
      ParamName[1] := 'log10(Ksat)';
      ParamName[2] := '    ak    ';
      ParamName[3] := '   Wsat   ';
      ParamName[4] := '  alpha1  ';
      ParamName[5] := '    n1    ';
      ParamName[6] := '    Wr    ';
      ParamName[7] := '  parlb_a  ';
      ParamName[8] := '  parlb_b  ';
    end;
    if (IPET_type = 2) and (UseOutFlowForK = 0) and (l_bc_type = 4) and (Tensio = 2) then
    begin
      Tensio := 1;
      z_lb0 := z_lb;
      z_lb := z_obs[2];
      NumObs := 1;
      for i := 1 to NumTensioData do
      begin
        t_p_bot[i] := t_tensio[i];
        Pbot[i]    := Ptens2[i];
        HC_filter := 10000;
      end;
    end;
    if StopCalc = 1 then
    begin
      SayGoodBye;
      Exit; //or (dialogbox = -1)
    end;
    ShowMessage(Msg[4]);
    NumPerform := 0;
    FitMode := 2;
  //------------------//
    Marquadt(Param, IsFitted);
  //------------------//
    if StopCalc = 1 then
    begin
      SayGoodBye;
      Exit;
    end;
    OutputResults(Param, IsFitted);
    SayGoodBye;
    if rec0 = 1 then
      rec := 1;
    AllowRecord := 1;
   //----------------------//
    Simulator.Simulate;
   //----------------------//
    if (independent <> 1) and (IPET_type <> 5) then
    begin
    //  Soil := TSoil.Create(self);
      Soil.num_ret_data := NumRetData;
      Soil.num_add_ret_data := NumAddRetData;
      Soil.ShowModal;
    //  Soil.Release;
    end;
    //Main.SendDataToSoil;
    Kparams := TKparams.Create(Self);
    Main.SendDataToKparams;
    Kparams.FitMode := 2;
    Kparams.ShowMode := 1;
    Kparams.SetProperty_of_HyConCurve(1, Soil.CaseName + '_K_Curve', False);
    Kparams.ShowModal;
    Main.RetrieveDataFromKparams;
    KParams.Release;
  end
  else  //solute = 1
  begin
    LoadMeasuredConcentrationProfile;
    NumPerform := 0;
    FitMode := 3;
    AllowRecord := 0;
  //------------------//
    Marquadt(Param, IsFitted);
  //------------------//
    if StopCalc = 1 then
    begin
      SayGoodBye;
      Exit;
    end;
 //   OutputResults(Param, IsFitted);
    SayGoodBye;
    if rec0 = 1 then
      rec := 1;
    AllowRecord := 1;
   //----------------------//
    Simulator.Simulate;
   //----------------------//
    STparams := TSTparams.Create(Self);
   // STparams.ShowMode := 1;
    STparams.ShowModal;
    STparams.Release;
  end;
  Soil.ShowMode := 0;
  if Water = 1 then
    Kparams.ShowMode := 0;
  FitMode := 0;
end;

procedure TParamEstimator.SayGoodBye;
begin
  if StopCalc = 1 then
  {$ifdef Linux}
    if Application.MessageBox('Would you like to save current results?', '', [smbYes, smbNo]) = smbNo then
  {$else}
    if Application.MessageBox('Would you like to save current results?', '', mb_yesno or mb_iconquestion) = id_no then
  {$endif}
      Exit;
  StrList1.SaveToFile(CaseName + '_IPE.out');
  StrList1.Free;
  StrList2.Free;
  AllowRecord := 1;
  Simulator.OutputToFile;
end;

///////////////////   Optimization Argorithsm of Marquardt  /////////////////////////
procedure TParamEstimator.Marquadt(var a, ia: glma);
var
  i, itst, j: Integer;
  alamda, ObjFunc, OFbase, fgauss, SigSq: Double;
  x0, x1, x2, x3, y0, y1, y2, y3, step: Double;
  x, y, sig: glndata;
  covar, alpha_: glmabyma;
  procedure SetSigma(StartPos, ToEnd: Integer);
  var i: Integer;
  begin
    if ToEnd <> StartPos then
    begin
      Yavg := 0;
      for i := StartPos + 1 to ToEnd do
        Yavg := Yavg + y[i];
      Yavg := Yavg / (ToEnd - StartPos);
      SigSq := 0;
      for i := StartPos + 1 to ToEnd do
        SigSq := SigSq + Sqr(y[i] - Yavg);
      SigSq := Sqrt(SigSq);
      if StartPos + 1 = ToEnd then
        SigSq := 1;
      for i := StartPos + 1 to ToEnd do
        sig[i] := SigSq;
    end;
  end;

  function f(x_: Double): Double;
  begin
    if (KsatFix = 1) and (akFix = 1) and (bkFix = 1) then
      a[4] := x_
    else
      a[1] := x_;
    mrqcof(x, y, sig, a, ia, alpha_, beta_, ObjFunc, ndata);
    Result := ObjFunc;
  end;
begin
  for i := 1 to 8 do
    ia[i] := 1;
  with Soil do
    case FitMode of
    1:begin
        a[1] := Wsat[1];
        if RF[1] = 1 then
        begin
          ma   := 6;
          a[2] := zeta[1];// a_max[2] := 0.3; a_min[2] := 0;
          a[3] := alpha[sn*1];
          a[4] := np[sn*1];
          a[5] := mp[sn*1];
          a[6] := Llambda[1];
          if ZetaFix = 1 then
            ia[2] := 0;
          if Linked_m = 1 then
            ia[5] := 0;
          if LlambdaFix  = 1 then
            ia[6] := 0;
        end
        else
        begin
          ma   := 7;
          a[2] := sp[1];
          a[3] := alpha1[sn*1];
          a[4] := np1[sn*1];
          a[5] := alpha2[1];
          a[6] := np2[1];
          a[7] := Wr[1];
          if spFix = 1 then
          begin
            ia[2] := 0;
            ia[5] := 0;
            ia[6] := 0;
          end;
          if WrFix = 1 then ia[7] := 0;
        end;
        if WsatFix = 1 then ia[1] := 0;
        ndata := NumRetData + NumAddRetData;
        for i := 1 to NumRetData do
        begin
          x[i] := Pret[i];
          y[i] := Wret[i];
        end;
        if (IPET_type = 1) or (AddRetData = 1) then
        begin
          j := 0;
          for i := NumRetData + 1 to ndata do
          begin
            j := j + 1;
            x[i] := Pretm[j];
            y[i] := Wretm[j];
          end;
        end;
        SetSigma(0, ndata);
      end;
    2:begin
        a[1] := log10(Ksat[1]); a_min[1] := -7; a_max[1] := 0;
        if KsatFix = 1 then ia[1] := 0;
        if (independent = 1) or (IPET_type = 5) then
        begin
          a[2] := ak[1];
          a[3] := bk[1];
          if (KF[1] = 2) or (KF[1] = 3) then
            ma   := 5
          else
          begin
            ma   := 6;
            a[4] := ck[1];
          end;
          if akFix= 1 then
            ia[2] := 0;
          if bkFix= 1 then
            ia[3] := 0;
        end
        else
        begin
          ma := 8;
          a[2] := ak[1];     a_max[2] := 10; a_min[2] := -2;
          a[3] := Wsat[1];
          a[4] := alpha1[sn*1]; a_min[4] := 0;
          a[5] := np1[sn*1];
          a[6] := Wr[1];
          if akFix = 1 then
            ia[2] := 0;
          if WsatFix = 1 then
            ia[3] := 0;
          if WrFix = 1 then
            ia[6] := 0;
        end;
        a[ma-1] := parlb_a;
        a[ma]   := parlb_b;
        if (ChangeResistance <> True) or (IPET_type > 2) or ((IPET_type = 1) and (UseOutFlowForK = 0)) then
        begin
          ia[ma-1] := 0;
          ia[ma]   := 0;
        end;
        //----------------------------------------------------------
        case IPET_type of
        1: begin
            if UseOutFlowForK = 0 then
              NumOutflowData := 0;
            ndata := NumOutflowData + NumEvapData + NumSampling + NumAddHyConData;
            //-------- Outflow -------------------
            if UseOutFlowForK <> 0 then
            begin
              for i := 1 to NumOutflowData do
              begin
                x[i] := t_outflow[i];
                y[i] := CumOutFlow[i]; //Weight[1] * CumOutFlow[i];
              end;
              SetSigma(0, NumOutflowData);
            end;
            //-------- Evaporation -----------------
            j := 0;
            for i := NumOutflowData + 1 to NumOutflowData + NumEvapData do
            begin
              j := j + 1;
              x[i] := t_evaporation[j];
              y[i] := CumEvaporation[j];//Weight[2] * CumEvaporation[j];
            end;
            SetSigma(NumOutflowData, NumOutflowData + NumEvapData);
            //-------- Wetnesss Profile ---------------
            j := 0;
            for i := NumOutflowData + NumEvapData + 1 to NumOutflowData + NumEvapData + NumSampling do
            begin
              j := j + 1;
              x[i] := zm[j];
              y[i] := Wm[j]; //Weight[3] * Wm[j];
            end;
            SetSigma(NumOutflowData + NumEvapData, NumOutflowData + NumEvapData + NumSampling);
            //-------- Additional K data -----------
            if NumAddHyConData > 0 then
            begin
              j := 0;
              for i := NumOutflowData + NumEvapData + NumSampling + 1 to ndata do
              begin
                j := j + 1;
                x[i] := Wkm[j];
                y[i] := LogKm[j]; //Weight[4] * LogKm[j];
              end;
              SetSigma(NumOutflowData + NumEvapData + NumSampling, ndata);
            end;
            //-------------------------------------------
          end;
        2:begin
            if UseOutFlowForK = 0 then
              NumOutflowData := 0;
            ndata := NumOutflowData; // for independent & without tensiometer
            //-------- Outflow -------------------
            for i := 1 to NumOutflowData do
            begin
              x[i] := t_outflow[i];
              y[i] := CumOutFlow[i]; //Weight[1] * CumOutFlow[i];
            end;
            SetSigma(0, NumOutflowData);
            //-------- Tensiometer -------------------
            if Tensio >= 1 then
            begin
              j := 0;
              ndata := NumOutflowData + NumTensioData;
              for i := NumOutflowData + 1 to NumOutflowData + NumTensioData do
              begin
                j := j + 1;
                x[i] := t_tensio[j];
                y[i] := Ptens1[j]; //Weight[2] * Ptens1[j];
              end;
              SetSigma(NumOutflowData, NumOutflowData + NumTensioData);
            end;
            if Tensio = 2 then
            begin
              j := 0;
              for i := NumOutflowData + NumTensioData + 1 to NumOutflowData + 2 * NumTensioData do
              begin
                j := j + 1;
                x[i] := t_tensio[j];
                y[i] := Ptens2[j]; //Weight[2] * Ptens1[j];
              end;
              SetSigma(NumOutflowData + NumTensioData, NumOutflowData + NumTensioData * 2);
            end;
            //-------- Additional Retention Data -----------
            if independent <> 1 then
            begin
              j := 0;
              if Tensio >= 1 then
                dumint := 2
              else
                dumint := 1;
              ndata := NumOutflowData + Tensio * NumTensioData + NumAddRetData + dumint;
              for i := NumOutflowData + Tensio * NumTensioData + 1 to ndata do
              begin
                j := j + 1;
                x[i] := Pretm[j];
                y[i] := Wretm[j]; //Weight[3] * Wretm[j];
              end;
              SetSigma(NumOutflowData + Tensio * NumTensioData, ndata);
            end; // if
          end; // 2: of IPET_Type
        3:begin
            //-------- Inflow -------------------
            j := 0;
            for i := 1 to NumOutflowData do
            begin
              x[i] := t_outflow[i];
              if t_outflow[i] < t_limit then
              begin
                y[i] := CumOutFlow[i]; //Weight[1] * CumOutFlow[i];
                j := j + 1;
              end
              else
                y[i] := 0;
            end;
            NumOutflowData := j;
            SetSigma(0, NumOutflowData);
            ndata := NumOutflowData + 1; // for independent & without tensiometer
            y[ndata] := W_slice;
            sig[ndata] := W_slice / 2;
            {
            //-------- Additional Retention Data -----------
            if independent <> 1 then
            begin
              j := 0;
              if Tensio >= 1 then
                dumint := 2
              else
                dumint := 1;
              ndata := NumOutflowData + Tensio * NumTensioData + NumAddRetData + dumint;
              for i := NumOutflowData + Tensio * NumTensioData + 1 to ndata do
              begin
                j := j + 1;
                x[i] := Pretm[j];
                y[i] := Wretm[j]; //Weight[3] * Wretm[j];
              end;
              SetSigma(NumOutflowData + Tensio * NumTensioData, ndata);
            end; // if
            }
          end; // 3: of IPET_Type
        4:begin
            j := 0;
            for i := 1 to NumTensioData do
            begin
              j := j + 1;
              x[i] := t_tensio[j];
              y[i] := Ptens1[j]; //Weight[2] * Ptens1[j];
            end;
            SetSigma(0, NumTensioData);
            ndata := NumTensioData + 1;
            if Tensio = 2 then
            begin
              j := 0;
              for i := NumTensioData + 1 to 2 * NumTensioData do
              begin
                j := j + 1;
                x[i] := t_tensio[j];
                y[i] := Ptens2[j]; //Weight[2] * Ptens1[j];
              end;
              SetSigma(NumTensioData, NumTensioData * 2);
              ndata := 2 * NumTensioData + 1;
              y[ndata] := W_end;
              sig[ndata] := 1;
            end;
          end; // 4: : of IPET_Type
        5:begin
            ndata := NumOutflowData + NumFrontData + NumSampling;
            for i := 1 to NumOutflowData do
            begin
              x[i] := t_outflow[i];
              y[i] := CumOutFlow[i]; //Weight[1] * CumOutFlow[i];
            end;
            SetSigma(0, NumOutflowData);
            if NumFrontData > 0 then
            begin
              j := 0;
              for i := NumOutflowData + 1 to NumOutflowData + NumFrontData do
              begin
                j := j + 1;
                x[i] := t_front[j];
                y[i] := MeasuredFront[j];
              end;
              SetSigma(NumOutflowData, NumOutflowData + NumFrontData);
            end;
            if NumSampling > 0 then
            begin
              j := 0;
              for i := NumOutflowData + NumFrontData + 1 to ndata do
              begin
                j := j + 1;
                x[i] := zm[j];
                y[i] := Wm[j]; //Weight[3] * Wm[j];
              end;
              SetSigma(NumOutflowData + NumFrontData, NumOutflowData + NumFrontData + NumSampling);
            end;
          end;
        6:begin
            //-------- Outflow -------------------
            for i := 1 to NumOutflowData do
            begin
              x[i] := t_outflow[i];
              y[i] := CumOutFlow[i]; //Weight[1] * CumOutFlow[i];
            end;
            SetSigma(0, NumOutflowData);
            //-------- Tensiometer -------------------
            j := 0;
            ndata := NumOutflowData + NumTensioData;
            for i := NumOutflowData + 1 to NumOutflowData + NumTensioData do
            begin
              j := j + 1;
              x[i] := t_tensio[j];
              y[i] := Ptens1[j]; //Weight[2] * Ptens1[j];
            end;
            SetSigma(NumOutflowData, NumOutflowData + NumTensioData);
          end; // 6: of IPET_Type
        end; // case IPET_Type
      end; // case 2: of FitMode
    3:begin
        a[1] := dispersivity[1];
        for i := 1 to NumSampling do
        begin
          x[i] := zms[i];
          y[i] := Cm[i]; //Weight[1] * CumOutFlow[i];
        end;
        SetSigma(0, NumSampling);
        ndata := NumSampling;
      end; // case 3: of FitMode
    end; // case FitMode
  alamda := -1;
  ObjFunc := 0; itst := 0; fgauss := 0;
  step := 0;
  //------ Golden Section Method ----//
  if (FitMode = 3) or ((FitMode = 2) and
     ((KsatFix = 1) and (akFix = 1) and (bkFix = 1)))  then // or
     // ((Soil.RF[1] = 2) and (Soil.KF[1] = 3) and (independent = 1) and (akFix = 1))) then
  begin
    // Sensitivity analysis
    {
    StrList3 := TStringList.Create;
    try
      for i := 1 to 24 do
      begin
      //  x0 := 8.31  - 3.75 + 0.25 * i;
        x0 := 10.72 - 3.75 + 0.25 * i;
        y3 := f(x0);
        StrList3.Add(FloatToStr(x0) + ',' + FloatToStr(ymod[ndata]) + ',' + FloatToStr(y3));
      end;
      StrList3.SaveToFile(CaseName + '_sensitivity.csv');
    finally
      StrList3.Free;
    end;
    }
    GSM := True;
    if (KsatFix = 1) and (akFix = 1) and (bkFix = 1) then
      x0 := a[4]
    else
      x0 := a[1];
    y0 := f(x0);
    x3 := x0 * 1.1;
    y3 := f(x3);
    if StopCalc = 1 then
      Exit;
    if y0 < y3 then
    begin
      while y0 < y3 do
      begin
        step := x0 - x3;
        x3 := x0;
        y3 := y0;
        x0 := x0 + step * 1.5;
        y0 := f(x0);
        if StopCalc = 1 then
          Exit;
      end; ;
      x3 := x3 - step;
    end
    else
    begin
      while y0 > y3 do
      begin
        step := x3 - x0;
        x0 := x3;
        y0 := y3;
        x3 := x3 + step * 1.5;
        y3 := f(x3);
        if StopCalc = 1 then
          Exit;
      end; ;
      x0 := x0 - step;
    end;
    x1 := x0 + (x3 - x0) / 2.618;
    x2 := x0 + (x3 - x0) / 1.618;
    y1 := f(x1);
    y2 := f(x2);
    repeat
      if StopCalc = 1 then
        Exit;
      if y1 > y2 then
      begin
        x0 := x1;
        x1 := x2;
        x2 := x0 + (x3 - x0) / 1.618;
        y1 := y2;
        y2 := f(x2);
      end
      else
      begin
        x3 := x2;
        x2 := x1;
        x1 := x0 + (x3 - x0) / 2.618;
        y2 := y1;
        y1 := f(x1);
      end;
    until (Abs(x3 - x0) < 0.02);
  end
  //--------------------------------//
  else
  begin
    //-------------------------------------------------------------------------
      mrqmin(x, y, sig, a, ia, covar, alpha_, ObjFunc, fgauss, alamda, ndata);
    //-------------------------------------------------------------------------
    if StopCalc = 1 then Exit;
    while (itst < 7) and (alamda > 0.000001) do
    begin
      OFbase := ObjFunc;
      //------------------------------------------------------------------------
        mrqmin(x, y, sig, a, ia, covar, alpha_, ObjFunc, fgauss, alamda, ndata);
      //------------------------------------------------------------------------
      if StopCalc = 1 then Exit;
      if ObjFunc > OFbase * 1.00001 then
        itst := 0
      else
      begin
        if NumPerform > 500 then Break;
        if Abs(OFbase - ObjFunc) / ObjFunc < 0.1 Then
          itst := itst + 1;
      end;
    end;
    alamda := 0;
    //------------------------------------------------------------------------
      mrqmin(x, y, sig, a, ia, covar, alpha_, ObjFunc, fgauss, alamda, ndata);
    //------------------------------------------------------------------------
  end;
  with Soil do
    case FitMode of
    1:begin
        Wsat[1]  := a[1];
        if RF[1] = 1 then
        begin
          zeta[1]   := a[2];
          alpha[sn*1]  := Abs(a[3]);
          np[sn*1]     := a[4];
          if Linked_m <> 1 then
            mp[sn*1] := a[5]
          else
            mp[sn*1] := 1 - 1 / np[sn*1];
          Llambda[1]:= a[6];
        end
        else
        begin
          sp[1]     := a[2];
          alpha1[sn*1] := Abs(a[3]);
          np1[sn*1]    := a[4];
          alpha2[1] := Abs(a[5]);
          np2[1]    := a[6];
          Wr[1]     := a[7];
          mp1[sn*1] := 1 - 1 / np1[1];
          mp2[1] := 1 - 1 / np2[1];
        end;
      end;
    2:begin
        Ksat[1]  := Power(10, a[1]);
        ak[1]    := a[2];
        if (independent = 1) or (IPET_type = 5) then
        begin
          bk[1] := a[3];
          if (KF[1] = 1) or (KF[1] = 4) then
            ck[1] := a[4];
        end
        else
        begin
          Wsat[1] := a[3];
          alpha1[sn*1]:= a[4];
          np1[sn*1]   := a[5];
          Wr[1]   := a[6];
          mp1[1]   := 1 - 1 / np1[1];
          if KF[1] = 3 then
            bk[1]  := mp1[1];
          mp2[1]   := 1 - 1 / np2[1];
        end;
       // Main.SendDataToSoil;
      end;
    3: dispersivity[1] := a[1];
    end;
end;

//===============================================================================================================================
procedure TParamEstimator.mrqmin(x, y, sig: glndata; var a, ia: glma; var covar, alpha_: glmabyma; var ObjFunc, fgauss, alamda: Double; ndata: Integer);
//===============================================================================================================================
var
  i, j, k, l, mfit: Integer;
  OFbase: Double;
  da: array[0..100] of Double;
  atry: glma;
  dumarray: glmabyma;
  dumstr2: String;
  //const MMAX = 7;
begin
  mfit := 0;
  for j := 1 to ma do
    if ia[j] <> 0 then mfit := mfit + 1;
  if alamda < 0 Then
  begin
    alamda := 0.01;
   //------------------------------------------------------------------
     mrqcof(x, y, sig, a, ia, alpha_, beta_, ObjFunc, ndata);
   //------------------------------------------------------------------
    if StopCalc = 1 then Exit;
    Report(a, ia, alamda, ObjFunc);
    OFbase := ObjFunc;
    for j := 1 to ma do atry[j] := a[j];
  end
  else
    OFbase := ObjFunc; //? ɤɬ
  for j := 1 to mfit do
  begin
    for k := 1 to mfit do
      covar[j,k] := alpha_[j,k];
    covar[j,j] := alpha_[j,j] * (1 + alamda);
    da[j] := beta_[j];
    if da[j] = 0 then
      da[j] := 1e-10;
    dumarray[j,1] := da[j]
  end;
  //----------------------------------------------------------
    gaussj(covar, dumarray, mfit, 1);
  //----------------------------------------------------------
  for j := 1 to mfit do
    da[j] := dumarray[j,1];
  if alamda = 0 then
  begin
    //  Absolute values of standard deviations of each parameters are meaningless since they depend on how much weighting coefficients(sig[i]) are applied.
    StrList2.Add(Msg[5]);
    dumstr := '';
    for j := 1 to mfit do
      dumstr := dumstr + Simulator.SetLengthRJ(FormatFloat('#0.####0', Sqrt(Abs(covar[j,j]))), 8) + '  ' ;
    StrList2.Add(dumstr);
    StrList2.Add('');
    StrList2.Add('----- Correlation Matrix for the Optimized Parameters -----');
    dumstr := '         ';
    j := 0;
    for i := 1 to ma do
      if ia[i] = 1 then
      begin
        j := j + 1;

        FittedParamName[j] := ParamName[i];
        dumstr := dumstr + ParamName[i];
      end;
    StrList2.Add(dumstr);
    for i := 1 to mfit do
    begin
      dumstr := '';
      for j := 1 to mfit do
        if i >= j then
        begin
          if covar[i,j] < 0 then
            dumstr2 := ''
          else
            dumstr2 := ' ';
          dumstr := dumstr + dumstr2 + FormatFloat('0.000', covar[i,j]/(Sqrt(Abs(covar[i,i])) * Sqrt(Abs(covar[j,j])))) + '   ';
        end;
      StrList2.Add(FittedParamName[i] + '   ' + dumstr);
    end;
    // High correlation means that uniqueness of the two parameters are dubious.
    Exit;
  end;
  j := 0;
  for l := 1 to ma do
    if ia[l] <> 0 Then
      begin
      j := j + 1;
      if a[l] + da[j] > a_max[l] then da[j] := 0;   // 990524
      if a[l] + da[j] < a_min[l] then da[j] := 0;   // 990524
      atry[l] := a[l] + da[j];
      end;
  //  else
  //    atry[l] := a[l]; //? ɤɬ
  //------------------------------------------------------------------
    mrqcof(x, y, sig, atry, ia, covar, da, ObjFunc, ndata);
  //------------------------------------------------------------------
    if StopCalc = 1 then Exit;
    Report(atry, ia, alamda, ObjFunc);
  if ObjFunc <= OFbase then
  begin
    alamda := 0.1 * alamda;
    //OFbase :=ObjFunc;
    for j := 1 to mfit do
    begin
      for k := 1 to mfit do
        alpha_[j,k] := covar[j,k];
      beta_[j] := da[j];
    end;
    for l := 1 to ma do
      a[l] := atry[l];
  end
  else
  begin
    alamda := 10 * alamda;
    //ObjFunc := OFbase
  end;
end;


//===============================================================================================================================
procedure TParamEstimator.gaussj(var a, b: glmabyma; n, m: Integer);
//===============================================================================================================================
var
  i,icol,irow,j,k,l,ll:integer;
  big,dum,pivinv:double;
  i2:integer;
  indxr,indxc: array[-1..8] of integer;
  //:array[1..5] of integer;
  ipiv:array[1..8] of integer;
const NMAX = 50;
begin
  icol := 0; irow := 0;
  for i:=1 to n do
  begin
    indxc[i]:=0;
    indxr[i]:=0;
    ipiv[i]:=0;
  end;
  //
  for j := 1 to n do
    ipiv[j]:=0;
  for i :=1 to n do
  begin
    big := 0;
    for j:=1 to n do
    begin
      if ipiv[j] <> 1 then
      begin
        for k := 1 to n do
        begin
          if ipiv[k] = 0 then
          begin
            if abs(a[j][k]) >= big then
            begin
              big := abs(a[j][k]);
              irow := j;
              icol := k;
            end;
          end
          else
            if ipiv[k] > 1 then
            begin
              ShowMessage('singular matrix in gaussj');
              Exit;
            end;
        end;
      end;
    end;
    ipiv[icol] := ipiv[icol] + 1;
    //==========
    if irow <> icol then
    begin
      for l:=1 to n do
      begin
        dum := a[irow][l];
        a[irow][l] := a[icol][l];
        a[icol][l] := dum;
      end;
      for l:=1 to m do
      begin
        dum := b[irow][l];
        b[irow][l] := b[icol][l];
        b[icol][l] := dum;
      end;
    end;
    indxr[i] := irow;
    indxc[i] := icol;
    if a[icol][icol]= 0 then
    begin
      //ShowMessage('singular matrix in gaussj');
      Main.StatusBar1.SimpleText := 'singular matrix in gaussj!';
      // This occurs when at least one dy/da equals zero. i.e. Completely non-sensitive parameter(s) is(are) "optimized".
      Exit;
    end
    else
      if Main.StatusBar1.SimpleText = 'singular matrix in gaussj!' then
        Main.StatusBar1.SimpleText := '';
    pivinv := 1 / a[icol][icol];
    a[icol][icol] := 1;
    for l := 1 to n do
      a[icol][l] := a[icol][l] * pivinv;
    for l:=1 to m do
      b[icol][l] := b[icol][l] * pivinv;
    for ll:=1 to n do
    begin
      if ll <> icol then
      begin
        dum := a[ll][icol];
        a[ll][icol] := 0;
        for l := 1 to n do
          a[ll][l] := a[ll][l] - a[icol][l] * dum;
        for l := 1 to m do
         b[ll][l] := b[ll][l] - b[icol][l] * dum;
      end;
    end;
  end;
  for l:=n downto 1 do
  begin
    if indxr[l] <> indxc[l] then
    begin
      for k:=1 to n do
      begin
        dum := a[k][indxr[l]];
        a[k][indxr[l]] := a[k][indxc[l]];
        a[k][indxc[l]] := dum;
      end;
    end;
  end;
  if Main.StatusBar1.SimpleText = 'singular matrix in gaussj!' then
    Main.StatusBar1.SimpleText := 'Press [ESC] to stop.';
end;

//====================================================================================================================================================
procedure TParamEstimator.mrqcof(x, y, sig: glndata; var a, ia: glma; var alpha_: glmabyma; var beta_: array of Double; var ObjFunc: Double; ndata: Integer);
//====================================================================================================================================================
const
  //da = 0.0000000005; { <-- This value shoud be chosen carefully.}
  MMAX = 8;
var
  mfit, i, j, k, l, m: Integer;
  da, dy, sig2i, wt: Double;
  dyda, ymod1: array[0..3000, 0..MMAX] of Double;
  dumintarray: array[1..12] of integer;
  Num_Data: array[1..3] of integer;
  procedure AddSquareError(i: Integer);
  begin
    RMSE[i] := RMSE[i] + dy * dy;
    ObjFunc_[i] := ObjFunc_[i] + dy * dy * sig2i / (ndata * ndata);
    Inc(Num_Data[i]);
  end;
begin
  mfit := 0;
  for i := 1 to 1000 do
  begin
    ymod[i]  := 0;
    ymod0[i] := 0;
  end;
  for j := 1 to ma do
    if ia[j] <> 0 then
      mfit := mfit + 1;
  for j := 1 to mfit do
  begin
    for k := 1 to j do
      alpha_[j,k] := 0;
    beta_[j] := 0;
  end;
  ObjFunc := 0;
  //----------------------------------------------------------
  case FitMode of
  1   :RetentionFunction(a, x);
  2..3:GetSimulationResults(a, x);
  end;
  if StopCalc = 1 then
    Exit;
  //----------------------------------------------------------
  for i := 1 to ndata do
    ymod0[i] := ymod[i];
  if not GSM then
  begin
    for k := 1 to ma do
    begin
      if ia[k] <> 0 then
      begin
        if a[k] <> 0 then
          da := a[k] * 0.0001 // IMPORTANT !!
        else
          da := 0.0001;
        a[k] := a[k] + da;
      //----------------------------------------------------------
        case FitMode of
        1   :RetentionFunction(a, x);
        2..3:GetSimulationResults(a, x);
        end;
        if StopCalc = 1 then Exit;
      //----------------------------------------------------------
        for i := 1 to ndata do
        begin
          ymod1[i,k] := ymod[i];
          dyda[i,k]  := (ymod1[i,k] - ymod0[i]) / da;
         // sig[i] := 1;// Abs(ymod1[i,k] - ymod0[i]) + Yavg * 0.0001;   äƤ
        end;
        a[k] := a[k] - da;
      end;
    end;
  end;
  for i := 1 to 3 do
  begin
    ObjFunc_[i] := 0;
    RMSE[i]     := 0;
    Num_Data[i] := 0;
  end;
  for i := 1 to ndata do
  begin
    sig2i := 1 / (sig[i] * sig[i]) * ndata * ndata; // "* ndata * ndata" was added on 2003/3/2
    dy := y[i] - ymod0[i];
    j  := 0;
    if not GSM then
      for l := 1 to ma do
      begin
        if ia[l] <> 0 then
        begin
          j := j + 1;
          wt := dyda[i,l] * sig2i;
          k := 0;
          for m := 1 to l do
            if ia[m] <> 0 then
            begin
              k := k + 1;
              alpha_[j,k] := alpha_[j,k] + wt * dyda[i,m];
            end;
          beta_[j] := beta_[j] + dy * wt;
        end;
      end;
  {============ Objective Function is here! ===========}
    ObjFunc :=ObjFunc + dy * dy * sig2i / (ndata * ndata); // " / (ndata * ndata)" was added on 2003/3/2;
    case IPET_type of
    1:begin
        if i <= NumOutflowData then
          AddSquareError(1);
        if (NumOutflowData < i) and (i <= NumOutflowData + NumEvapData) then
          AddSquareError(2);
        if i > NumOutflowData + NumEvapData then
          AddSquareError(3);
      end;
    2:begin
        if i <= NumOutflowData then
          AddSquareError(1);
        if Tensio >= 1 then
          if (NumOutflowData < i) and (i <= NumOutflowData + NumTensioData) then
            AddSquareError(2);
        if independent <> 1 then
          if (NumOutflowData + NumTensioData < i) and (i <= ndata) then
            AddSquareError(3);
      end;
    3:begin
        if i <= NumOutflowData then
          AddSquareError(1)
        else
          AddSquareError(2);
      end;
    4:begin
        if i <= NumTensioData * Tensio then
          AddSquareError(1)
        else
          AddSquareError(2);
      end;
    5:begin
        if i <= NumOutflowData then
          AddSquareError(1);
        if (i > NumOutflowData) and (i <= NumOutflowData + NumFrontData) then
          AddSquareError(2);
        if i > NumOutflowData + NumFrontData then
          AddSquareError(3);
      end;
    6:begin
        if i <= NumOutflowData then
          AddSquareError(1);
        if (NumOutflowData < i) and (i <= NumOutflowData + NumTensioData) then
          AddSquareError(2);
      end;
    end;
 {====================================================}
  end;
  for i := 1 to 3 do
    if Num_Data[i] > 0 then
      RMSE[i] := Sqrt(RMSE[i] / Num_Data[i]);
  if not GSM then
    for j := 2 to mfit do
      for k := 1 to j - 1 do alpha_[k,j] := alpha_[j,k];
  if FitMode = 2 then
    with Main.Image4.Canvas do
    begin
      for i := 1 to 12 do
        dumintarray[i] := 7 + Ceil(i * 1.7 * StdFontSize);
      i := ColumnPosition + 1;
      TextOut(4, dumintarray[i], Msg[6] + FormatFloat('0.000000000', ObjFunc));
      if (IPET_type = 1) or (independent <> 1) or (Tensio = 1) or (IPET_type = 3) then
      begin
        TextOut(4, dumintarray[i+1], Msg[7]);
        TextOut(4 + TextWidth(Msg[7]), dumintarray[i+1], ' = ' + FormatFloat('#0.0', 100 * ObjFunc_[1] / ObjFunc) + '%');
        TextOut(4, dumintarray[i+2],  Msg[8]);
        if (IPET_type = 2) and (Tensio <> 1) then
          dum := ObjFunc_[3]
        else
          dum := ObjFunc_[2];
        TextOut(4 + TextWidth(Msg[8]), dumintarray[i+2], ' = ' + FormatFloat('#0.0', 100 * dum / ObjFunc) + '%');
      end;
      if ((IPET_type = 1) or (independent <> 1)) and (ObjFunc_[3] > 0) then
      begin
        if (IPET_type = 2) and (Tensio <> 1) then else
        begin
          TextOut(4, dumintarray[i+3], Msg[9]);
          TextOut(4 + TextWidth(Msg[9]), dumintarray[i+3], ' = ' + FormatFloat('#0.0', 100 * ObjFunc_[3] / ObjFunc) + '%');
        end;
      end;
    end;
  Application.ProcessMessages;
end;

//========================================================================================
procedure TParamEstimator.RetentionFunction(a: glma; x: glndata);
var
  i, j, k: Integer;
  h1, h2, a_, x_, x1, x2, dx, sum, sum_h, EvapRate, Grad: Double;
  h, W: array[0..10] of Double;
 // Hysteresis: Boolean;
begin
  with Soil do
  begin
    Wsat[1] := a[1];
    if RF[1] = 1 then
    begin
      zeta[1]  := a[2];
      alpha[sn*1] := a[3];
      np[sn*1]    := a[4];
      if Linked_m <> 1 then
        mp[sn*1] := a[5]
      else
        mp[sn*1] := 1 - 1 / a[4];//np[1];
      Llambda[1]:= a[6];
    end
    else
    begin
      sp[1]     := a[2];
      alpha1[sn*1] := a[3];
      np1[sn*1]    := a[4];
      alpha2[1] := a[5];
      np2[1]    := a[6];
      Wr[1]     := a[7];
      mp1[1] := 1 - 1 / np1[1];
      mp2[1] := 1 - 1 / np2[1];
    end;
   // Main.SendDataToSoil;
    j := 0;
    x1 := z_lb - z_obs[1];  // x is height from the bottom
    x2 := z_lb - z_obs[2];
    for i := 1 to ndata do
      if (IPET_type < 4) or (Tensio = 1) then
        ymod[i] := Water_Content(x[i], Tref[1], Wsat[1], zeta[1], Wr[1], 1, IniDrying)
      else
      begin
        repeat j := j + 1
        until t_tensio[j] >= t_evaporation[i];
        h1 := Ptens1[j-1];
        h2 := Ptens2[j-1];
        a_ := (x2 - x1 + h2 - h1) / (x2 * x2 - x1 * x1);
        dx := z_lb / 10;
        sum_h := 0;
        for k := 0 to 10 do
        begin
          x_ := k * dx;
          h[k] := a_ * (x_ * x_ - x1 * x1) - x_ + h1 + x1;
          W[k] := Soil.Water_Content(h[k], Tref[1], Wsat[1], zeta[1], Wr[1], 1, True);
          sum_h := sum_h + h[k];
        end;
        sum := 0;
        for k := 1 to 9 do
          sum := sum + W[k];
        ymod[i] := (dx / 2 * (W[1] + 2 * sum + W[10])) / z_lb;
        Pret[i] := sum_h / 11;
        if i = 1 then
          EvapRate := (CumEvaporation[2] - CumEvaporation[1]) / (t_evaporation[2] - t_evaporation[1]) / t_unit
        else
          if i = ndata then
            EvapRate := (CumEvaporation[ndata] - CumEvaporation[ndata-1]) / (t_evaporation[ndata] - t_evaporation[ndata-1]) / t_unit
          else
            EvapRate := (CumEvaporation[i]     - CumEvaporation[i-1])     / (t_evaporation[i]     - t_evaporation[i-1])     / t_unit;
        x_ := 0.5 * (x1 + x2);
        {$ifdef linear}
        Grad := (h2 - h1) / (z_obs[2] - z_obs[1]);
        {$else}
        Grad := - (2 * a_ * x_ - 1);
        {$endif}
        K_direct[i] := EvapRate * (x_ / z_lb) / (Grad - 1);
        W_direct[i] := Wret[i];
      end;
  end;
  NumPerform := NumPerform + 1;
end;

//========================================================================================
procedure TParamEstimator.GetSimulationResults(a: glma; x: glndata);
//========================================================================================
var
  i, j: Integer;
  t_prev, t_next: Double;
 // Gheight, Gwidth, Glmargin, Gtmargin: Integer;
 // nday : Integer;
 // GXmax, GXmin, GYmax, GYmin: Single;
begin
  with Soil do
    if FitMode = 2 then
      if (independent = 1) or (IPET_type = 5) then
      begin
        Ksat[1] := Power(10, a[1]);
        ak[1] := a[2];
        bk[1] := a[3];
        if (KF[1] = 1) or (KF[1] = 4) then
          ck[1] := a[4];
       // Main.SendDataToSoil;
      //  Main.SendDataToKparams;
      end
      else
      begin
        Ksat[1]  := Power(10, a[1]);
        ak[1]    := a[2];
        Wsat[1]  := a[3];
        alpha1[1]:= a[4];
        np1[1]   := a[5];
        Wr[1]    := a[6];
        if IPET_type <> 5 then
        begin
          mp1[1]   := 1 - 1 / np1[1];
          if KF[1] = 3 then
            bk[1]  := mp1[1];
          mp2[1]   := 1 - 1 / np2[1];
        end;
    //  Main.SendDataToSoil;
    //  Main.SendDataToKparams;
      end
    else
    begin
      Soil.dispersivity[1] := a[1];
    end;
  parlb_a := a[ma-1];
  parlb_b := a[ma];
  //----------------------//
  Simulator.Simulate;
  //----------------------//
  if StopCalc = 1 then Exit;
  if x[1] = 0 then x[1] := 0.00000000000001;
  if IPET_type <> 4 then
    for i := 1 to NumOutflowData do
    begin
      j := Ceil(x[i] / int_rec);
      t_prev := int_rec * (j-1);
      t_next := int_rec * j;
      if t_next > t_prev then
        ymod[i] := (CumD[j-1] * ( t_next - x[i] ) + CumD[j] * ( x[i] - t_prev )) / ( t_next -  t_prev ); // * Weight[1];
      if (IPET_type = 3) and (x[i] >= t_limit) then
        ymod[i] := 0;
    end;
  if Tensio >= 1 then    //  IPET_type = 2 or 4 or 6
    for i := NumOutflowData + 1 to NumOutflowData + NumTensioData do
    begin
      j := Ceil(x[i] / int_rec);
      if j = 0 then j := 1;
      t_prev := int_rec * (j-1);
      t_next := int_rec * j;
      if t_next > t_prev then
        ymod[i] := (Ptime[1,j-1] * ( t_next - x[i] ) + Ptime[1,j] * ( x[i] - t_prev )) / ( t_next -  t_prev ); // * Weight[2]
    end;
  if (IPET_Type = 2) and (Tensio = 2) then    //  IPET_type = 2
    for i := NumOutflowData + NumTensioData + 1 to NumOutflowData + 2 * NumTensioData do
    begin
      j := Ceil(x[i] / int_rec);
      if j = 0 then j := 1;
      t_prev := int_rec * (j-1);
      t_next := int_rec * j;
      if t_next > t_prev then
        ymod[i] := (Ptime[2,j-1] * ( t_next - x[i] ) + Ptime[2,j] * ( x[i] - t_prev )) / ( t_next -  t_prev ); // * Weight[2]
    end;
  case IPET_type of
  1:begin
      for i := NumOutflowData + 1 to NumOutflowData + NumEvapData do
      begin
        j := Ceil(x[i] / int_rec);
        t_prev := int_rec * (j-1);
        t_next := int_rec * j;
        if t_next > t_prev then
          ymod[i] := (CumE[j-1] * ( t_next - x[i] ) + CumE[j] * ( x[i] - t_prev )) / ( t_next -  t_prev ); // * Weight[2]
      end;
      for i := NumOutflowData + NumEvapData + 1 to NumOutflowData + NumEvapData + NumSampling do
      begin
        if com_ratio = 1 then
          j := Trunc(x[i]/dz[1]) + 1
        else
          j := Ceil(LogN(com_ratio, 1 + x[i] * (com_ratio - 1) / dz[1]));
        ymod[i] := W[j]; // * Weight[3]
      end;
      with Soil do
        for i := NumOutflowData + NumEvapData + NumSampling + 1 to ndata do
          ymod[i] := Log10(HydraulicConductivity(x[i], Tref[1], 1) / t_unit);// * Weight[4];
    end;
  2:begin
      with Soil do
        if independent <> 1 then
          for i := NumOutflowData + Tensio * NumTensioData + 1 to ndata do
            ymod[i] := Water_Content(x[i], Tref[1], Wsat[1], zeta[1], Wr[1], 1, True); // * Weight[3]
    end;
  3:begin
      ymod[ndata] := Simulator.GetAvgWaterContentAbove(z_slice);
     // For sensitivity analysis
     // ShowMessage(FloatToStr(Soil.ck[1]) + ', ' + FloatToStr(dum));
    end;
  4:begin
      if Tensio = 2 then
        for i := NumTensioData + 1 to 2 * NumTensioData do
        begin
          j := Ceil(x[i] / int_rec);
          if j = 0 then j := 1;
          t_prev := int_rec * (j-1);
          t_next := int_rec * j;
          if t_next > t_prev then
            ymod[i] := (Ptime[2,j-1] * ( t_next - x[i] ) + Ptime[2,j] * (x[i] - t_prev )) / ( t_next -  t_prev ); // * Weight[2]
        end;
      ymod[ndata] := W_storage_new / z_lb;
    end;
  5:begin
      for i := NumOutflowData + 1 to NumOutflowData + NumFrontData do
      begin
        j := Ceil(x[i] / int_rec);
        t_prev := int_rec * (j-1);
        t_next := int_rec * j;
        if t_next > t_prev then
          ymod[i] := (Front[j-1] * ( t_next - x[i] ) + Front[j] * (x[i] - t_prev )) / ( t_next -  t_prev ); // * Weight[2]
      end;
      for i := NumOutflowData + NumFrontData + 1 to ndata do
      begin
        if com_ratio = 1 then
          j := Trunc(x[i]/dz[1]) + 1
        else
          j := Ceil(LogN(com_ratio, 1 + x[i] * (com_ratio - 1) / dz[1]));
        ymod[i] := W[j]; // * Weight[3]
      end;
    end;
  11:begin
    //  Simulator.DrawFigure;
      for i := 1 to ndata do
      begin
        if com_ratio = 1 then
          j := Trunc(x[i] / dz[1]) + 1
        else
          j := Ceil(LogN(com_ratio, 1 + x[i] * (com_ratio - 1) / dz[1]));
        ymod[i] := C[j]; // * Weight[3]
      end;
    end;
  end;
  NumPerform := NumPerform + 1;
end;
//----------------------------------------------------------
procedure TParamEstimator.Report(a, ia : glma; alamda, ObjFunc: Double);
var i: ShortInt;
begin
  with Soil do
    if FitMode = 1 then
    begin
      if RF[1] = 1 then
        dumint := 6
      else
        dumint := 6
    end
    else
      if independent = 1 then
        if (KF[1] = 1) or (KF[1] = 4) then
          dumint := 6
        else
          dumint := 5
      else
        dumint := 8;
  dumstr := '';
  for i := 1 to dumint do
    if ia[i] = 1 then
      dumstr := dumstr + Simulator.SetLengthRJ(FormatFloat('#0.####0', a[i]), 8) + '  ' ;
  StrList2.Add(dumstr + '  ' + FormatFloat('#0.####0', alamda) + '  ' + FormatFloat('0.000000000', ObjFunc));
end;

procedure TParamEstimator.OutputResults(Param, IsFitted: glma);
var
  i: Integer;
begin
  dumstr := '';
  for i := 1 to ma do
    if IsFitted[i] = 0 then
      dumstr := dumstr + ParamName[i];
  if dumstr <> '' then
  begin
    StrList1.Add('----- Fixed Parameters -----');
    StrList1.Add(dumstr);
  end;
  dumstr := '';
  for i := 1 to ma do
    if IsFitted[i] = 0 then
      dumstr := dumstr + '  ' + Simulator.SetLengthRJ(FormatFloat('#0.####0', Param[i]), 8);
  StrList1.Add(dumstr);
  StrList1.Add('----- Fitted Parameters -----');
  dumstr := '';
  for i := 1 to ma do
      dumstr := dumstr + FittedParamName[i];
  StrList1.Add(dumstr + '  lambda   Obj.Function');
  for i := 0 to StrList2.Count - 1 do
    StrList1.Add(StrList2[i]);
  StrList1.Add(' Number of trial = ' + IntToStr(NumPerform));
  for i := 1 to 3 do
    if RMSE[i] > 0 then
      StrList1.Add('RMSE' + IntToStr(i) + ' = '  + FloatToStr(RMSE[i]));
end;

//----------------------------------------------------------
function TParamEstimator.FlexVariance(dumarray: array of double; IniValue, FinValue: Integer): Double;
var
  i: Integer;
  dum, dum2 : Double;
begin
  if IniValue = FinValue then
    begin
    Result := dumarray[IniValue] * 0.1;
    Exit;
    end;
  dum := 0; dum2 := 0;
  for i := IniValue to FinValue do
    dum := dum + dumarray[i] / (FinValue - IniValue + 1);
  for i := IniValue to FinValue do
    dum2 := dum2 + Sqr(dumarray[i] - dum) / (FinValue - IniValue + 1);
  Result := dum2;
end;

procedure TParamEstimator.FormShow(Sender: TObject);
begin
  Close;
end;

end.

