{
_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/

        WASH_1D version 1.35

        Copyright(C) 2000-2004 Haruyuki FUJIMAKI and Mitsuhiro INOUE
        fujimaki@sakura.cc.tsukuba.ac.jp
        URL: http://www.geocities.jp/fujimaki691202/
        Distributed under the GPL

_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/
}

unit Pos_Information;

interface

uses
{$ifdef Linux}
  SysUtils, Classes, QGraphics, QControls, QForms, 
  QDialogs, QStdCtrls, QExtCtrls, QComCtrls, QMenus, 
  IniFiles;
{$else}
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls, ComCtrls, Menus, Spin, IniFiles;
{$endif}

type
  TPositionInfo = class(TForm)
    GroupBox2: TGroupBox;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    ed_z_lb: TEdit;
    ed_dz_top: TEdit;
    ed_dz_bot: TEdit;
    Panel1: TPanel;
    Execute: TButton;
    Back: TButton;
    Next: TButton;
    GroupBox1: TGroupBox;
    Label1: TLabel;
    Label6: TLabel;
    ed_z_border: TEdit;
    GroupBox3: TGroupBox;
    Label8: TLabel;
    Label9: TLabel;
    Label10: TLabel;
    ed_z_obs: TEdit;
    Label5: TLabel;
    OpenDialog1: TOpenDialog;
    seNumLayer: TSpinEdit;
    seBorderNumber: TSpinEdit;
    seNumObs: TSpinEdit;
    seObsptNo: TSpinEdit;
    procedure ed_NumLayerChange(Sender: TObject);
    procedure ed_z_borderExit(Sender: TObject);
    procedure ed_NumBorderChange(Sender: TObject);
    procedure ExecuteClick(Sender: TObject);
    procedure BackClick(Sender: TObject);
    procedure NextClick(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure ed_NumObsChange(Sender: TObject);
    procedure ed_ObsPtNoChange(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure ed_z_obsChange(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    {$ifdef Linux}
    procedure seNumLayerChanged(Sender: TObject; NewValue: Integer);
    procedure seBorderNumberChanged(Sender: TObject; NewValue: Integer);
    procedure seNumObsChanged(Sender: TObject; NewValue: Integer);
    procedure seObsptNoChanged(Sender: TObject; NewValue: Integer);
    {$else}
    procedure seNumLayerChange(Sender: TObject);
    procedure seBorderNumberChange(Sender: TObject);
    procedure seNumObsChange(Sender: TObject);
    procedure seObsptNoChange(Sender: TObject);
    {$endif}
  private
    procedure Language;
    { Private  }
  public
    function Suffix(i: Integer): String ;
    { Public  }
  end;

var
  PositionInfo: TPositionInfo;

implementation

uses WASH1dMAIN, RC_Params;

{$R *.xfm}

procedure TPositionInfo.FormCreate(Sender: TObject);
begin
{$ifdef Linux}
  seObsPtNo.Max := MaxNumObs;
{$else}
  seObsPtNo.MaxValue := MaxNumObs;
{$endif}
end;

procedure TPositionInfo.FormShow(Sender: TObject);
begin
  DialogBox := -1;
  if z_border[1] = 0 then
    z_border[1] := 10;
  if z_lb = 0 then
    if Mode = 2 then
    begin
      z[1]   := 0.2;
      dz_bot := 0.2;
      z_lb := 5;
    end
    else
      z_lb := 40;
  //ed_NumLayer.Text := IntToStr(NumLayer);
  ed_z_lb.Text   := FloatToStr(z_lb);
  ed_dz_top.Text := FloatToStr(z[1]);
  ed_dz_bot.Text := FloatToStr(dz_bot);
  if z_obs[1] = 0 then z_obs[1] := 1;
  ed_z_obs.Text  := FloatToStr(z_obs[1]);
  seObsPtNo.Value := 1;
  if Mode = 2 then
    seNumLayer.Enabled := False;
{$ifdef Linux}
  seBorderNumberChanged(Sender, 1);
{$else}
  seBorderNumberChange(Sender);
{$endif}
  if (Mode = 2) and (IPET_type = 4) then
  begin
    seNumObs.Value := Tensio;
    SeNumObs.Enabled := False;
  end;
{$ifdef Linux}
  seObsPtNoChanged(Sender, 1);
{$else}
  seObsPtNoChange(Sender);
{$endif}
  Language;
end;
//----------------------------------------------------------
procedure TPositionInfo.ed_NumLayerChange(Sender: TObject);
begin
end;
//----------------------------------------------------------
procedure TPositionInfo.ed_NumBorderChange(Sender: TObject);
begin

end;
//----------------------------------------------------------
procedure TPositionInfo.ed_z_borderExit(Sender: TObject);
begin
  dumint := seBorderNumber.Value;
  z_border[dumint] := StrToFloat(ed_z_border.Text);
end;
//----------------------------------------------------------
procedure TPositionInfo.ed_NumObsChange(Sender: TObject);
begin
end;
//----------------------------------------------------------
procedure TPositionInfo.ed_ObsPtNoChange(Sender: TObject);
begin
end;
//----------------------------------------------------------
function TPositionInfo.Suffix(i: Integer): String ;
begin
  Case i of
  0..1: Result := 'st';
  2: Result := 'nd';
  3: Result := 'rd';
  else
    Result := 'th';
  end;
end;
//----------------------------------------------------------
procedure TPositionInfo.ed_z_obsChange(Sender: TObject);
begin
  dumint := seObsPtNo.Value;
  if ed_z_obs.Text = '' then
    Exit;
  z_obs[dumint] := StrToFloat(ed_z_obs.Text);
end;
//--------------------------------------------------------------
procedure TPositionInfo.ExecuteClick(Sender: TObject);
begin
  DialogBox := 0;
  Close;
end;
//----------------------------------------------------------
procedure TPositionInfo.BackClick(Sender: TObject);
begin
  GoAhead := False;
  if Mode = 2 then
    DialogBox := 11
  else
    DialogBox := 1;
  Close;
end;
//----------------------------------------------------------
procedure TPositionInfo.NextClick(Sender: TObject);
begin
  GoAhead := True;
  DialogBox := 3;
  Close;
end;
//----------------------------------------------------------
procedure TPositionInfo.FormClose(Sender: TObject;
  var Action: TCloseAction);
var i: Integer;
begin
  ed_z_borderExit(Sender);
  /// Space Discretization ///
  z_lb := StrToFloat(ed_z_lb.Text);
  z[1] := StrToFloat(ed_dz_top.Text);
  dz_bot := StrToFloat(ed_dz_bot.Text);
  if NumLayer > 1 then
    for i := 1 to NumLayer - 1 do
      if z_border[i] = 0 then
        begin
        ShowMessage('Please input depth of ' + IntToStr(i) + Suffix(i) + ' border.');
        DialogBox := 2;
        Exit
        end;
  for i := 1 to NumObs do
    if z_obs[i] = 0 then
      begin
      ShowMessage('Please input depth of ' + IntToStr(i) + Suffix(i) + ' observation point.');
      DialogBox := 2;
      end;
  if NumLayer = 1 then z_border[1] := z_lb;
end;
//===============================================================================================================================
procedure TPositionInfo.Language;
var
  IniFile: TIniFile;
  S, ResourceFileName: String;
begin
  S := Self.Name;
  ResourceFileName := ChangeFileExt(Application.ExeName, '.lng');
  Font.Assign(Main.Font);
  if FileExists(ResourceFileName) then
  begin
    IniFile := TIniFile.Create(ResourceFileName);
    with IniFile do
      try
        Caption     := ReadString(S, 'PositionInfo.Caption', '');
        GroupBox2.Caption        := ReadString(S, 'GroupBox2.Caption', '');
        Label2.Caption           := ReadString(S, 'Label2.Caption', '');
        Label3.Caption           := ReadString(S, 'Label3.Caption', '');
        Label4.Caption           := ReadString(S, 'Label4.Caption', '');
        Panel1.Caption           := ReadString(S, 'Panel1.Caption', '');
        Execute.Caption          := ReadString(S, 'Execute.Caption', '');
        Back.Caption             := ReadString(S, 'Back.Caption', '');
        Next.Caption             := ReadString(S, 'Next.Caption', '');
        GroupBox1.Caption        := ReadString(S, 'GroupBox1.Caption', '');
        Label1.Caption           := ReadString(S, 'Label1.Caption', '');
        Label6.Caption           := ReadString(S, 'Label6.Caption', '');
        Label5.Caption           := ReadString(S, 'Label5.Caption', '');
        GroupBox3.Caption        := ReadString(S, 'GroupBox3.Caption', '');
        Label8.Caption           := ReadString(S, 'Label8.Caption', '');
        Label9.Caption           := ReadString(S, 'Label9.Caption', '');
        Label10.Caption          := ReadString(S, 'Label10.Caption', '');
      finally
        Free;
      end;
  end;
  if LANG = 128 then
  begin
    Label5.Visible := False;
    seBorderNumber .Left := 20;
    seNumLayer.Left := Label1.Left + label1.Width + 5  ;
    seObsptNo.Left := 20;
    ed_z_border.Left := Label6.Left + Label6.Width + 4;
    Label10.Visible := False;
    seNumObs.Left := Label8.Left + Label8.Width + 10 ;
    ed_z_obs.Left := Label9.Left + Label9.Width + 2;
    GroupBox1.Width := ed_z_border.Left + ed_z_border.Width + 24;
  end;
  ed_dz_bot.Left := Label4.Left + Label4.Width + 5;
  ed_z_lb.Left   := ed_dz_bot.Left;
  ed_dz_top.Left := ed_dz_bot.Left;
  GroupBox2.Width := GroupBox1.Width;
  GroupBox3.Width := GroupBox1.Width;
  Width := GroupBox1.Width + GroupBox1.Left * 2;
  Panel1.Left := (Width - Panel1.Width) div 2;
end;


{$ifdef Linux}
procedure TPositionInfo.seNumLayerChanged(Sender: TObject; NewValue: Integer);
{$else}
procedure TPositionInfo.seNumLayerChange(Sender: TObject);
{$endif}
begin
  try
    NumLayer := seNumLayer.Value;
  except
    Exit;
  end;
{$ifdef Linux}
  seBorderNumber.Max := NumLayer - 1;
{$else}
  seBorderNumber.MaxValue := NumLayer - 1;
{$endif}
  if NumLayer = 1 then
  begin
    seBorderNumber.Enabled := False;
    ed_z_border.Enabled  := False;
    z_border[1] := z_lb;
  end
  else
  begin
    seBorderNumber.Enabled := True;
    ed_z_border.Enabled  := True;
  end;
  ed_NumBorderChange(Sender);
end;

{$ifdef Linux}
procedure TPositionInfo.seBorderNumberChanged(Sender: TObject; NewValue: Integer);
{$else}
procedure TPositionInfo.seBorderNumberChange(Sender: TObject);
{$endif}
begin
  try
    dumint := seBorderNumber.Value;
  except
    Exit;
  end;
  if dumint > NumLayer - 1 then dumint := NumLayer - 1;
  if LANG = 1 then
    Label5.Caption := Suffix(dumint) + ' border =';
  ed_z_border.Text := FloatToStr(z_border[dumint]);
end;

{$ifdef Linux}
procedure TPositionInfo.seNumObsChanged(Sender: TObject; NewValue: Integer);
{$else}
procedure TPositionInfo.seNumObsChange(Sender: TObject);
{$endif}
begin
  try
    NumObs := seNumObs.Value;
  except
    Exit;
  end;
  {$ifdef Linux}
  seObsPtNo.Max := NumObs;
  {$else}
  seObsPtNo.MaxValue := NumObs;
  {$endif}
  if NumObs = 1 then
    seObsPtNo.Enabled := False
  else
    seObsPtNo.Enabled := True;
end;

{$ifdef Linux}
procedure TPositionInfo.seObsptNoChanged(Sender: TObject; NewValue: Integer);
{$else}
procedure TPositionInfo.seObsptNoChange(Sender: TObject);
{$endif}
begin
  dumint := 1;
  try
    dumint := seObsPtNo.Value;
  except
    Exit;
  end;
  if dumint > NumObs then dumint := NumObs;
  if LANG = 1 then
    Label10.Caption := Suffix(dumint) + ' observation point =';
  if z_obs[dumint] > 0 then
    ed_z_obs.Text := FloatToStr(z_obs[dumint])
  else
    ed_z_obs.Text := '1';
end;

end.
