{
_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/

        WASH_1D version 1.36

        Copyright(C) 2000-2004 Haruyuki FUJIMAKI and Mitsuhiro INOUE
        fujimaki@sakura.cc.tsukuba.ac.jp
        URL: http://www.geocities.jp/fujimaki691202/
        Distributed under the GPL

_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/
}

unit RC_Params;

interface

uses
{$ifdef Linux}
  SysUtils, Classes, QGraphics, QControls, QForms, 
  QDialogs, QStdCtrls, QExtCtrls, QGrids, QButtons, 
  QComCtrls, QMenus, Math, IniFiles, QPrinters, Qt, Dialogs, Spin,
  StdCtrls, Controls, ComCtrls, ExtCtrls, Buttons;
{$else}
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls, Grids, jpeg, Buttons, ComCtrls, Menus, Math, IniFiles, Registry, Spin, {$WARN UNIT_PLATFORM OFF}FileCtrl{$WARN UNIT_PLATFORM ON};
{$endif}

type
  TSoil = class(TForm)
    Panel1: TPanel;
    Execute: TButton;
    Back: TButton;
    Next: TButton;
    Image1: TImage;
    Image2: TImage;
    Edit1: TEdit;
    Edit2: TEdit;
    Edit3: TEdit;
    Edit4: TEdit;
    Edit5: TEdit;
    Edit6: TEdit;
    Edit7: TEdit;
    Image3: TImage;
    Label1: TLabel;
    Edit8: TEdit;
    Label2: TLabel;
    Edit9: TEdit;
    Label3: TLabel;
    Edit10: TEdit;
    Label4: TLabel;
    Label5: TLabel;
    BitBtn1: TBitBtn;
    StatusBar1: TStatusBar;
    BitBtn2: TBitBtn;
    OpenDialog1: TOpenDialog;
    Label6: TLabel;
    cbRF: TComboBox;
    Label7: TLabel;
    CheckBox1: TCheckBox;
    CheckBox2: TCheckBox;
    CheckBox3: TCheckBox;
    Label8: TLabel;
    Panel2: TPanel;
    CheckBox4: TCheckBox;
    Label9: TLabel;
    Edit11: TEdit;
    Edit12: TEdit;
    Edit13: TEdit;
    Edit14: TEdit;
    Edit15: TEdit;
    Label10: TLabel;
    Label11: TLabel;
    Panel3: TPanel;
    seLayerNumber: TSpinEdit;
    CheckBox5: TCheckBox;
    procedure ExecuteClick(Sender: TObject);
    procedure BackClick(Sender: TObject);
    procedure NextClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure cbRFClick(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure BitBtn1Click(Sender: TObject);
    procedure BitBtn2Click(Sender: TObject);
    procedure ed_NumLayerChange(Sender: TObject);
    procedure cbRFChange(Sender: TObject);
    procedure FormKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure CheckBox2Click(Sender: TObject);
    procedure Panel2Click(Sender: TObject);
    procedure CheckBox4Click(Sender: TObject);
    procedure FormShow(Sender: TObject);
    {$ifdef Linux}
    procedure seLayerNumberChanged(Sender: TObject; NewValue: Integer);
    {$else}
    procedure seLayerNumberChange(Sender: TObject);
    {$endif}
  private
    procedure GetParameters;
    procedure ShowEquation;
    procedure Language;
    procedure SetProperty_of_RetCurveFig(layer: Integer; FileName: String);
    function  SetLengthRJ(S: String; i: Shortint): String;
  public
    Modified, Mode, water, NumLayer, ShowMode, num_add_ret_data :Shortint;
    WsatFix, LlambdaFix, zetafix, spFix, WrFix, IPET_type, Independent, Linked_m: Shortint;
    num_ret_data                                                : Integer;
    DialogBox, heat : Shortint;
    CaseName, ExePath, BaseDir: String;
    SoilName, SoilComment: array[1..5] of String;
    RF, KF : array[1..5] of Shortint;
    Tref, Llambda, LogOfLlambda                              : array[1..5] of Double;
    Wsat, zeta, Wr                                                          : array[1..5] of Double;
    alpha, np, mp, sp, alpha1, np1, alpha2, np2, mp1, mp2          : array[-5..5] of Double;  //-5
    Ksat, ak, bk, ck                                                  : array[1..5] of Double;
    a_tau, b_tau, c_tau, d_tau, dispersivity                                                : array[1..5] of Double;
    Akh, Bkh, Ckh, Dkh, Ekh, AlbedoMax, AlbedoMin, Aal, Bal, ThickAlb, Aen, Ben, Cen, Den, Een : array[1..5] of Double;
    GoAhead : Boolean;
    t_unit, LANG: Integer;
    fl_retention, VirtualFile, Slash, MyDocDir: String;
    Cwsat: Double;
    function Water_Content(P, T, Wsat, zeta, Wr: Double; j: Integer; Drying: Boolean): Double;
    function Pressure_Head(W, T, Wsat, zeta, Wr: Double; j: Integer; Drying: Boolean): Double;
    function Water_Capacity(P, T, Wsat, zeta, Wr: Double; j: Integer; Drying: Boolean): Double;
    function HydraulicConductivity(W, T: Double; j: Integer): Double;
    procedure LoadSoilProperty(j: Shortint);
    procedure SaveSoilProperty(j: Shortint; WriteOnFile: Boolean);
    procedure Initialize;
  end;

var
  Soil: TSoil;
  j : Shortint;
  dumstr: String;
  dumint: Integer;
  AllowModified : Boolean;
  Msg: Array[1..20] of String;
  MLB: Boolean = False;//True; // for fingering study

implementation

uses FigFileMaker;

{$R *.xfm}

//------------------------------------------------------
procedure TSoil.FormCreate(Sender: TObject);
begin
  Initialize;
end;

procedure TSoil.Initialize;
var i: Integer;
{$ifdef MSWINDOWS}
  Reg: TRegistry;
{$endif}
begin
  AllowModified := False;
  Mode := 1; water := 1; NumLayer := 1; t_unit := 3600;
  ShowMode := 0;
  num_ret_data := 0; num_add_ret_data := 0;
  WsatFix := 1; LlambdaFix := 1; spFix := 1; WrFix := 1; heat := 1;
  ExePath := ExtractFileDir(Application.ExeName);
  {$ifdef Linux}
  BaseDir := GetEnvironmentVariable('HOME') + '/.' + ExtractFileName(Application.ExeName);
  {$endif}
  SoilName[1] := ''; SoilComment[1] := '';
  RF[1] := 2;
  Wsat[1] := 0.4; zeta[1] := 0.1; Wr[1] := 0.02;
  Tref[1] := 298.2; Llambda[1] := 10000000;
  alpha[1] := 0.01 ; np[1] := 1.5 ; mp[1] := 0.3333;
  alpha[-1] := 0.02; np[-1] := 1.5; mp[-1] := 0.3333;
  sp[1] := 1 ; alpha1[1]  := 0.01 ; np1[1]  := 1.5 ; alpha2[1]  := 0.001 ; np2[1]  := 1.5 ; mp1[1]  := 0.3333; mp2[1]  := 0.3333;
  sp[-1]:= 1 ; alpha1[-1] := 0.02 ; np1[-1] := 1.5 ; alpha2[-1] := 0.001 ; np2[-1] := 1.5 ; mp1[-1] := 0.3333; mp2[-1] := 0.3333;
  fl_retention := '';
  Independent := 1;
  Linked_m := 0;
  LANG := 1;
  Cwsat := 0.0001; // 0.000001;
  DialogBox := -1;
  for i := 1 to 5 do
  begin
    RF[i] := 1;
    KF[i] := 1;
  end;
  {$ifdef Linux}
  MyDocDir := GetEnvironmentVariable('HOME');
  Slash := '/';
  {$else}
  Reg := TRegistry.Create;
  with Reg do
  try
    RootKey := HKEY_CURRENT_USER;
    OpenKey('Software\Microsoft\Windows\CurrentVersion\Explorer\Shell Folders', False);
    MyDocDir := ReadString('Personal') + '\';// lpszPath; // Modified 02/01/05
    CloseKey;
  finally
    Free;
  end;
  Slash := '\';
  {$endif}
  Msg[1] := '&Execute';
  Msg[2] := '&Next >>';
  Msg[3] := '<< &Back';
  Msg[4] := 'Results of parameter estimation';
  Msg[5] := '&Figure';
  Msg[6] := '&O K';
  Msg[7] := '&Print';
  Msg[8] := '&Cancel';
  Msg[9] := 'Please select file which holds properties of the soil';
  Msg[10]:= 'Soil water retension curve of ';
  Msg[11]:= '  V.W.C.  presure head(cm)     Kdry(cm/s)     Kwet(cm/s)';
  Msg[12]:= '[r][b]Fig.2[ ]  Soil water retention curve of ';
  Msg[13]:= '\n';
  Msg[14]:= 'Volumetric water content [s]q[a] (cm[^]3[-]/cm[^]3[-])\n';
  Msg[15]:= 'Pressure head [s][~]y[a][.](cm)\n';
  Msg[16]:= 'Additional \n';
end;

procedure TSoil.FormShow(Sender: TObject);
var i: Integer;
begin
  StatusBar1.Visible := False;
  if Mode = 1 then
    dumstr := 'Are properties of the soil already held in a file?'
  else
    dumstr := 'Do you use parameters of other soil for initial value?';
  if (CaseName = BaseDir + Slash + 'Untitled') and (SoilName[1] = '') then
  begin
    if water = 1 then
      {$ifdef Linux}
      if Application.MessageBox(PChar(dumstr), 'If datafile of the soil is already prepared in "SoilProperties"folder, press [(Y)] button.',
                                [smbYes, smbNo])
        = smbYes then
      {$else}
      if Application.MessageBox(PChar(dumstr), 'If datafile of the soil is already prepared in "SoilProperties"folder, press [(Y)] button.',
                                MB_YESNO +MB_ICONQUESTION)
        = IDYES then
      {$endif}
      begin
        OpenDialog1.InitialDir := ExePath + Slash + 'SoilProperties';
        if OpenDialog1.Execute = true then
          for i := 1 to NumLayer do
          begin
            SoilName[i] := ExtractFileName(ChangeFileExt(OpenDialog1.FileName, ''));
            LoadSoilProperty(i);
          end;
      end;
   end;
  if NumLayer = 1 then
  begin
    Label6.Visible := False;
    seLayerNumber.Visible := False;
    Label7.Top := 30;
    cbRF.Top := 46;
  end
  else
  begin
    Label7.Top := 48;
    cbRF.Top := 64;
  //  for i := 2 to NumLayer do RF[i] := 1;
  end;
  if (SoilName[1] = '') and (Mode = 2) then
  begin
    ShowMessage('Please input initial values of parameters to be estimated');
    StatusBar1.Visible := True;
    StatusBar1.SimpleText := 'Initial values of parameters to be estimated';
  end;
  if j = 0 then
    j := 1;
  if ShowMode = 1 then
  begin
    cbRF.Enabled  := False;
    Edit1.Enabled := False;
    Edit2.Enabled := False;
    Edit3.Enabled := False;
    Edit4.Enabled := False;
    Edit5.Enabled := False;
    Edit6.Enabled := False;
    Edit7.Enabled := False;
    Edit8.Enabled := False;
    Edit9.Enabled := False;
    Edit10.Enabled:= False;
    Edit11.Enabled:= False;
    Edit12.Enabled:= False;
    Edit13.Enabled:= False;
    Edit14.Enabled:= False;
    Edit15.Enabled:= False;
    StatusBar1.Visible := True;
    Execute.TabOrder := 0;
  end;
  if (Mode = 2) and (IPET_type <> 5) then
  begin
    Label8.Visible    := True;
    CheckBox1.Visible := True;
    CheckBox2.Visible := True;
    if RF[j] = 1 then
      CheckBox5.Visible := True
    else
      CheckBox5.Visible := False;
    if WsatFix = 1 then
      CheckBox1.Checked := True;
    if (LlambdaFix = 1) or (spFix = 1) then
      CheckBox2.Checked := True;
    if WrFix   = 1 then
      CheckBox3.Checked := True;
    if ZetaFix = 1 then
      CheckBox5.Checked := True
    else
      CheckBox5.Checked := False;
  end
  else
  begin
    Label8.Visible    := False;
    CheckBox1.Visible := False;
    CheckBox2.Visible := False;
    CheckBox3.Visible := False;
    CheckBox5.Visible := False;
  end;
  seLayerNumber.Value := j;
{$ifdef Linux}
  seLayerNumber.Max := NumLayer;
{$else}
  seLayerNumber.MaxValue := NumLayer;
{$endif}
  if Mode = 2 then
  begin
    if (IPET_type <> 1) and (IPET_type <> 5) and (Independent <> 1)then
    begin
      RF[1] := 2;
      cbRF.Enabled := False;
      Edit2.Enabled := False;
      Edit5.Enabled := False;
      Edit6.Enabled := False;
      CheckBox2.Enabled := False;
      if sp[1] <> 1 then
      begin
        sp[1] := 1;
        ShowMessage('Only van Genuchten - Mualem soil hydraulic relationship is allowed for simultaneous estimation of hydraulic properties.');
      end;
    end;
  end;
  CheckBox4Click(Sender);               
  ShowEquation;
  Language;
  AllowModified := True;
end;
//------------------------------------------------------
procedure TSoil.ExecuteClick(Sender: TObject);
begin
  DialogBox := 0; Close;
end;
//------------------------------------------------------
procedure TSoil.BackClick(Sender: TObject);
begin
  if ShowMode > 0 then
    BitBtn1Click(Sender)
  else
  begin
    GoAhead := False;
    DialogBox := 2;
    Close;
  end;
end;
//------------------------------------------------------
procedure TSoil.NextClick(Sender: TObject);
begin
  case ShowMode of
  0:begin
      GoAhead := True;
      DialogBox := 4;
      Close;
    end;
  1:begin
    {$ifdef Linux}
    Printer.ExecuteSetup;
    {$else}
    //if PrintDialog.Execute then
      Print;
    {$endif}
    end;
  2:Close;
  end;
end;
//------------------------------------------------------

procedure TSoil.cbRFClick(Sender: TObject);
begin
  Case cbRF.itemindex of
    0: RF[j] := 1;
    1: RF[j] := 2;
  end;
  ShowEquation;
end;
//------------------------------------------------------
procedure TSoil.ShowEquation;
var dumstr2: string;
begin
  dumstr := '';
  cbRF.itemindex := RF[j] - 1;
  if Tref[j] = 0 then
    Tref[j] := 298.2;
  case RF[j] of
  1:begin
      dumstr  := 'TrueRet.jpg';
      dumstr2 := 'mS params0.jpg';
      if np[j] = 0 then
        np[j] := 2;
      Edit2.Text := Copy(FloatToStr(zeta[j]), 1, 8);
      Edit3.Text := Copy(FormatFloat('0.######', alpha[j]), 1, 8);
      Edit4.Text := Copy(FloatToStr(np[j]), 1, 8);
      Edit5.Text := Copy(FloatToStr(Llambda[j]), 1, 8);
      Edit6.Text := Copy(FloatToStr(mp[j]), 1, 8);
      Edit12.Text :=  Copy(FloatToStr(alpha[-j]), 1, 8);
      Edit13.Text :=  Copy(FloatToStr(np[-j]), 1, 8);
      Edit15.Text := Copy(FloatToStr(mp[-j]), 1, 8);
      if Linked_m = 1 then
      begin
        CheckBox4.Checked := True;
        Edit6.Visible     := False;
        Label9.Visible    := False;
      end
      else
      begin
        CheckBox4.Checked := False;
        Label9.Visible    := True;
      end;
      Edit7.Visible := False;
      Edit11.Visible := False;
      Edit14.Visible := False;
      CheckBox4.Visible := True;
      CheckBox5.Visible := True;
      if Mode = 2 then
      begin
        CheckBox2.Top := 248;
        CheckBox3.Visible := False;
      end;
    end;
  2:begin
      dumstr  := 'bimodal RF0.jpg';
      dumstr2 := 'BRF params0.jpg';
      Edit6.Visible := True;
      Edit7.Visible := True;
      Edit11.Visible :=  True;
      Edit14.Visible :=  True;
      if np1[j] = 0 then np1[j] := 2;
      if np2[j] = 0 then np2[j] := 2;
      if sp[j]  = 0 then sp[j] := 1;
      Edit2.Text := Copy(FloatToStr(sp[j]), 1, 8);
      Edit3.Text := Copy(FloatToStr(alpha1[j]), 1, 8);
      Edit4.Text := Copy(FloatToStr(np1[j]), 1, 8);
      Edit5.Text := Copy(FormatFloat('0.#####', alpha2[j]), 1, 8);
      Edit6.Text := Copy(FloatToStr(np2[j]), 1, 8);
      Edit11.Text :=  Copy(FloatToStr(sp[-j]), 1, 8);
      Edit12.Text :=  Copy(FloatToStr(alpha1[-j]), 1, 8);
      Edit13.Text :=  Copy(FloatToStr(np1[-j]), 1, 8);
      Edit14.Text :=  Copy(FormatFloat('0.#####', alpha2[-j]), 1, 8);
      Edit15.Text :=  Copy(FloatToStr(np2[-j]), 1, 8);
      Edit7.Text :=  Copy(FloatToStr(Wr[j]), 1, 8);
      CheckBox4.Visible := False;
      CheckBox5.Visible := False;
      Label9.Visible    := False;
      if Mode = 2 then
      begin
        CheckBox2.Top := 148;
        CheckBox3.Visible := True;
      end;
    end;
  end;
  dumstr  := ExePath + Slash + 'Equations' + Slash + dumstr;
  dumstr2 := ExePath + Slash + 'Equations' + Slash + dumstr2;
  image1.picture.loadfromfile(dumstr);
  image2.picture.loadfromfile(dumstr2);
  dumstr := ExePath + Slash + 'Equations' + Slash + 'RC params0.jpg';
  image3.picture.loadfromfile(dumstr);
  Edit1.Text := Copy(FloatToStr(Wsat[j]), 1, 8);
  Edit8.Text := FloatToStr(Tref[j]-273.2);
  Edit9.Text := SoilName[j];
  Edit10.Text :=  SoilComment[j];
  if Edit7.Visible then
    Panel3.Visible := False
  else
    Panel3.Visible := True;
  if (Mode = 2) and (IPET_type <> 3) and (IPET_type <> 5) then
  begin
    Label11.Visible := False;
    Edit11.Visible := False;
    Edit12.Visible := False;
    Edit13.Visible := False;
    Edit14.Visible := False;
    Edit15.Visible := False;
  end;
end;
//----------------------------------------------------------
procedure TSoil.BitBtn1Click(Sender: TObject);
begin
  GetParameters;
  dumint := j;
  if Mode = 2 then
    dumint := 1;
  SetProperty_of_RetCurveFig(dumint, CaseName + '_RetCurve');
end;
//----------------------------------------------------------
procedure TSoil.GetParameters;
begin
  Wsat[j]  := StrToFloat(Edit1.Text);
  Tref[j]  := StrToFloat(Edit8.Text) + 273.2;
  SoilName[j]    := Edit9.Text;
  SoilComment[j] := Edit10.Text;
  Case RF[j] of
    1:begin
        zeta[j]  := StrToFloat(Edit2.Text);
        alpha[j]  := StrToFloat(Edit3.Text);
        np[j]     := StrToFloat(Edit4.Text);
        Llambda[j]  := StrToFloat(Edit5.Text);
        LogOfLlambda[j] := ln(Llambda[j]);
        if Linked_m = 1 then
          mp[j] := 1 - 1 / np[j]
        else
          mp[j] := StrToFloat(Edit6.Text);
        if(Mode <> 2) or (IPET_type = 3) or (IPET_type = 5) then
        begin
          alpha[-j]  := StrToFloat(Edit12.Text);
          np[-j]     := StrToFloat(Edit13.Text);
          if Linked_m = 1 then
            mp[-j] :=  1 - 1 / np[-j]
          else
            mp[-j] :=  StrToFloat(Edit15.Text);
        end;
      end;
    2:begin
        sp[j]     := StrToFloat(Edit2.Text);
        alpha1[j] := StrToFloat(Edit3.Text);
        np1[j]    := StrToFloat(Edit4.Text);
        alpha2[j] := StrToFloat(Edit5.Text);
        np2[j]    := StrToFloat(Edit6.Text);
        Wr[j]     := StrToFloat(Edit7.Text);
        if MLB then
        begin
          mp1[j] := 1;
          mp2[j] := 1;
        end
        else
        begin
          mp1[j] := 1 - 1 / np1[j];
          mp2[j] := 1 - 1 / np2[j];
        end;
        if(Mode <> 2) or (IPET_type = 5) then
        begin
          alpha2[-j] :=  StrToFloat(Edit14.Text);
          alpha1[-j] :=  StrToFloat(Edit12.Text);
          sp[-j]    := StrToFloat(Edit11.Text);
          np1[-j]   := StrToFloat(Edit13.Text);
          np2[-j]   := StrToFloat(Edit15.Text);
          mp1[-j] :=  1 - 1 / np1[-j];
          mp2[-j] :=  1 - 1 / np2[-j];
        end;
      end;
  end;
end;
//------------------------------------------------------
procedure TSoil.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  if Mode = 2 then
  begin
    if CheckBox1.Checked = True then
      WsatFix := 1
    else
      WsatFix := 0;
    if CheckBox2.Checked = True then
      if RF[j] = 1 then
        LlambdaFix := 1
      else
        spFix := 1
    else
    begin
      LlambdaFix := 0;
      spFix   := 0;
    end;
    if CheckBox3.Checked = True then
      WrFix   := 1
    else
      WrFix   := 0;
    if CheckBox5.Checked = True then
      ZetaFix := 1
    else
      ZetaFix := 0;
  end;
  GetParameters;
end;
//----------------------------------------------------------
procedure TSoil.BitBtn2Click(Sender: TObject);
begin
  ShowMessage(Msg[9]);
  OpenDialog1.InitialDir := ExePath + Slash + 'SoilProperties';
  OpenDialog1.FileName   := 'Please double-click the file above.';
  if OpenDialog1.Execute = True then
    SoilName[j] := ExtractFileName(ChangeFileExt(OpenDialog1.FileName, ''));
  LoadSoilProperty(j);
  FormShow(Sender);
end;
//----------------------------------------------------------
procedure TSoil.ed_NumLayerChange(Sender: TObject);
begin
end;
//----------------------------------------------------------
procedure TSoil.cbRFChange(Sender: TObject);
begin
  RF[j] := cbRF.ItemIndex + 1;
  ShowEquation;
end;
//----------------------------------------------------------
procedure TSoil.CheckBox2Click(Sender: TObject);
begin
end;
//----------------------------------------------------------
procedure TSoil.CheckBox4Click(Sender: TObject);
begin
  if (CheckBox4.Checked = True) then//and (RF[j] = 2) then
  begin
    Linked_m := 1;
    Edit6.Visible  := False;
    Edit15.Visible  := False;
    Label9.Visible := False;
  end
  else
  begin
    Linked_m := 0;
    Edit6.Visible  := True;
    Edit15.Visible  := True;
    Label9.Visible := True;
  end;
  if RF[j] = 2 then
    Edit15.Visible  := True;
  Edit6.Text  := Copy(FloatToStr(mp[j]), 1, 8);
  Edit15.Text := Copy(FloatToStr(mp[-j]), 1, 8);
end;
//===============================================================================================================================
procedure TSoil.Language;
var
{$ifdef MSWINDOWS}
  adjuster : Double;
{$endif}
  i : Shortint;
  IniFile: TIniFile;
  S, ResourceFileName: String;
{$ifdef Linux}
  function ConvertToCLXcharset(i: Integer): TFontCharset;
  begin
    Case i of
    0  : Result := fcsDefaultCharSet;
    128: Result := fcsSet_Ja;
    else Result := fcsDefaultCharSet;
    end;
  end;
{$endif}
begin
  S := Self.Name;
  ResourceFileName := ChangeFileExt(Application.ExeName, '.lng');
  if FileExists(ResourceFileName) then
  begin
    IniFile := TIniFile.Create(ResourceFileName);
    with IniFile do
      try
        Caption            := ReadString(S, 'Caption', '');
        Label1.Caption     := ReadString(S, 'Label1.Caption', '');
        Label2.Caption     := ReadString(S, 'Label2.Caption', '');
        Label3.Caption     := ReadString(S, 'Label3.Caption', '');
        Label4.Caption     := ReadString(S, 'Label4.Caption', '');
        Label5.Caption     := ReadString(S, 'Label5.Caption', '');
        Label6.Caption     := ReadString(S, 'Label6.Caption', '');
        Label7.Caption     := ReadString(S, 'Label7.Caption', '');
        Label8.Caption     := ReadString(S, 'Label8.Caption', '');
        BitBtn1.Hint       := ReadString(S, 'BitBtn1.Hint', '');
        CheckBox1.Hint     := ReadString(S, 'CheckBox1.Hint', '');
        CheckBox2.Hint     := ReadString(S, 'CheckBox2.Hint', '');
        CheckBox3.Hint     := ReadString(S, 'CheckBox3.Hint', '');
        Font.Name          := ReadString(S, 'Soil.Font.Name', '');
        Label9.Font.Name   := ReadString(S, 'Label9.Font.Name', '');
        i := cbRF.ItemIndex;
        cbRF.Items.Text    := StringReplace(ReadString(S, 'cbRF.Items.Text', ''), '<br>', #13#10, [rfReplaceAll, rfIgnoreCase]);
        cbRF.ItemIndex := i;
        for i := 1 to 17 do
          Msg[i] := StringReplace(ReadString(S, 'Msg' + IntToStr(i), ''), '<br>', #13#10, [rfReplaceAll, rfIgnoreCase]);
      finally
        Free;
      end;
  end;
{$ifdef Linux}
  Font.Charset := ConvertToCLXcharset(LANG);
  if LANG = 128 then
    Font.Size := 11;
{$else}
  Font.Charset := LANG;
{$endif}
  if LANG = 128 then
  begin
    {$ifdef MSWINDOWS}
    adjuster := Screen.Width / 1024.0;
    if GetDeviceCaps(Canvas.Handle, VERTSIZE) < 130 then
      Font.Size := Trunc(Font.Size * adjuster);
    {$endif}
    Edit8.Top := 338;
  end;
  case ShowMode of
  0:begin
      Execute.Caption  := Msg[1];
      Next.Caption     := Msg[2];
      Back.Caption     := Msg[3];
    end;
  1:begin
      StatusBar1.SimpleText := Msg[4];
      Back.Caption     := Msg[5];
      Execute.Caption  := Msg[6];
      Next.Caption     := Msg[7];
    end;
  2:begin
      Back.Caption     := Msg[5];
      Execute.Caption  := Msg[6];
      Next.Caption     := Msg[8];
    end
  end;
  CheckBox2.Hint := CheckBox1.Hint;
  CheckBox3.Hint := CheckBox1.Hint;
end;

procedure TSoil.FormKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
var dum: Double;
begin
{$ifdef Linux}
  if Key = Key_F2 then
{$else}
  if Key = VK_F2 then
{$endif}
  begin
    GetParameters;
    dum := StrToFloat(InputBox('Water content -> Pressure head', 'What is the water content?', '0.3'));
    dum := Pressure_Head(dum, Tref[j], Wsat[j], zeta[j], Wr[j], j, True);
    ShowMessage('Pressure head = ' + FloatToStr(dum));
  end;
end;
//----------------------------------------------------------
procedure TSoil.Panel2Click(Sender: TObject);
var dum: Double;
begin
  GetParameters;
  dum := StrToFloat(InputBox('Pressure head -> Water content', 'What is the pressure head?', '-1000'));
  dum := Water_Content(dum, Tref[j], Wsat[j], zeta[j], Wr[j], j, True);
  ShowMessage('Water content = ' + FloatToStr(dum));   
end;
//---------------------------------------------------------
procedure TSoil.LoadSoilProperty(j: Shortint);
var
  i: Integer;
  f: Textfile;
  Version: Single;
  SoilPropertyFile: String;
begin
  Version := 0;
  SoilPropertyFile := BaseDir + Slash + SoilName[j] + '.dat';
  if Slash = '' then
    Initialize;
  if FileExists(SoilPropertyFile) = False then
    SoilPropertyFile := ExePath + Slash  + 'SoilProperties' + Slash + SoilName[j] + '.dat';
  if not FileExists(SoilPropertyFile) then
  begin
    ShowMessage(Msg[9]);
    with OpenDialog1 do
    begin
      FileName   := 'Please double-click the file above.';
      InitialDir := ExePath + Slash + 'SoilProperties';
      if Execute = True then
      begin
        SoilName[j] := ExtractFileName(ChangeFileExt(OpenDialog1.FileName, ''));
        SoilPropertyFile := ExePath + Slash + 'SoilProperties' + Slash + SoilName[j] + '.dat';
      end
      else
        Exit;
    end;
  end;
  AssignFile(f, SoilPropertyFile);
  Reset(f);
  Readln(f, dumstr);
  i := Pos('version', dumstr);
  if i > 0 then
    Version := StrToFloat(Copy(dumstr, i + 7, 5));
  Readln(f, SoilComment[j]);
  for i := 1 to 2 do Readln(f, dumstr);
    Read(f, RF[j]);
  Case RF[j] of
  1:begin
      Read(f, Tref[j], Wsat[j], zeta[j], alpha[j], np[j], mp[j], Llambda[j]);
      if Version > 1.001 then
      begin
        Readln(f, dumstr);
        Read(f, alpha[-j], np[-j], mp[-j]);
      end
      else
      begin
        alpha[-j] := 2 * alpha[j];
        np[-j] := np[j];
        mp[-j] := mp[j];
      end;
     // mp[j] := mp[j]; // ? 1 - 1 / np[j];
      if Llambda[j] < 10000 then
        Llambda[j] := 10000000;
      LogOfLlambda[j] := ln(Llambda[j]);
    end;
  2:begin
      Read(f, Tref[j], Wsat[j], sp[j], alpha1[j], np1[j], alpha2[j], np2[j], Wr[j]);
      if Version > 1.001 then
      begin
        Readln(f, dumstr);
        Read(f, sp[-j], alpha1[-j], np1[-j], alpha2[-j], np2[-j]);
      end
      else
      begin
        sp[-j] := sp[j];
        alpha1[-j] := 2 * alpha1[j];
        np1[-j] := np1[j];
        alpha2[-j] := 2 * alpha2[j];
        np2[-j] := np2[j];
      end;
      if MLB then
      begin
        mp1[j] := 1;
        mp2[j] := 1;
      end
      else
      begin
        mp1[j] := 1 - 1 / np1[j];
        mp2[j] := 1 - 1 / np2[j];
      end;
      if (Mode <> 2) or (IPET_type = 4) then
      begin
        mp1[-j] :=  1 - 1 / np1[-j];
        mp2[-j] :=  1 - 1 / np2[-j];
      end;
    end;
  end;
  for i := 1 to 3 do Readln(f, dumstr);
  Read(f, KF[j]);
  if (KF[j] = 2) or (KF[j] = 3) then
    Read(f, Ksat[j], ak[j], bk[j])
  else
    Read(f, Ksat[j], ak[j], bk[j], ck[j]);
  for i := 1 to 3 do Readln(f, dumstr);
  if version < 1.35 then
    Read(f, a_tau[j], b_tau[j], dispersivity[j])
  else
    Read(f, a_tau[j], b_tau[j], c_tau[j], d_tau[j], dispersivity[j]);
  for i := 1 to 3 do Readln(f, dumstr);
  Read(f, Akh[j], Bkh[j], Ckh[j], Dkh[j], Ekh[j]);
  for i := 1 to 3 do Readln(f, dumstr);
  if Version > 0 then
    Read(f, AlbedoMax[j], AlbedoMin[j], Aal[j], Bal[j], ThickAlb[j])
  else
    Read(f, AlbedoMax[j], AlbedoMin[j], Aal[j], ThickAlb[j]);
  for i := 1 to 3 do Readln(f, dumstr);
  Read(f, Aen[j], Ben[j], Cen[j], Den[j], Een[j]);
  CloseFile(f);
  dumstr := ExtractFileName(SoilPropertyFile);
  SoilName[j] := Copy(dumstr,1,Length(dumstr)-4);
end;

procedure TSoil.SaveSoilProperty(j: Shortint; WriteOnFile: Boolean);
var SL: TStringList;
begin
  SL := TStringList.Create;
  try
    with SL do
    begin
      Add('>>>>>>>   Properties of Soil (version 1.40 format) <<<<<<<');
      Add(SoilComment[j]);
      Add('====  soil water retension curve  ====');
      Case RF[j] of
      1:begin
          Add('  RF  Tref   Wsat   zeta    alpha     n     m   Llambda');
          Add('  '+IntToStr(RF[j])+'   '+FloatToStr(Tref[j])+'  '+ FloatToStr(Wsat[j])+'   '+
              FloatToStr(zeta[j])+'  '+ FloatToStr(alpha[j])+'  '+FloatToStr(np[j])+'  '+FormatFloat('0.000', mp[j])+'  '+FloatToStr(Llambda[j]));
          Add('                         '+ FloatToStr(alpha[-j])+'  '+FloatToStr(np[-j])+'  '+FormatFloat('0.000', mp[-j]));
        end;
      2:begin
          Add('  RF   Tref   Wsat    s   alpha1   n1     alpha2   n2    Wr');
          Add('  '+IntToStr(RF[j])+'   '+FloatToStr(Tref[j])+'  '+ FloatToStr(Wsat[j])+'   '+
              FloatToStr(sp[j])+'   '+FloatToStr(alpha1[j])+'   '+FloatToStr(np1[j])+'    '+
              FloatToStr(alpha2[j])+'   '+FloatToStr(np2[j])+'   '+FloatToStr(Wr[j]));
          Add('                        '+FloatToStr(sp[-j])+'   '+FloatToStr(alpha1[-j])+'   '+FloatToStr(np1[-j])+'    '+
              FloatToStr(alpha2[-j])+'   '+FloatToStr(np2[-j]));
        end;
      end;
      Add('=====  Hydraulic Conductivity  =====');
      if (KF[j] = 2) or (KF[j] = 3) then
        begin
          Add('  KF   Ksat         ak       bk');
          Add('  '+IntToStr(KF[j])+'    '+FormatFloat('0.000000', Ksat[j])+'    '+FloatToStr(ak[j])+'    '+FloatToStr(bk[j]));
        end
      else
        begin
          Add('  KF   Ksat       ak       bk      ck');
          Add('  '+IntToStr(KF[j])+'    '+FloatToStr(Ksat[j])+'    '+FloatToStr(ak[j])+'    '+FloatToStr(bk[j])+'    '+FloatToStr(ck[j]));
        end;
      Add('=====  Solute Movement Property  =====');
      Add(' a_s    b_s    c_s    d_s    dispersivity');
      Add('  ' + FloatToStr(a_tau[j]) + '     ' + FloatToStr(b_tau[j]) + '     ' + FloatToStr(c_tau[j]) + '     ' + FloatToStr(d_tau[j]) + '     ' + FloatToStr(dispersivity[j]));
      Add('=====  Thermal Conductivity  =====');
      Add('  a_h      b_h      c_h      d_h      e_h');
      Add('  '+FloatToStr(Akh[j])+'    '+FloatToStr(Bkh[j])+'    '+FloatToStr(Ckh[j])+'    '+FloatToStr(Dkh[j])+'    '+FloatToStr(Ekh[j]));
      Add('=====  Albedo  =====');
      Add('  Max   Min    a_al   b_al  Walb');
      Add(' ' + FloatToStr(AlbedoMax[j]) + '   ' + FloatToStr(AlbedoMin[j]) + '   ' + FloatToStr(Aal[j]) + '   ' + FloatToStr(Bal[j]) + '   ' + FloatToStr(ThickAlb[j]));
      Add('=====  Enhancement Factor  =====');
      Add(' a_e   b_e   c_e   d_e   e_e');
      Add('  '+FloatToStr(Aen[j])+'   '+FloatToStr(Ben[j])+'   '+FloatToStr(Cen[j])+'   '+FloatToStr(Den[j])+'   '+FloatToStr(Een[j]));
      if WriteOnFile then
      begin
        SaveToFile(ExePath + Slash  + 'SoilProperties' + Slash + SoilName[j] + '.dat');
        if not DirectoryExists(BaseDir) then
          CreateDir(BaseDir);
        SaveToFile(BaseDir + Slash + SoilName[j] + '.dat');
      end
      else
        VirtualFile := SL.Text;
    end
  finally
    SL.Free;
  end;
end;

//----------------------------------------------------------
function TSoil.Pressure_Head(W, T, Wsat, zeta, Wr: Double; j: Integer; Drying: Boolean): Double;
var
  a, b, c, Accuracy, fa, fc: Double;
  i: Integer;
begin
  a := ln(10000000); 
  b := ln(0.1);
  c := 0;
  Accuracy := 0.00000001;
  fa := W - Water_Content(- exp(a), T, Wsat, zeta, Wr, j, Drying);
  for i := 1 to Trunc(ln(Abs(b - a) / Accuracy) / ln(2)) do
  begin
    c := (a + b) / 2;
    fc := W - Water_Content(- exp(c), T, Wsat, zeta, Wr, j, Drying);
    if fa * fc < 0 then
      b := c
    else
    begin
      a := c;
      fa := fc;
    end;
  end;
  Result := - exp(c);
end;
//----------------------------------------------------------

function TSoil.Water_Content(P, T, Wsat, zeta, Wr: Double; j: Integer; Drying: Boolean): Double;    // j is the layer number
var
  GAMMA, Teffect, dum: Double;
  i: Integer;
begin
  if Mode <> 2 then
    Teffect := exp(0.0068 * (T - Tref[j]))
  else
    Teffect := 1;
  if Drying then i := j else i := -j;
  if P < -0.0001 then
    Case RF[j] of
    1:begin
      dum := Power(1 + Power(Abs(alpha[i]) * Teffect * Llambda[j], np[i]), mp[i]);
      GAMMA  := (dum * Wsat - zeta) / (dum - 1 );
      Result :=  (GAMMA - zeta) / Power(1 + Power(Abs(alpha[i]) * Teffect * -P, np[i]), mp[i])
               - (GAMMA - zeta) / dum
               + zeta * (1 - Sqr(ln(-P * Teffect + 1) / LogOfLlambda[j]));
             // + zeta * (1 - ln(-P * Teffect + 1) / LogOfLlambda[j]);
      end;
    2:Result :=  Wr + sp[i] * (Wsat - Wr) / Power(1 + Power(Abs(alpha1[i]) * Teffect * -P, np1[i]), mp1[i]) +
                   (1 - sp[i]) * (Wsat - Wr) / Power(1 + Power(Abs(alpha2[i]) * Teffect * -P, np2[i]), mp2[i]);
    else
      Result := Wsat;
    end
  else
    Result := Wsat + Cwsat * P;   // fine tuning is required !
end;

{$WARNINGS OFF}
function TSoil.Water_Capacity(P, T, Wsat, zeta, Wr: Double; j: Integer; Drying: Boolean): Double;
var
  i: Integer;
  GAMMA, Teffect, dum: Double;
begin
  if Drying then i := j else i := -j;
  if heat = 1 then Teffect := exp(0.0068 * (T - Tref[j])) else Teffect := 1;
  if P < -0.0001 then
    Case RF[j] of
    1:begin
      dum := Power(1 + Power(Abs(alpha[i]) * Teffect * Llambda[j], np[i]), mp[i]);
      GAMMA := (dum * Wsat - zeta) / (dum - 1 );
      Result := mp[i] * (GAMMA - zeta) * Power(1 + Power(alpha[i] * Teffect * -P , np[i]), -mp[i] - 1) * np[i] * Power(alpha[i] * Teffect , np[i]) * Power( -P ,(np[i] - 1))
             + Teffect * zeta * 2 * ln(-Teffect * P + 1) / ((1 - Teffect * P) * Sqr(LogOfLlambda[j]));
            // + Teffect * zeta[i] / ((1 - Teffect * P) * LogOfLlambda[i]);
      end;
    2: Result :=       mp1[i] * sp[i] * (Wsat - Wr) * Power(1 + Power(alpha1[i] * Teffect * -P , np1[i]), -mp1[i] - 1) * np1[i] * Power(alpha1[i] * Teffect , np1[i]) * Power(-P , (np1[i] - 1))
               + mp2[i] * (1 - sp[i]) * (Wsat - Wr) * Power(1 + Power(alpha2[i] * Teffect * -P , np2[i]), -mp2[i] - 1) * np2[i] * Power(alpha2[i] * Teffect , np2[i]) * Power(-P , (np2[i] - 1));
    end
  else
    Result := Cwsat;  // fine tuning is required !
end;
{$WARNINGS ON}

function TSoil.HydraulicConductivity(W, T: Double; j: Integer): Double;
var
  Lgamma, Wrk: Double;
begin
  Result := 0;
  if MLB then
    Wrk := 0.07
  else
    Wrk := 0;

  if W > 0.002 then
    Case KF[j] of
    1:  Result := t_unit * Ksat[j] * Power((W - Wrk) / (Wsat[j] - Wrk), ak[j] * Sqr(W) + bk[j] * W + ck[j]);
    2:  Result := t_unit * Ksat[j] * exp(ak[j] * (1 / (1 + bk[j]) - 1 / (W / Wsat[j] + bk[j])));
    3:  begin
          Lgamma := (W - Wr[j]) / (Wsat[j] - Wr[j]);
          if Lgamma <= 1 then
            Result := t_unit * Ksat[j] * Power(Lgamma, ak[j]) * Sqr(1 - Power(1 - Power(Lgamma, 1 / bk[j]), bk[j]))
          else
            Result := t_unit * Ksat[j];
        end;
    4:  Result := t_unit * Ksat[j] * exp( -ak[j] * Power(1 - Power(W / Wsat[j], bk[j]), ck[j]));
    end
  else
    Result := 0;
  Result := Result * exp(2050 / Tref[j] - 7) / exp(2050 / T - 7);
end;

//----------------------------------------------------------
procedure TSoil.SetProperty_of_RetCurveFig(layer: Integer; FileName: String);
var
  i : Integer;
  f : TextFile;
  GX: array[0..100, 1..4] of Double;
  GY: array[0..100] of Double;
  IniFile: TIniFile;
  RetCurveFig : TXYGrapher;
  S: String;
begin
  IniFile := TIniFile.Create(MyDocDir + Slash + '.XYGrapher.ini');
  try
    IniFile.WriteInteger('Options', 'Height', 550);
    IniFile.WriteInteger('Options', 'Width' , 500);
  finally
    IniFile.Free;
  end;
  //--- Saving of Fitted Curve ---//
  GY[1] := -1;
  GX[1,1] := Wsat[layer];
  GX[1,2] := Wsat[layer];
  GX[1,3] := Ksat[layer];
  GX[1,4] := Ksat[layer];
  for i := 2 to 100 do
  begin
    GY[i] := - Power(10, 7 / 100 * i);
    GX[i,1] := Water_Content(GY[i], Tref[layer], Wsat[layer], zeta[layer], Wr[layer], layer, True);
    if i < 91 then
      GX[i,3] := HydraulicConductivity(GX[i,1], Tref[layer], layer) / t_unit;
    if (Mode <> 2) or (IPET_type = 3) or (IPET_type = 5) then
    begin
      GX[i,2] := Water_Content(GY[i], Tref[layer], Wsat[layer], zeta[layer], Wr[layer], layer, False);
      if i < 91 then
        GX[i,4] := HydraulicConductivity(GX[i,2], Tref[layer], layer) / t_unit;
    end;
  end;
  dumstr := ExePath + Slash + 'SoilProperties' + Slash + SoilName[layer];
  if DirectoryExists(dumstr) = False then
    CreateDir(dumstr);
  AssignFile(f, dumstr + Slash + SoilName[layer] + '_swrc.txt');
  Rewrite(f);
  if LANG = 128 then
    Writeln(f, SoilName[j] + Msg[10])
  else
    Writeln(f, Msg[10] + SoilName[j]);
  j := layer;
  Writeln(f, Soil.cbRF.Items[Soil.cbRF.ItemIndex]);
  Case RF[j] of
  1:begin
    Writeln(f, ' Tref   Wsat   zeta    alpha      n         m         Llambda');
    Writeln(f, '  '+FormatFloat('##0.0000', Tref[j])+'  '+ FormatFloat('##0.0000', Wsat[j])+'   '+
            FormatFloat('##0.0000', zeta[j])+'  '+ FormatFloat('##0.#######', alpha[j])+
            '  '+FormatFloat('##0.0000', np[j])+'  '+FormatFloat('##0.0000', mp[j])+'  '+ FormatFloat('########0', Llambda[j]));
    if (Mode <> 2) or (IPET_type = 3) or (IPET_type = 5)  then
      Writeln(f, 'wetting:            '+ FormatFloat('##0.0000', alpha[-j])+'  '+FormatFloat('##0.0000', np[-j])+'  '+FormatFloat('##0.0000', mp[-j]));
    end;
  2:begin
    Writeln(f, ' Tref   Wsat   s   alpha1   n1     alpha2   n2    Wr');
    Writeln(f, '   '+FloatToStr(Tref[j])+'  '+ FloatToStr(Wsat[j])+'   '+
        FloatToStr(sp[j])+'   '+FloatToStr(alpha1[j])+'   '+FloatToStr(np1[j])+'    '+
        FloatToStr(alpha2[j])+'   '+FloatToStr(np2[j])+'   '+FloatToStr(Wr[j]));
    if (Mode <> 2) or (IPET_type = 3) or (IPET_type = 5) then
      Writeln(f, 'wetting:     '+ FloatToStr(sp[-j])+'   '+FloatToStr(alpha1[-j])+'   '+FloatToStr(np1[-j])+'    '+FloatToStr(alpha2[-j])+'   '+FloatToStr(np2[-j]));
    end;
  end;
  Writeln(f, Msg[11]);
  if (Mode <> 2) or (IPET_type = 3) or (IPET_type = 5)  then
  begin
    for i := 1 to 100 do
      Writeln(f, '    ' + SetLengthRJ(FormatFloat('0.0000', GX[i,1]), 8) + '    ' + SetLengthRJ(FormatFloat('0.0000', GX[i,2]), 8) + '      ' + FormatFloat('########.0', GY[i]) + '    ' + SetLengthRJ(FormatFloat('0.000000000000', GX[i,3]), 13) + '    ' + SetLengthRJ(FormatFloat('0.000000000000', GX[i,4]), 13));
  end
  else
  begin
    for i := 1 to 100 do
      Writeln(f, '    ' + SetLengthRJ(FormatFloat('0.0000', GX[i,1]), 8) +  '      ' + FormatFloat('########.0', GY[i]) + '    ' + SetLengthRJ(FormatFloat('0.000000000000', GX[i,3]), 13));
  end;
  CloseFile(f);
  //---------------------------------
  RetCurveFig := TXYGrapher.Create;
  with RetCurveFig do
  begin
    if (Mode <> 2) or (IPET_type = 3) or (IPET_type = 5) then
      NumDataSeries := 2
    else
      NumDataSeries := 1;
    if num_ret_data > 0    then
      NumDataSeries := NumDataSeries + 1;
    if num_add_ret_data > 0 then
      NumDataSeries := NumDataSeries + 1;
    //----------
    DataSeries[1] := dumstr + Slash + SoilName[layer] + '_swrc.txt';
    if (Mode <> 2) or (IPET_type = 3) or (IPET_type = 5)then
      Yl[1] := 3
    else
      Yl[1] := 2;
    Xb[1] := 1; Xt[1] := 0; Yr[1] := 0; ReadStart[1] := 6; ReadEnd[1] := 0;
    LineStyle[1] := 1; LineWidth[1] := 0.25; LineColor[1] := 12615680; MarkStyle[1] := 0; MarkSize[1] := 0;
    Xmult[1] := 1; Xoffset[1] := 0; Ymult[1] := -1; Yoffset[1] := 0;
    if (Mode <> 2) or (IPET_type = 3) or (IPET_type = 5) then
    begin
      DataSeries[2] := DataSeries[1];
      Xb[2] := 2; Xt[2] := 0; Yl[2] := 3; Yr[2] := 0; ReadStart[2] := 6; ReadEnd[2] := 0;
      LineStyle[2] := 1; LineWidth[2] := 0.25; LineColor[2] := 16711680; MarkStyle[2] := 0; MarkSize[2] := 0;
      Xmult[2] := 1; Xoffset[2] := 0; Ymult[2] := -1; Yoffset[2] := 0;
    end;
    //----------
    if num_ret_data > 0 then
    begin
      if num_add_ret_data > 0 then
        i := NumDataSeries - 1
      else
        i := NumDataSeries;
      DataSeries[i] := CaseName + '_RetData.out';
      Xb[i] := 1; Xt[i] := 0; Yl[i] := 2; Yr[i] := 0; ReadStart[i] := 0; ReadEnd[i] := 0;
      LineStyle[i] := 0; LineWidth[i] := 0; LineColor[i] := 1; MarkStyle[i] := 1; MarkSize[i] := 1.5; MarkColor[i] := 16777215;
      Xmult[i] := 1; Xoffset[i] := 0; Ymult[i] := -1; Yoffset[i] := 0;
    end;
    //----------
    if num_add_ret_data > 0 then
    begin
      i := NumDataSeries;
      DataSeries[i] := fl_retention;
      Xb[i] := 1; Xt[i] := 0; Yl[i] := 2; Yr[i] := 0; ReadStart[i] := 0; ReadEnd[i] := 0;
      LineStyle[i] := 0; LineWidth[i] := 0; LineColor[i] := 1; MarkStyle[i] := 2; MarkSize[i] := 1.5; MarkColor[i] := 16777215;
      Xmult[i] := 1; Xoffset[i] := 0; Ymult[i] := -1; Yoffset[i] := 0;
    end;
    //----------
    Height := 65; Width := 65; Lmargin := 30; Tmargin := 20; FLineWidth := 0.4; NumFontSize := 9;
    NumFontName := 'Arial';
    dumint := Trunc(Wsat[j] * 10) + 1;
    Max[1] := 0.1 * dumint; Min[1] := 0; Division[1] := dumint; Minordivision[1] := 2; logarithm[1] := 0; NumeralsXshift[1] := 0; NumeralsYshift[1] := 0; ZeroLine[1] := 0;
    Max[2] := 0.1 * dumint; Min[2] := 0; Division[2] := dumint; Minordivision[2] := 2; logarithm[2] := 0; NumeralsXshift[2] := 0; NumeralsYshift[2] := 0; ZeroLine[2] := 0;
    Max[3] := 10000000; Min[3] := 1; Division[3] := 7; Minordivision[3] := 0; logarithm[3] := 1; NumeralsXshift[3] := 0; NumeralsYshift[3] := 0; ZeroLine[3] := 0;
    Max[4] := 10000000; Min[4] := 1; Division[4] := 7; Minordivision[4] := 0; logarithm[4] := 1; NumeralsXshift[4] := 0; NumeralsYshift[4] := 0; ZeroLine[4] := 0;
    NumLegend := 5;
    if num_ret_data > 0 then
      NumLegend := 6;
    if num_add_ret_data > 0 then
      NumLegend := 6;
    Legend[1] := Msg[12] + SoilName[j] + Msg[13];
    Legend[2] := Msg[14];
    Legend[4] := Msg[15];
    dumstr    := Msg[16];
    Legend[3] := '';
    Legend[5] := '';
    if IPET_type <> 3 then
      S := 'MSO'
    else
      S := 'MSI';
    if num_ret_data > 0 then
      if num_add_ret_data = 0 then
        Legend[6] := '%2 [1]' + S + '\n'
      else
        Legend[6] := '%' + IntToStr(NumDataSeries) + ' [1]' + dumstr + '%' + IntToStr(NumDataSeries - 1) + ' [1]' + S + '\n'
    else
      if num_add_ret_data > 0 then
        Legend[6] := '%2 [1]' + dumstr;
    LegendLspacing[1] := 4; LegendXshift[1] := 0; LegendYshift[1] := 0;
    LegendLspacing[2] := 0; LegendXshift[2] := 0; LegendYshift[2] := 0;
    LegendLspacing[3] := 0; LegendXshift[3] := 0; LegendYshift[3] := 0;
    LegendLspacing[4] := 0; LegendXshift[4] := 0; LegendYshift[4] := 0;
    LegendLspacing[5] := 0; LegendXshift[5] := 0; LegendYshift[5] := 0;
    LegendLspacing[6] := 5; LegendXshift[6] := 10; LegendYshift[6] := -25;
    SaveFigFile(FileName);
    ExecuteXYGrapher(FileName);
  end;
  RetCurveFig.Free;
end;
//----------------------------------------------------------
function TSoil.SetLengthRJ(S: String; i: Shortint): String;
var j: Shortint;
begin
  for j := 1 to i - Length(S) do
    S := ' '+ S;
  Result := S;
end;

{$ifdef Linux}
procedure TSoil.seLayerNumberChanged(Sender: TObject; NewValue: Integer);
{$else}
procedure TSoil.seLayerNumberChange(Sender: TObject);
{$endif}
begin
  if Edit1.Text <> '' then
    GetParameters;
  j := seLayerNumber.Value;
  if j < 1 then
    j := 1;
  if (j > 1) and (Wsat[j] < 0.1) then
    LoadSoilProperty(j);
  ShowEquation;
end;

end.
