{
_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/

        WASH_1D version 1.34

        Copyright(C) 2000-2003 Haruyuki FUJIMAKI and Mitsuhiro INOUE
        fujimaki@sakura.cc.tsukuba.ac.jp
        URL: http://homepage2.nifty.com/Fujimaki/
        Distributed under the GPL

_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/
}

unit Recent;

interface

uses
{$ifdef Linux}
  SysUtils, Classes, QGraphics, QControls, QForms, 
  QDialogs, QStdCtrls, QExtCtrls, QButtons, QComCtrls, IniFiles, ComCtrls,
  StdCtrls, Controls, ExtCtrls
  ;
{$else}
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls, Buttons, ComCtrls, IniFiles, {$Warnings off} FileCtrl, {$Warnings on}ShlObj;
{$endif}

type
  TRecentFile = class(TForm)
    ListBox1: TListBox;
    Panel1: TPanel;
    btnOpen: TButton;
    btnOther: TButton;
    btnNew: TButton;
    Memo1: TMemo;
    Label1: TLabel;
    btnAnime: TButton;
    Label2: TLabel;
    StatusBar1: TStatusBar;
    procedure btnOtherClick(Sender: TObject);
    procedure btnOpenClick(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure btnNewClick(Sender: TObject);
    procedure btnAnimeClick(Sender: TObject);
    procedure ListBox1KeyUp(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure ListBox1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  private
    procedure Language;
  public
    function SetLengthLJ(dumstr: String; dumint: Shortint): String;
    procedure SaveRecentFile;
  end;

var
  RecentFile: TRecentFile;
  Msg: array[1..3] of String;

implementation

uses WASH1dMAIN;

{$R *.xfm}
//----------------------------------------------------------
procedure TRecentFile.FormCreate(Sender: TObject);
var
  IniFile: TIniFile;
  i, j: Integer;
  f: Textfile;
  {$ifdef Linux}
  S: WideString;
  {$endif}
begin
  dumint := 0;
  IniFile := TIniFile.Create(ChangeFileExt(Application.ExeName, '.ini'));
  try
    if BaseDir = '' then
      BaseDir := Main.GetAbsoluteDirectory(ExeDir, IniFile.ReadString('Options', 'CurrentFolder', ''));
    if BaseDir = '' then
    begin
      BaseDir := MyDocDir + Slash + 'WASH_1D';
      CreateDir(BaseDir);
      ShowMessage(Msg[1]);
      {$IFDEF Linux}
      S := BaseDir;
      SelectDirectory('Working Directory', '', S);
      BaseDir := S;
      {$else}
      SelectDirectory(BaseDir, [sdAllowCreate, sdPerformCreate, sdPrompt], 1);
      {$endif}
    end;
    Memo1.Clear;
    ListBox1.Items.Clear;
    j := 0;
    for i :=1 to 12 do
      RecentFileName[i] := ''; // initiallization
    for i :=1 to 12 do
    begin
      dumstr :=  IniFile.ReadString('RecentFile', IntToStr(i), '');
      if (Pos(':\', dumstr) = 0) and (StringReplace(dumstr, '..' + Slash, '', [rfReplaceAll]) <> '') then
        dumstr := Main.GetAbsoluteDirectory(ExeDir, dumstr);
      //if i = 1 then
      //  ShowMessage(dumstr);
      if not FileExists(dumstr) then    // for examples
        dumstr := ExeDir + dumstr;
      if (FileExists(dumstr) = True) and (ExtractFileExt(dumstr) = '.in') and (RecentFileName[j] <> dumstr) then
      begin
        j := j + 1;
        RecentFileName[j] := dumstr;
        Assignfile(f, dumstr);
        Reset(f);
        Readln(f,dumstr);
        Readln(f,dumstr);
        Readln(f, RecentComment[j]);
        CloseFile(f);
        dumstr := ExtractFileName(RecentFileName[j]);
        dumstr := Copy(dumstr,1,Length(dumstr)-3);
        ListBox1.Items.Add(SetLengthLJ(dumstr,12));
        Memo1.Lines.Add(RecentComment[j]);
      end;
    end;
  finally
    IniFile.Free;
  end;
//  {$I+}
  ListBox1.ItemIndex := 0;
  ListBox1Click(Sender);
  Language;
end;
//----------------------------------------------------------
procedure TRecentFile.btnOtherClick(Sender: TObject);
begin
  CaseName := '';
  dumint := 0;
  Close;
end;
//----------------------------------------------------------
procedure TRecentFile.btnOpenClick(Sender: TObject);
begin
  dumstr := RecentFileName[ListBox1.ItemIndex+1];
  CaseName := Copy(dumstr,1,Length(dumstr)-3);
  dumint := ListBox1.ItemIndex;
  Close;
end;
//----------------------------------------------------------
procedure TRecentFile.btnNewClick(Sender: TObject);
begin
  CaseName := BaseDir + Slash + 'Untitled';
  dumint := 0;ListBox1.ItemIndex := 0;
  Close;
end;
//----------------------------------------------------------
procedure TRecentFile.btnAnimeClick(Sender: TObject);
begin
  Animation := 1;
  btnOpenClick(Sender);
end;
//----------------------------------------------------------
procedure TRecentFile.FormClose(Sender: TObject; var Action: TCloseAction);
var
  i, j: Integer;
  S: String;
begin
  if dumint > 0 then
  begin
    S := RecentFileName[dumint+1];
    for i:= dumint + 1 downto 2 do
      RecentFileName[i] := RecentFileName[i-1];
    RecentFileName[1] := S;
    S := ExeDir + S;
  end;
  for i := 2 to 12 do
    for j := i-1 downto 1 do
      if RecentFileName[j] = RecentFileName[i] then
        RecentFileName[i] := '';
  SaveRecentFile;
end;
//----------------------------------------------------------
procedure TRecentFile.SaveRecentFile;
var
  IniFile: TIniFile;
  i: Integer;
  S: String;
begin
  IniFile := TIniFile.Create(ChangeFileExt(Application.ExeName, '.ini'));
  with IniFile do
  try
    for i := 1 to 12 do
    begin
      if RecentFileName[i] <> '' then
      begin
        S := Main.GetRelativeDirectory(ExeDir, RecentFileName[i]);
        WriteString('RecentFile', IntToStr(i), S);
      end;
    end;
  finally
    Free;
  end;
end;

//----------------------------------------------------------
function TRecentFile.SetLengthLJ(dumstr: String; dumint: Shortint): String;
var i: Shortint;
begin
  for i:=1 to dumint - Length(dumstr) do
    dumstr:=dumstr+' ';
  Result := dumstr;
end;
//----------------------------------------------------------

procedure TRecentFile.Language;
var
  IniFile: TIniFile;
  S, S0: String;
  i: Integer;
{$ifdef Linux}
  function ConvertToCLXcharset(i: Integer): TFontCharset;
  begin
    Case i of
    0  : Result := fcsDefaultCharSet;
    128: Result := fcsSet_Ja;
    else Result := fcsDefaultCharSet;
    end;
  end;
{$endif}
begin
  Msg[1] := #13#10 + 'Welcome to WASH_1D!' + #13#10 + #13#10 + 'Please select (or make) the working directory.'
          + #13#10 + 'If you accept the proposed directory in the next dialog box, click on the [OK] button.';
  S := ChangeFileExt(Application.ExeName, '.lng');
  S0 := Self.Name;
  if FileExists(S) then
  begin
    IniFile := TIniFile.Create(S);
    with IniFile do
      try
        Font.Name        := ReadString(S0, 'Font.Name', '');
        LANG     := ReadInteger(S0, 'LANG', 1);
        StatusBar1.SimpleText := ReadString(S0, 'StatusBar1.SimpleText', '');
        Label1.Caption   := ReadString(S0, 'Label1.Caption', '');
        Label2.Caption   := ReadString(S0, 'Label2.Caption', '');
        btnOpen.Caption  := ReadString(S0, 'btnOpen.Caption', '');
        btnOther.Caption := ReadString(S0, 'btnOther.Caption', '');
        btnNew.Caption   := ReadString(S0, 'btnNew.Caption', '');
        btnAnime.Caption := ReadString(S0, 'btnAnime.Caption', '');
        Font.Size        := ReadInteger(S0, 'Font.Size', 9);
        for i := 1 to 1 do
          Msg[i] := StringReplace(ReadString(S0, 'Msg' + IntToStr(i), ''), '<br>', #13#10, [rfReplaceAll, rfIgnoreCase]);
      finally
        IniFile.Free;
      end;
  end;
{$ifdef Linux}
  Font.Charset := ConvertToCLXcharset(LANG);
  if LANG = 128 then
    Font.Size := 11;
{$else}
  Font.Charset := LANG;
{$endif}
  Label1.Font.Charset := Font.Charset;
end;

procedure TRecentFile.ListBox1KeyUp(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  ListBox1Click(Sender);
end;
//----------------------------------------------------------
procedure TRecentFile.ListBox1Click(Sender: TObject);
var dumstr2 : String;
begin
  dumstr  := RecentFileName[ListBox1.Itemindex + 1];
  dumstr  := ExtractFileName(dumstr);
  dumstr  := Copy(dumstr,1,Length(dumstr)-3);
  dumstr2 := ExtractFileDir(RecentFileName[ListBox1.Itemindex + 1]) + Slash + dumstr + '_history.zip';
  dumstr  := ExtractFileDir(RecentFileName[ListBox1.Itemindex + 1]) + Slash + 'History' + Slash + dumstr + '_001.out';
  if (FileExists(dumstr) = True) or (FileExists(dumstr2) = True) then
    btnAnime.Enabled := True
  else
    btnAnime.Enabled := False;
end;

end.
