{
_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/

        WASH_1D version 1.35

        Copyright(C) 2000-2004 Haruyuki FUJIMAKI and Mitsuhiro INOUE
        fujimaki@sakura.cc.tsukuba.ac.jp
        URL: http://www.geocities.jp/fujimaki691202/
        Distributed under the GPL

_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/
}

unit ST_params;

interface

uses
{$ifdef Linux}
  SysUtils, Classes, QGraphics, QControls, QForms, 
  QDialogs, QStdCtrls, QExtCtrls, QComCtrls, HyperText, Spin, StdCtrls,
  Controls, ExtCtrls;
{$else}  
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls, jpeg, HyperText, ComCtrls, Spin;
{$endif}

type
  TSTparams = class(TForm)
    Edit3: TEdit;
    Back: TButton;
    Execute: TButton;
    Next: TButton;
    Panel1: TPanel;
    Edit1: TEdit;
    Edit2: TEdit;
    Label1: TLabel;
    Label6: TLabel;
    seLayerNumber: TSpinEdit;
    HyperText: THyperText;
    Edit4: TEdit;
    Edit5: TEdit;
    Image1: TImage;
    procedure ExecuteClick(Sender: TObject);
    procedure BackClick(Sender: TObject);
    procedure NextClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure ShowParams;
    {$ifdef Linux}
    procedure seLayerNumberChanged(Sender: TObject; NewValue: Integer);
    {$else}
    procedure seLayerNumberChange(Sender: TObject);
    {$endif}
  private
    procedure GetParameters;
    { Private  }
  public
    { Public  }
  end;

var
  STparams: TSTparams;
  j: Shortint;

implementation

uses WASH1dMAIN, RC_Params;

{$R *.xfm}
//----------------------------------------------------------
procedure TSTparams.FormCreate(Sender: TObject);
var x, y: Integer;
begin
  dialogbox := -1;
  seLayerNumber.Value := 1;
  j := 1;
  {$ifdef Linux}
  seLayerNumber.Max := NumLayer;
  {$else}
  seLayerNumber.MaxValue := NumLayer;
  {$endif}
  if NumLayer = 1 then
    seLayerNumber.Enabled := False;
  dumstr := ExeDir + Slash + 'Equations' + Slash + 'Dispersion params0.jpg';
 // image1.picture.loadfromfile(dumstr);
  x := 160;
  y :=  20;
  HyperText.TargetCanvas := Image1.Canvas;
  with HyperText do
  begin
  //  TargetCanvas.Font.Size := Trunc(StdFontSize * adjuster);
    Write('[5][r][i]D[/i]= [i]D[_]m[-][/i] + [i]D[_]i[-]', x, y, 0);
    Write('D[_]m[-][/i] = [s]l[r]|[i]V[/i]|'  , x, y + 40, 0);
    Write('[i]D[_]i[-][/i] = [i]D[_]i[/i]0[-][s]t[_]s[-]'  , x, y + 70, 0);
    Write('[s]t[r][_]s[-] =  [i]a[_]s[-][/i] {1 - exp@[-([i]b[_]s[-][/i] [s]q[r])[i][^]cs[-][/i]]} +[i]d[_]s[-][/i][s]q[r]'  , x, y + 100, 0);
    Write('[s]l[r] = ', 60, 163, 0);
    Write('[i]a[_]s[-][/i] = ', 185, 163, 0);
    Write('[i]b[_]s[-][/i] = ', 185, 200, 0);
    Write('[i]c[_]s[-][/i] = ', 305, 163, 0);
    Write('[i]d[_]s[-][/i] = ', 305, 200, 0);
  end;
  ShowParams;
end;
//----------------------------------------------------------
procedure TSTparams.ShowParams;
begin
  if j = 0 then j := 1;
  Edit1.Text := FormatFloat('0.000', Soil.dispersivity[j]);
  Edit2.Text := FloatToStr(Soil.a_tau[j]);
  Edit3.Text := FloatToStr(Soil.b_tau[j]);
  Edit4.Text := FloatToStr(Soil.c_tau[j]);
  Edit5.Text := FloatToStr(Soil.d_tau[j]);
end;
//----------------------------------------------------------
procedure TSTparams.ExecuteClick(Sender: TObject);
begin
  dialogbox:=0; Close();
end;
//------------------------------------------------------
procedure TSTparams.BackClick(Sender: TObject);
begin
  GoAhead:=false; dialogbox:=4; Close();
end;
//------------------------------------------------------
procedure TSTparams.NextClick(Sender: TObject);
begin
  GoAhead:=true; dialogbox:=6; Close();
end;
//------------------------------------------------------
procedure TSTparams.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  GetParameters;
end;
//----------------------------------------------------------
procedure TSTparams.GetParameters;
begin
  if j = 0 then j := 1;
  Soil.dispersivity[j] := StrToFloat(Edit1.Text);
  Soil.a_tau[j]        := StrToFloat(Edit2.Text);
  Soil.b_tau[j]        := StrToFloat(Edit3.Text);
  Soil.c_tau[j]        := StrToFloat(Edit4.Text);
  Soil.d_tau[j]        := StrToFloat(Edit5.Text);
end;

{$ifdef Linux}
procedure TSTparams.seLayerNumberChanged(Sender: TObject; NewValue: Integer);
{$else}
procedure TSTparams.seLayerNumberChange(Sender: TObject);
{$endif}
begin
  if (Edit1.Text <> '1') or (Edit2.Text <> '1') then
  begin
    GetParameters;
    j := seLayerNumber.Value;
    ShowParams;
  end;
end;

end.
