{
_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/

        WASH_1D version 1.35

        Copyright(C) 2000-2004 Haruyuki FUJIMAKI and Mitsuhiro INOUE
        fujimaki@sakura.cc.tsukuba.ac.jp
        URL: http://www.geocities.jp/fujimaki691202/
        Distributed under the GPL

_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/
}

unit THC_Params;

interface

uses
{$ifdef Linux}
  SysUtils, Classes, QGraphics, QControls, QForms, 
  QDialogs, QStdCtrls, QExtCtrls, QGrids, QComCtrls, 
  QButtons;
{$else}  
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls, Grids, jpeg, ComCtrls, Buttons, Spin;
{$endif}

type
  TTHCparams = class(TForm)
    Panel1: TPanel;
    Execute: TButton;
    Back: TButton;
    Next: TButton;
    Edit1: TEdit;
    Edit2: TEdit;
    Edit3: TEdit;
    Edit4: TEdit;
    Edit5: TEdit;
    Edit6: TEdit;
    Edit7: TEdit;
    GroupBox1: TGroupBox;
    Image1: TImage;
    GroupBox2: TGroupBox;
    Image2: TImage;
    Edit8: TEdit;
    Edit9: TEdit;
    Edit10: TEdit;
    Label1: TLabel;
    Label6: TLabel;
    BitBtn1: TBitBtn;
    BitBtn2: TBitBtn;
    seLayerNumber: TSpinEdit;
    procedure ExecuteClick(Sender: TObject);
    procedure BackClick(Sender: TObject);
    procedure NextClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure BitBtn1Click(Sender: TObject);
    procedure BitBtn2Click(Sender: TObject);
    {$ifdef Linux}
    procedure seLayerNumberChanged(Sender: TObject; NewValue: Integer);
    {$else}
    procedure seLayerNumberChange(Sender: TObject);
    {$endif}
  private
    procedure ShowEquation;
    procedure GetParameters;
  public
  end;

var
  THCparams: TTHCparams;
  j: Shortint;

implementation

uses WASH1dMAIN, RC_Params;

{$R *.xfm}

//------------------------------------------------------
procedure TTHCparams.FormCreate(Sender: TObject);
begin
  dialogbox := -1;
  seLayerNumber.Value := 1;
  j := 1;
  {$ifdef Linux}
  seLayerNumber.Max := NumLayer;
  {$else}
  seLayerNumber.MaxValue := NumLayer;
  {$endif}
  if NumLayer = 1 then
    seLayerNumber.Enabled := False;
  ShowEquation;
end;
//------------------------------------------------------
procedure TTHCparams.ExecuteClick(Sender: TObject);
begin
  dialogbox:=0; Close();
end;
//------------------------------------------------------
procedure TTHCparams.BackClick(Sender: TObject);
begin
  GoAhead:=false; dialogbox:=5; Close();
end;
//------------------------------------------------------
procedure TTHCparams.NextClick(Sender: TObject);
begin
  GoAhead:=true; dialogbox:=7; Close();
end;
//------------------------------------------------------
procedure TTHCparams.ShowEquation();
var dumstr2: string;
begin
  dumstr :='McInnes_kh0.jpg';
  dumstr2:='albedo0.jpg';
  if j = 0 then j := 1;
  Edit1.Text := FloatToStr(Soil.Akh[j]);
  Edit2.Text := FloatToStr(Soil.Bkh[j]);
  Edit3.Text := FloatToStr(Soil.Ckh[j]);
  Edit4.Text := FloatToStr(Soil.Dkh[j]);
  Edit5.Text := FloatToStr(Soil.Ekh[j]);
  dumstr := ExeDir + Slash + 'Equations' + Slash + dumstr;
  image1.picture.loadfromfile(dumstr);
  if j = 1 then
    GroupBox2.Visible := True
  else
    begin
    GroupBox2.Visible := False;
    Exit;
    end;
  Edit6.Text := FloatToStr(Soil.AlbedoMax[1]);
  Edit7.Text := FloatToStr(Soil.AlbedoMin[1]);
  Edit8.Text := FloatToStr(Soil.Aal[1]);
  Edit9.Text := FloatToStr(Soil.Bal[1]);
  Edit10.Text := FloatToStr(Soil.ThickAlb[1]);
  dumstr2 := ExeDir + Slash + 'Equations' + Slash + dumstr2;
  image2.picture.loadfromfile(dumstr2);
  end;
//----------------------------------------------------------
procedure TTHCparams.BitBtn1Click(Sender: TObject);
begin
  GetParameters;
  Main.ExecuteXYGrapher(4, j);
end;
//----------------------------------------------------------
procedure TTHCparams.BitBtn2Click(Sender: TObject);
begin
  GetParameters;
  Main.ExecuteXYGrapher(5, j);
end;
//------------------------------------------------------
procedure TTHCparams.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  GetParameters;
end;
//----------------------------------------------------------
procedure TTHCparams.GetParameters;
begin
  if j = 0 then
    j := 1;
  Soil.Akh[j] := StrToFloat(Edit1.Text);
  Soil.Bkh[j] := StrToFloat(Edit2.Text);
  Soil.Ckh[j] := StrToFloat(Edit3.Text);
  Soil.Dkh[j] := StrToFloat(Edit4.Text);
  Soil.Ekh[j] := StrToFloat(Edit5.Text);
  if j <> 1 then
    Exit;
  Soil.AlbedoMax[1]   := StrToFloat(Edit6.Text);
  Soil.AlbedoMin[1]   := StrToFloat(Edit7.Text);
  Soil.Aal[1] := StrToFloat(Edit8.Text);
  Soil.Bal[1] := StrToFloat(Edit9.Text);
  Soil.ThickAlb[1] := StrToFloat(Edit10.Text);
end;
//--------------------------------------------------------------------

{$ifdef Linux}
procedure TTHCparams.seLayerNumberChanged(Sender: TObject; NewValue: Integer);
{$else}
procedure TTHCparams.seLayerNumberChange(Sender: TObject);
{$endif}
begin
  if (Edit1.Text <> '1') or (Edit2.Text <> '1') then
  begin
    GetParameters;
    j := seLayerNumber.Value;
    ShowEquation;
  end;
end;

end.
