{
_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/

        WASH_1D version 1.36

        Copyright(C) 2000-2004 Haruyuki FUJIMAKI and Mitsuhiro INOUE
        fujimaki@sakura.cc.tsukuba.ac.jp
        URL: http://www.geocities.jp/fujimaki691202/
        Distributed under the GPL

_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/
}

unit WASH1dMain;

interface

uses
{$ifdef Linux}
  SysUtils, Classes, QGraphics, QControls, QForms, 
  QDialogs, QButtons, QExtCtrls, QStdCtrls, QMenus, Math, 
  QPrinters, QComCtrls, QImgList, Output, ZipMasterForLinux, IniFiles, 
  HyperText, QTypes, Qt
  ;
{$else}
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Buttons, ExtCtrls, StdCtrls, Menus, Math, Printers, ComCtrls, ToolWin,
  ImgList, Output, ZipMstr, HyperText, IniFiles, Registry;
{$endif}

const
  NumElem = 801;

{$define debugging_}

type
  TMain = class(TForm)
    MainMenu1: TMainMenu;
    File1: TMenuItem;
    Exit1: TMenuItem;
    N1: TMenuItem;
    Print1: TMenuItem;
    N2: TMenuItem;
    SaveAs1: TMenuItem;
    Open1: TMenuItem;
    Help1: TMenuItem;
    About1: TMenuItem;
    Contents1: TMenuItem;
    OpenDialog1: TOpenDialog;
    SaveDialog1: TSaveDialog;
    Timer1: TTimer;
    OpenDialog2: TOpenDialog;
    Panel2: TPanel;
    Image1: TImage;
    Panel3: TPanel;
    Image2: TImage;
    Panel5: TPanel;
    Image4: TImage;
    Panel4: TPanel;
    Image3: TImage;
    Input1: TMenuItem;
    IG: TMenuItem;
    ISP: TMenuItem;
    ISR: TMenuItem;
    ISK: TMenuItem;
    Execute1: TMenuItem;
    ProgressBar1: TProgressBar;
    ISS: TMenuItem;
    IW: TMenuItem;
    IA: TMenuItem;
    ISM: TMenuItem;
    ISH: TMenuItem;
    ISE: TMenuItem;
    Output: TMenuItem;
    ConvertToRate: TMenuItem;
    II: TMenuItem;
    StatusBar1: TStatusBar;
    ToolBar1: TToolBar;
    ToolButton1: TToolButton;
    ToolButton2: TToolButton;
    ToolButton3: TToolButton;
    ToolButton4: TToolButton;
    ToolButton5: TToolButton;
    ImageList1: TImageList;
    ToolButton6: TToolButton;
    Play_or_Stop: TSpeedButton;
    Rewind: TSpeedButton;
    FastForward: TSpeedButton;
    AnimeCounter: TEdit;
    ToolButton7: TToolButton;
    Slow: TSpeedButton;
    PlayorStop2: TMenuItem;
    Slow2: TMenuItem;
    FastForward2: TMenuItem;
    Rewind2: TMenuItem;
    AnimatedFigure1: TMenuItem;
    IP: TMenuItem;
    Panel1: TPanel;
    Image5: TImage;
    ShowObservationFigure: TMenuItem;
    N3: TMenuItem;
    N4: TMenuItem;
    ShowProfileFigure: TMenuItem;
    HyperText: THyperText;
    OpenDialog3: TOpenDialog;
  //  PrinterSetupDialog1: TPrinterSetupDialog;
    procedure FormCreate(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
    procedure Exit1Click(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure Perform(Sender: TObject);
    procedure About1Click(Sender: TObject);
    procedure GetConfiguration(Sender: TObject);
    procedure PrintClick(Sender: TObject);
    procedure IGClick(Sender: TObject);
    procedure ISRClick(Sender: TObject);
    procedure ISKClick(Sender: TObject);
    procedure FileOpenClick(Sender: TObject);
    procedure ISSClick(Sender: TObject);
    procedure IWClick(Sender: TObject);
    procedure IAClick(Sender: TObject);
    procedure ISMClick(Sender: TObject);
    procedure ISHClick(Sender: TObject);
    procedure ISEClick(Sender: TObject);
    procedure ConvertToRateClick(Sender: TObject);
    procedure IIClick(Sender: TObject);
    procedure Play_or_StopClick(Sender: TObject);
    procedure RewindClick(Sender: TObject);
    procedure FastForwardClick(Sender: TObject);
    procedure SlowClick(Sender: TObject);
    procedure AnimatedFigure1Click(Sender: TObject);
    procedure IPClick(Sender: TObject);
    procedure TreatHistoryFile;
    procedure Language;
    procedure Contents1Click(Sender: TObject);
    procedure ShowObservationFigureClick(Sender: TObject);
    procedure ShowProfileFigureClick(Sender: TObject);
    procedure FormKeyUp(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure AnimeCounterDblClick(Sender: TObject);
    procedure SaveInformations(Sender: TObject);
  private
    Msg: Array[1..30] of String;
    function  GetIntegerValue(Key: String): Integer ;
    function  GetFloatValue(Key: String): Double;
    function  GetString(Key: String): String;
    function  CheckModified: Boolean;
    function  RoundToDecimalSF(Value : Double; SigFig : Integer) : Double;
    function  BoolToStr(V: Boolean): String;
    function  StrToBool(S: String): Boolean;
    procedure SetDefaultValues;
    procedure FileSaveQuery;
    procedure DeleteHistoryFile;
    procedure SaveInFile(WriteOnFile: Boolean);
    procedure GetVirtualFile;
    procedure SetDefaultFont;
    procedure LoadInformations(Sender: TObject);
  public
    procedure Report;
  //  procedure HyperText.Write(var Img: TImage; OriginalString: String; x, y: Integer);
    procedure Profile;
    procedure ProfileDraw(GX, GY : Array of Double; NumPoint: Integer; GXmin: Double; GXmax: Double; Lcol: Integer);
    procedure FluxProfile;
    procedure FluxProfileDraw(var GX : Array of Double; var GY : Array of Double; Lcol: Integer);
    procedure History;
    procedure HistoryDraw(GX, GY : Array of Double; StartPoint, EndPoint: Integer; GYmin, GYmax: Double; Lcol: Integer; PenStyle: TPenStyle);
    procedure PropertyDraw;
    procedure ExecuteXYGrapher(XYGrapherMode: Integer; Layer: Integer = 1);
    procedure SendDataToSoil;
    procedure RetrieveDataFromSoil;
    procedure SendDataToKparams;
    procedure RetrieveDataFromKparams;
    procedure SelectFile(var ObjectFileName: String; var ObjectEdit: TEdit);
    function  GetRelativeDirectory(Origin, S: String): String;
    function  GetAbsoluteDirectory(Origin, S: String): String;
  end;

const
  True_  ='True';
  False_ ='False';
  PRECISE = 1;
  StephBolz = 0.00000000000567; LOSS = 0;//LOSS = 2;
  MaxNumObs = 8;
var
  Main: TMain;
  f: textfile;
  CaseName, ExeDir, BaseDir, MyDocDir, dumstr, VirtualFile, Slash: String;
  comment : String;
  SoilName, SoilPropertyFile         :array[0..5] of String;
  fl_ql_top,fl_p_bot: String;
  fl_clmtc_con: String;
  fl_iniCprofile, fl_C_irg, fl_C_bot: String;
  fl_outflow, fl_CumEvap, fl_profile, fl_retention,
  fl_pressure, fl_HyConData, fl_front, JapFont: String;
  fl_c_profile: String;

  dum, dum2: Double;
  dumint, LANG: Integer;
  GoAhead: boolean;
  Mode, Modified, OriginalModified, JapFontSize: Shortint;
  water, solute, heat, rec, rec0, IPET_type, StopCalc, ConsiderHysteresis: Shortint;
  DialogBox: shortint;
  ic_type, u_bc_type, l_bc_type, NumLayer, NumObs                             : Shortint;
  t_unit                                                                      : Integer;
  abc_type, h_l_bc_type: Shortint;
  s_ic_type, s_u_bc_type, s_l_bc_type, s_type, S_crust, CRWM: Shortint;
  CDE_surface_modification: Boolean;
  t_c_bot, Cbot, t_c_irg, Cirg                       : array[0..1000] of Double;

  RecentFileName, RecentComment         : array[0..12] of String;
  z                                     : array[-1..NumElem] of Double;
  z_border, z_obs                       : array[0..MaxNumObs] of Double;
  NCtime                                : array[1..MaxNumObs] of Integer;
  z_lb, z_lb0, dz_bot, com_ratio        : Double;
  t_end,dt, dt_ini,dt_max, int_rec                  : Double;
  W_ini, P_ini, P_top_ini, ql_top, cum_ql_top, p_bot: Double;
  ra, RHair, Tair, Tini, Tbot                       : Double;
  Ds, Vfixed, C_ini, C_irg, C_bot                   : Double;
  HC_filter, W_end, Hpond, parlb_a, parlb_b: Double;     // Parameter for Additional Resistance to Lower Boundary

  // Soil Properties //
  {
  SoilComment                                                               : array[1..5] of String;
  RF                                                                        : array[1..NumElem] of Shortint;
  KF                                                                        : array[1..5] of Shortint;
  Tref, Llambda, LogOfLlambda                              : array[1..5] of Double;
  Wsat, zeta, Wr                                                          : array[1..5] of Double;
  alpha, np, mp, sp, alpha1, np1, alpha2, np2, mp1, mp2          : array[-5..5] of Double;
  Ksat, ak, bk, ck                                                  : array[1..5] of Double;
  a_tau, b_tau, dispersivity                                                : array[1..5] of Double;
  Akh, Bkh, Ckh, Dkh, Ekh, AlbedoMax, AlbedoMin, Aal, Bal, ThickAlb, Aen, Ben, Cen, Den, Een : array[1..5] of Double;
  }
  // In the Simulation //
  dz                                                                        : array[0..NumElem] of Double;
  L                                                                         : array[0..NumElem] of Shortint;
  flx, fly                                                                  : array[0..2000] of Double;

  time_ ,avdt: Double;
  counter, navdt, CRWMcounter: Integer;
  Drawing, AllowRecord, AllowPerform : ShortInt;

  Xmax, Ym, Y0, mean_                                     : array[0..NumElem] of Double;        // for CRWM
  SIGN                                                    : array[0..NumElem] of ShortInt; // for CRWM
  zp                                                      : array[0..40000] of Double; // for CRWM
  ncp                                                     : array[0..40000] of Integer; // for CRWM

  t_clm_con, wv, Ta, RHa, CPR, CRg, PR, Rg                : array[0..2000] of Double;
  t_p_bot, Pbot, G, t_ql_top, qltop                       : array[0..2000] of Double;

  n, NumCalc, NCalb, abc_done, Pbot_done, OutFlow_done, NumP, NumPbotData  : Integer;
  Num_qltop_Data, qltop_done, Angle: Integer;
  NumCirgData, NumCbotData, Cirg_done, Cbot_done: Integer;
  heatcalc, NegativeDCwarning: Shortint;
  alpha_crys: Double;
  Cva, Vwind, NumIon, Mweight, Prec, Rshort, Rldown: Double;
  Walb, Walb_bot, albedo, Rlup, Rl, Rn: Double;
  a_oc, b_oc, c_oc, rsc: Double;

  // P1, P2, W1, W2 : Double;
  W_storage_ini, W_storage_new, W_storage_old : Double;
  WCumRError, CumInfilt, CumDrain, CumEvap, ESRErrorW, ESErrorW: Double;
  MaxDiffW: Double;
  E_storage_ini, E_storage_old: Double;
  dz_, Diw0, Cmax: Double;
  S_storage_ini, S_storage, Cum_qs_top, Cum_qs_bot, Crystal, SCumRError         : Double;
  MPP, dt_CRWM, dt_CRWM_next, time_CRWM, Vmax , OneStepDisp, OneStepDiff        : Double;  // for CRWM
  Integler_ub, Integler_lb, Vnbefore, V1before                                  : Double;  // for CRWM
  Tnew, maxchangeT, totalLoss : Double;
  ECumRError, E_Storage, CumSHT, CumLHT, CumCHL, CumHLB, CumHLS : Double;
  IniDrying                                                                     : Boolean;
  SL          : TStringList;

  // Observation //
  time, CumE, CumD, CumI, ql_bot, Evap, dumArray, t_front, Front : array[0..3000] of Double;
  Wtime, Ptime, Ctime, Ttime, AvgWaterContentAbove                  : array[1..MaxNumObs, 0..3000] of Double;

  // Inverse Parameter Estimation //
  t_outflow, t_evaporation, CumOutFlow, CumEvaporation                      : array[0..2000] of Double;
  t_tensio, Ptens1, Ptens2                                           : array[0..2000] of Double;
  Wretm, Pretm, Wkm, LogKm                                                           : array[0..100] of Double;
  Pret, Wret                                                             : array[0..1000] of Double;
  Weight, zm, zmb, zms, Wm, Cm                                 : array[0..100] of Double;
  K_direct, W_direct, K_direct_p, W_direct_p, t_direct, t_direct_p: array[0..500] of Double;
  MeasuredFront                            : array[0..1000] of Double;
  NumRetData, NumOutflowData, NumEvapData, NumAddRetData, NumSampling, NumFrontData: Integer;
  NumTensioData, NumAddHyConData, NumOutflowData_for_DP                             : Integer;
  NumExp, independent, AddRetData, FitMode, mfit_for_RF, Tensio, MultiStep : Shortint;
  WsatFix, LlambdaFix, Linked_m, spFix, ZetaFix, WrFix, KsatFix, akFix, bkFix: Shortint;
  UseOutFlowForK, UseProfileForK, UseFrontForK  : Shortint;
  UseAdditionalHyConData : ShortInt;
  MeanCumOutflow, LowestPbot, ChgCriteria, OutflowWeight: Double;
  ArtSTEOutflow, ArtSTEEvap, ArtCEVWC, ArtCEPsychro: Double;
  t_slicing, z_slice, W_slice, Wfront : Double;

  // Graphic //
  Graph, ColumnPosition: ShortInt;
  Moment, adjuster, StdFontSize: Single;

  // Animation //
  Animation, JustLoading, playing, Fast : Shortint;
  Demonstration: Boolean;
  ShowResult : TOutputResults;
  {$ifdef Linux}
  ZipMaster: TZipMasterForLinux;
  {$else}
  ZipMaster: TZipMaster;
  FCS: Integer;
  {$endif}

/////////////////////////////////////////////////////////////////
implementation

uses
  Greeting, G_Information, W_Information, RC_Params, K_Params, THC_Params,
  Atmos_BC, Simulation, ST_params, S_Information, Recent, En_Factor,
  I_Information, P_Estimator, Pos_Information, FigFileMaker, MyMsgDlg,
  Help_Search, I_s_Information;

{$R *.xfm}
//---------------------------------------------------------------------------
procedure TMain.FormCreate(Sender: TObject);
{$ifdef MSWINDOWS}
var
  Reg: TRegistry;
  S: String;
  lpBuffer: PChar;
{$endif}
begin
  ExeDir := ExtractFileDir(Application.ExeName);
  {$ifdef Linux}
  MyDocDir := GetEnvironmentVariable('HOME');
  Slash := '/';
  {$else}
  Reg := TRegistry.Create;
  with Reg do
  try
    RootKey := HKEY_CURRENT_USER;
    OpenKey('Software\Microsoft\Windows\CurrentVersion\Explorer\Shell Folders', False);
    MyDocDir := ReadString('Personal');// lpszPath; // Modified 02/01/05
    CloseKey;
  finally
    Free;
  end;
  lpBuffer := AllocMem(256);
  GetWindowsDirectory(lpBuffer, 256);
  S := lpBuffer;
  S := ExtractFileDir(S);
  Slash := '\';
  {$endif}
  RecentFile:= TRecentFile.Create(Self);
  {
  //-- GreetingBox --//
  Hide;
  GreetingBox := TGreetingBox.create(Self);
  GreetingBox.ShowModal;
  GreetingBox.Release;
  Show;
  }
  SetDefaultValues;
  //RecentFile.Release;
  Timer1.Enabled := True;
  adjuster := Screen.Width / 1024.0;
  ProgressBar1.Left  := StatusBar1.Panels[0].Width + 2;
  ProgressBar1.Width := StatusBar1.Panels[1].Width - 2;
  ProgressBar1.Height:= StatusBar1.Height - 2;
  Font.Assign(RecentFile.Font);
  {$ifdef Linux}
  StdFontSize := Font.Size;//Trunc(Font.Size * Screen.Width / 800.0);
  {$else}
  StdFontSize := Font.Size * 120 / GetDeviceCaps(Canvas.Handle, LOGPIXELSY) * (800 / Screen.Width);
  {$endif}
  ShowResult := TOutputResults.Create(Self);
  SL := TStringList.Create;
  Simulator := TSimulator.Create; //(Self);
  {$ifdef Linux}
  ZipMaster := TZipMasterForLinux.Create(Self);
  {$else}
  ZipMaster := TZipMaster.Create(Self);
  {$endif}
  with ZipMaster do
  begin
    AddOptions := [AddRecurseDirs, AddUpdate];
    ExtrOptions := [ExtrOverWrite, ExtrUpdate];
    {$ifdef MSWINDOWS}
    AddCompLevel := 9;
    Unattended := False;
    MinZipDllVers := 172;
    MinUnzDllVers := 172;
    VersionInfo := '1.72';
    {$endif}
  end;
end;
//---------------------------------------------------------------------------
procedure Tmain.SetDefaultValues;
begin
  {$ifdef MSWINDOWS}
  ImageList1.GetIcon(5, Application.Icon);
  {$endif}
  MODE := 1; z[1] := 0.5; dz_bot := 2; t_unit := 3600;
  t_end  := 240; int_rec := 0.5;
  ic_type := 2; l_bc_type := 2; u_bc_type := 1;
  IPET_type := 2; independent := 1;
  Tini := 298.2; Tbot := 298.2; Tair := 298.2; RHair := 0.4;
   // ShowObservationFigure.Visible := False;
  NumLayer := 1; NumObs := 1;
  CaseName := BaseDir + Slash + 'Untitled';
  UseOutFlowForK := 1;
  navdt := 1;
  mfit_for_RF := 5;
  OutflowWeight := 1;
  abc_type    := 1; h_l_bc_type := 1; s_type      := 1;
  s_ic_type   := 1; s_u_bc_type := 1; s_l_bc_type := 1;
  HC_filter   := 10;
  AllowRecord := 1;
  Graph := 0;
  WsatFix := 1; LlambdaFix := 1; spFix := 1; KsatFix := 1;
  ConsiderHysteresis := 1;
  IniDrying := True;
  t_slicing := 0; z_slice := 0; W_slice := 0;
  UseProfileForK := 0; fl_profile := '';
 // parlb_a := 100000;
 // parlb_b := 2;
 // ---- Kuroboku -----
 // parlb_a := 39728208;
 // parlb_b := 3.11;
 // ---- Paddy -----
 // parlb_a := 4055371;
 // parlb_b := 4.49;
  Wfront := 0.05;
  parlb_a := 0;
  parlb_b := 0;
  Angle := 0;
  CDE_surface_modification := False;
  alpha_crys := 0.002;
end;
//----------------------------------------------------------
procedure TMain.Timer1Timer(Sender: TObject);
begin
  Timer1.Enabled := False;
  Application.OnHelp := HelpSearch.HelpTreeView.AppHelp;
  Soil := TSoil.Create(Self);
  RecentFile.ShowModal;
  RecentFile.Release;
  Caption := 'WASH_1D - ' + ExtractFileName(CaseName);
  Language;
  //if CaseName = 'Untitied' then Exit;
  HyperText.DefaultFontSize := 9;
  HyperText.AllowWrite := True;
  Self.Show;
  if Animation = 1 then
  begin
    LoadInformations(Sender);
    AnimatedFigure1Click(Sender)
  end
  else
  begin
    if CaseName = BaseDir + Slash + 'Untitled' then
      IGClick(Sender)
    else
    begin
      LoadInformations(Sender);
      GetConfiguration(Sender);
    end;
  end;
end;
//----------------------------------------------------------
procedure TMain.FileOpenClick(Sender: TObject);
begin
  FileSaveQuery;
  RecentFile:= TRecentFile.Create(Self);
  SetDefaultValues;
  Timer1Timer(Sender);
  Animation := 0;
  ToolButton4.Enabled := True;
  Execute1.Enabled    := True;
end;
//----------------------------------------------------------
procedure TMain.FileSaveQuery;
begin
  AllowPerform := 1;
  if CheckModified then
  begin
    {$ifdef Linux}
    if Application.MessageBox(PChar(Msg[1]),'', [smbYes, smbNo]) = smbYes then
    {$else}
    if Application.MessageBox(PChar(Msg[1]),'', mb_yesno or mb_iconquestion) = id_yes then
    {$endif}
      SaveInformations(Self)
    else
      AllowPerform := 0;
  end;
end;
//----------------------------------------------------------
procedure TMain.LoadInformations(Sender: TObject);
var
  i: Integer;
  Version: Single;
  function ConvertToFullPathName(S: String): String;
  begin
    {$ifdef Linux}
    S := StringReplace(S, '\', '/', [rfReplaceAll]);
    {$else}
    S := StringReplace(S, '/', '\', [rfReplaceAll]);
    {$endif}
    if (S <> '') and (S <> ' ') then
      if Version > 1.22 then
        Result := GetAbsoluteDirectory(BaseDir, S)
      else
        Result := ExeDir + S
    else
      Result := '';
  end;
begin
  Version := 0;
  Execute1.Enabled := True;
  if CaseName = '' then
  begin
    with OpenDialog1 do
    begin
      InitialDir := BaseDir;
      FileName   := 'Please Double-click the file above.';
      if Execute <> True then
        Exit;
      if ExtractFileExt(FileName) <> '.in' then  // 01/17/00
      begin
        ShowMessage('You can load setting file(*.in) only. Please retry.');
        Exit
      end;
      CaseName := Copy(FileName,1,Length(FileName)-3);
      RecentFile := TRecentFile.Create(Self);
      dumint := 11;
    end;
    //Delete(dumstr, 1, Length(BaseDir));
    RecentFileName[12] := CaseName + '.in';
    RecentFile.Close;
    RecentFile.Release;
  end;
  BaseDir := ExtractFileDir(CaseName);
  SL.Clear;
  SL.LoadFromFile(CaseName + '.in');
  i := Pos('version', SL[0]);
  if i > 0 then
    Version := StrToFloat(Copy(SL[0], i + 7, 5));
  Comment := SL[2];
  MODE   := GetIntegerValue('Mode');
  if Mode = 2 then
    IPET_type := GetIntegerValue('type of I.P.E.');
  if (Version < 1.215) and (IPET_type > 2) then
    IPET_type := IPET_type + 1;
  Water  := GetIntegerValue('water');
  Solute := GetIntegerValue('solute');
  Heat   := GetIntegerValue('heat');
  z_lb   := GetFloatValue('depth of lower boundary');
  z[1]   := GetFloatValue('space increment at the top');
  dz_bot := GetFloatValue('space increment at the bottom');
  NumLayer := GetIntegerValue('number of layer');
  if NumLayer >= 2 then
    for i := 1 to NumLayer - 1 do
      z_border[i] := GetFloatValue('depth of ' + IntToStr(i) + PositionInfo.Suffix(i) + 'border');
  NumObs := GetIntegerValue('number of observation point');
  for i := 1 to NumObs do
    z_obs[i] := GetFloatValue('depth of ' + IntToStr(i) + PositionInfo.Suffix(i) + ' observation point');
  t_unit := GetIntegerValue('unit of time');
  t_end  := GetFloatValue('final time');
  dt_ini := GetFloatValue('initial time increment');
  dt_max := GetFloatValue('maximum time increment');
  int_rec:= GetFloatValue('interval of report');
  rec    := GetIntegerValue('record profiles at the interval');
  if (Version > 1.01) and (Water = 1) then
  begin
    IterationScheme := GetIntegerValue('handling of water capacity');
    InterHyCon      := GetIntegerValue('method for giving interblock conductivity');
    TargetMaxDiff_logP  := GetFloatValue('maximum permissible difference of pressure head in a time step');
    if Version < 1.23 then
      TargetMaxDiff_logP := 0.693;
    TargetESRErrorW := GetFloatValue('target relative error in water budget  at each time step');
    LowerTargetIteration := GetIntegerValue('lower boundary of target range for Celia' + #39 + 's iteration');
    UpperTargetIteration := GetIntegerValue('upper boundary of target range for Celia' + #39 + 's iteration');
    CriteriaForCeliasIteration := GetFloatValue('criteria for Celia' + #39 + 's iteration');
    if Pos('consider hysteresis', SL.Text) > 0 then
      ConsiderHysteresis := GetIntegerValue('consider hysteresis');
  end;
  if Version > 1.21 then
    Angle := GetIntegerValue('angle of soil surface');
  if (Water = 1) or (Mode = 2) then
  begin
    for i := 1 to NumLayer do
      SoilName[i] := GetString(IntToStr(i) + PositionInfo.Suffix(i) + ' layer');
    //--- Water flow ---//
    ic_type := GetIntegerValue('type of initial condition for water');
    u_bc_type := GetIntegerValue('type of upper boundary condition for water');
    l_bc_type := GetIntegerValue('type of lower boundary condition for water');
    if (Version < 1.1) and (u_bc_type = 2) then
      u_bc_type := 3;
    Case ic_type of
    1: dumstr := 'initial volumetric water content = ';
    2: dumstr := 'initial pressure head(cm) = ';
    3: dumstr := 'initial pressure head(cm) at the top = ';
    end;
    if (Mode = 2) and (IPET_type = 1) and (UseOutflowforK = 0) then
      dumstr := 'initial pressure head(cm) at the top = ';
    if ic_type <= 3 then
    begin
      dum := GetFloatValue(dumstr);
      Case ic_type of
      1: W_ini := dum;
      2: P_ini := dum;
      3: P_top_ini := dum;
      end;
    end;
    if (IPET_type = 1) and (UseOutflowforK = 0) then
      P_top_ini := dum;
    p_bot     := GetFloatValue('pressure head(cm) at the bottom');
    HC_filter := GetFloatValue('hydraulic conductance of the filter');
    if ic_type = 4 then
      fl_profile := ConvertToFullPathName(GetString('file name for initial VWC profile'));
    case u_bc_type of
    1: ql_top    := GetFloatValue('solution flux at the top');
    2: Hpond := GetFloatValue('pressure head(cm) at the top');
    3: fl_ql_top := ConvertToFullPathName(GetString('file name for solution flux at the soil surface'));
    end;
    if (l_bc_type = 4) or ((Mode = 2) and(IPET_Type = 2)) then
      fl_p_bot  := ConvertToFullPathName(GetString('file name for lower pressure head change'));
    case l_bc_type of
    4: fl_p_bot   := ConvertToFullPathName(GetString('file name for lower pressure head change'));
    5: fl_outflow := ConvertToFullPathName(GetString('file name for measured outflow data'));
    end;
    if Version > 1 then
      IniDrying := StrToBool(GetString('initially drying?'));
    abc_type  := GetIntegerValue('type of A.B.C.');
    ra        := GetFloatValue('aerodynamic resistance');
    Tair      := GetFloatValue('temperature of air');
    RHair     := GetFloatValue('relative humidity of air');
    Case abc_type of
    3: fl_CumEvap   := ConvertToFullPathName(GetString('file name for measured evaporation rate'));
    4: fl_clmtc_con := ConvertToFullPathName(GetString('file name for climatic condition'));
    end;
  end;
 //--- Solute Movement ---//
  if solute = 1 then
  begin
    CRWM        := GetIntegerValue('Convective Random Walk Model');
    MPP         := GetIntegerValue('mass simulated by a particle');
    s_ic_type   := GetIntegerValue('type of initial condition for solute');
    s_u_bc_type := GetIntegerValue('type of upper boundary condition for solute');
    s_l_bc_type := GetIntegerValue('type of lower boundary condition for solute');
    s_type      := GetIntegerValue('type of solute');
    S_crust     := GetIntegerValue('salty crust resistance');
    if Version > 1.341 then
      CDE_surface_modification := StrToBool(GetString('Apply surface modification for CDE?'));
    C_ini       := GetFloatValue('initial concentraion');
    C_irg       := GetFloatValue('concentration of irrigation water');
    C_bot       := GetFloatValue('concentration at the lower boundary');
    if Version > 1.342 then
      alpha_crys  := GetFloatValue('crystallization rate constant');
    if water <> 1 then
    begin
      Ds     := GetFloatValue('dispersion coefficient');
      Vfixed := GetFloatValue('average pore water velocity');
    end;
    if s_ic_type > 1 then
      fl_iniCprofile := ConvertToFullPathName(GetString('file name for initial concentration profile'));
    if s_u_bc_type = 2 then
      fl_C_irg       := ConvertToFullPathName(GetString('file name for concentration of irrigation water'));
    if s_l_bc_type = 2 then
      fl_C_bot       := ConvertToFullPathName(GetString('file name for concentration at the lower boundary'));
  end;
  //--- Heat Movement ---//
  if heat = 1 then
  begin
    h_l_bc_type := GetIntegerValue('type of lower boundary condition for heat');
    Tbot := GetFloatValue('temperature at the lower boundary');
    Tini := GetFloatValue('initial temperature');
  end
  else
    Tini := Tair;
  //--- Inverse Paramater Estimation ---//
  if Mode = 2 then
  begin
    if (IPET_type <> 5) then
      Tensio    := GetIntegerValue('use of tensiometer');
    if IPET_type <= 2 then
      UseOutFlowForK := GetIntegerValue('use of outflow data for estimating hydraulic conductivity function');
    if IPET_type = 5 then
    begin
      UseFrontForK   := GetIntegerValue('use of infiltrating front for estimating hydraulic conductivity function');
      UseProfileForK := GetIntegerValue('use of final water content profile for estimating hydraulic conductivity function');
    end;
    if (IPET_type = 2) or (IPET_type = 3) then
      AddRetData := GetIntegerValue('use of additional retention data');
    independent := GetIntegerValue('independet determination of the retention curve');
    W_end       := GetFloatValue('volumetric water content at the end');
    WsatFix     := GetIntegerValue('fixation of saturated volumetric water content');
    LlambdaFix    := GetIntegerValue('fixation of pressure head(cm) at oven dry');
    Linked_m    := GetIntegerValue('linkage of m to n');
    spFix       := GetIntegerValue('fixation of weighting factor in the bimodal retention function');
    ZetaFix     := GetIntegerValue('fixation of zeta in the retention function');
    WrFix       := GetIntegerValue('fixation of resident water content');
    KsatFix     := GetIntegerValue('fixation of saturated hydraulic conductivity');
    akFix       := GetIntegerValue('fixation of ak value in the hydraulic conductivity function');
    if IPET_type = 3 then
    begin
      t_slicing := GetFloatValue('Time when the slicing was performed');
      z_slice   := GetFloatValue('Thickness of the sliced layer');
      W_slice   := GetFloatValue('V.W.C. of the sliced layer');
    end;
    if Version > 1.215 then
      bkFix       := GetIntegerValue('fixation of bk value in the hydraulic conductivity function');
    if (IPET_type <= 3) or (IPET_type = 6)  then
    begin
      fl_outflow := ConvertToFullPathName(GetString('file name for measured outflow data'));
    end;
    if IPET_type = 1 then
    begin
      fl_CumEvap := ConvertToFullPathName(GetString('file name for measured evaporation data'));
      fl_profile := ConvertToFullPathName(GetString('file name for measured water content profile'));
      if Version >= 1.0 then
      begin
        UseAdditionalHyConData := GetIntegerValue('use of additional hydraulic conductivity data');
        if UseAdditionalHyConData = 1 then
          fl_HyConData := ConvertToFullPathName(GetString('file name for additional hydraulic conductivity data'));
      end;
    end
    else
      if Tensio >= 1 then
        fl_pressure := ConvertToFullPathName(GetString('file name for pressure head measured by the tensiometer'));
    if (IPET_type = 1) or (AddRetData = 1) then
      fl_retention := ConvertToFullPathName(GetString('file name for additional retention data'));
    if IPET_Type = 5 then
    begin
      fl_outflow:= ConvertToFullPathName(GetString('file name for cumutlative infiltration'));
      if UseFrontForK = 1 then
        fl_front  := ConvertToFullPathName(GetString('file name for depth of infiltrating front'));
      if UseProfileForK = 1 then
        fl_profile:= ConvertToFullPathName(GetString('file name for measured water content profile'));
      Wfront := GetFloatValue('V.W.C. of the wetting front');
    end;
    if IPET_type = 11 then
      fl_c_profile:= ConvertToFullPathName(GetString('file name for concentration profile'));
  end;
  //------------------------------------//
  if (water = 1) or (Mode = 2) then
    for i := 1 to NumLayer do
    begin
      SendDataToSoil;
      Soil.LoadSoilProperty(i);
      RetrieveDataFromSoil;
    end;
  GetVirtualFile;
  DialogBox := 1;
  GoAhead:=True;
  Caption := 'WASH_1D - ' + ExtractFileName(CaseName)
end;
//----------------------------------------------------------
function TMain.GetIntegerValue(Key: String): Integer ;
var i : Integer;
begin
  Result := 1;
  try;
    for i := 3 to SL.Count - 1 do
      if Pos(Key, SL.Strings[i]) > 0 then
      begin
        Result := StrToInt(Copy(SL.Strings[i], Pos('=', SL.Strings[i]) + 1, 255));
        Break;
      end;
  except
    Result := MyMessageDlg.ReceiveInteger('Please input the value of ..', Key, '  ', 1, 30, 1);
  end;
end;

function TMain.GetFloatValue(Key: String): Double;
var i : Integer;
begin
  Result := 1;
  try
    for i := 3 to SL.Count - 1 do
      if Pos(Key, SL.Strings[i]) > 0 then
      begin
        Result := RoundToDecimalSF(StrToFloat(Copy(SL.Strings[i], Pos('=', SL.Strings[i]) + 1, 255)), 5);
        Break;
      end;
  except
    Result := MyMessageDlg.ReceiveFloat('Please input the value of ..', Key, ' ', 0, 60, 1);
  end;
end;

function TMain.RoundToDecimalSF(Value : Double; SigFig : Integer) : Double;
var
  Places: ShortInt;
  N : Double;
begin
  if Value <> 0 then
  begin
    Places := SigFig - Ceil(log10(Abs(Value)));
    N := Power(10.0, Places);
    RoundToDecimalSF := (Round(Value * N) )/ N;
  end
  else
    RoundToDecimalSF := Value;
end;

function TMain.GetString(Key: String): String;
var i : Integer;
begin
  Result := '';
  for i := 3 to SL.Count - 1 do
    if Pos(Key, SL.Strings[i]) > 0 then
    begin
      Result := TrimLeft(TrimRight(Copy(SL.Strings[i], Pos('=', SL.Strings[i]) + 1, 255)));
      Break;
    end;
  if Result = '' then
    Result := MyMessageDlg.ReceiveString('Please input the value of ..', Key, '', ' ', 0, 1);
end;

//----------------------------------------------------------
procedure TMain.GetConfiguration(Sender: TObject);
begin
  Execute1.Enabled := True;
  ToolButton4.Enabled := True;
  //------ DialogBox Management ----------//
  while DialogBox <> 0 do
    case DialogBox of
    1:begin
        GeneralInfo := TGeneralInfo.Create(Self);
        GeneralInfo.ShowModal;
        GeneralInfo.Release;
        Goahead := True;
      end;
    2:begin
        PositionInfo := TPositionInfo.Create(Self);
        PositionInfo.seNumLayer.Value := NumLayer;
        PositionInfo.seNumObs.Value := NumObs;
        PositionInfo.ShowModal;
        PositionInfo.Release;
      end;
    3:begin
        if Water <> 1 then
          DialogBox := 5
        else
        begin
          SendDataToSoil;
          Soil.ShowModal;
          RetrieveDataFromSoil;
        end;
      end;
    4:begin
        if Water <> 1 then
          DialogBox := 1
        else
        begin
          Kparams := TKparams.Create(Self);
          SendDataToSoil;
          SendDataToKparams;
          Kparams.ShowModal;
          RetrieveDataFromSoil;
          RetrieveDataFromKparams;
          KParams.Release;
        end;
      end;
    5:begin
        if ((Water <> 1) and (Mode = 1)) or (solute <> 1) then
          if GoAhead = True then DialogBox := 6 else DialogBox := 4
        else
        begin
          STparams := TSTparams.Create(Self);
          STparams.ShowModal;
          STparams.Release;
        end;
      end;
    6:begin
        if heat <> 1 then
          DialogBox := 8
        else
        begin
          THCparams := TTHCparams.Create(Self);
          THCparams.ShowModal;
          THCparams.Release;
        end;
      end;
    7:begin
        if heat <> 1 then
          DialogBox := 5
        else
        begin
          EnFactor := TEnFactor.Create(Self);
          EnFactor.ShowModal;
          EnFactor.Release;
        end;
      end;
    8:begin
        if Water <> 1 then
          DialogBox := 10
        else
        begin
          WaterInfo := TWaterInfo.Create(Self);
          WaterInfo.ShowModal;
          WaterInfo.Release;
        end;
      end;
    9:begin
        if Water <> 1 then
          DialogBox  := 7
        else
          if (Mode <> 2) or (IPET_type <> 2) then
          begin
            AtmosBC := TAtmosBC.Create(Self);
            AtmosBC.ShowModal;
            AtmosBC.Release;
          end
          else
            DialogBox := 0;
      end;
   10:begin
        if (solute <> 1) or (Mode = 2) then
        begin
          if GoAhead = True then
            DialogBox := 0
          else
            DialogBox := 9;
        end
        else
        begin
          SoluteInfo := TSoluteInfo.Create(Self);
          SoluteInfo.ShowModal;
          SoluteInfo.Release;
        end;
      end;
   11:begin
        if Water = 1 then
        begin
          InverseInfo := TInverseInfo.Create(Self);
          InverseInfo.ShowModal;
          InverseInfo.Release;
        end
        else
        begin
          SoluteInverseInfo := TSoluteInverseInfo.Create(Self);
          SoluteInverseInfo.ShowModal;
          SoluteInverseInfo.Release;
        end;
      end;
   -1:begin
        Language;
        Exit;
      end;
    end;
  FileSaveQuery;
  if AllowPerform = 1 then
    Perform(Sender);
end;
//----------------------------------------------------------
procedure TMain.Perform(Sender: TObject);
var
  {$ifdef Linux}
  button: TMessageButton;
  {$else}
  button: Integer;
  {$endif}
begin
  //SendDataToKparams;
  if Mode <> 2 then
  begin
    {$ifdef Linux}
    button:= Application.MessageBox('Would you like to watch graphs at each recording interval?', 'If you want fast termination, please click [NO]', [smbYes, smbNo, smbCancel]);
    case button of
      smbCancel: Exit;
      smbYes : Graph := 1;
      else
        Graph := 0;
    end;
    {$else}
    button:= Application.MessageBox('Would you like to watch graphs at each recording interval?', 'If you want fast termination, please click [NO]', MB_YESNOCANCEL or mb_iconquestion);
    case button of
      id_cancel: Exit;
      id_Yes : Graph := 1;
      else
        Graph := 0;
    end;
    {$endif}
  end;
  StatusBar1.Panels[0].Text := Msg[2];
  Case Mode of
  1:Simulator.Simulate;
  2:begin
      SendDataToSoil;
      ParamEstimator:= TParamEstimator.Create(Self);
      ParamEstimator.Release();
    end;
  end;
  ShowObservationFigure.Enabled := True;
  StatusBar1.Panels[0].Text := '  ' + comment;
  if rec = 1 then
    AnimatedFigure1Click(Sender);
end;
//----------------------------------------------------------
procedure TMain.PrintClick(Sender: TObject);
{$ifdef MSWINDOWS}
var
  ADevice, Adriver, Aport: array[0..255] of Char;
  DeviceHandle: Thandle;
  DevMode: PDeviceMode;
{$endif}
begin
{$ifdef MSWINDOWS}
  //if PrinterSetupDialog1.Execute then
  begin
    Printer.GetPrinter(ADevice, Adriver, Aport, DeviceHandle);
    DevMode := GlobalLock(DeviceHandle);
    with DevMode^ do
      begin
      dmFields := dmFields or DM_ORIENTATION;
      dmOrientation := DMORIENT_LANDSCAPE;
      end;
    if not DeviceHandle = 0 then GlobalUnLock(DeviceHandle);
    Print;
  end;
{$endif}
end;
//--------  Call from Menu -> Input  ----------------------
procedure TMain.IGClick(Sender: TObject);
begin
  DialogBox := 1;
  GoAhead:=True;
  GetConfiguration(Sender);
end;
procedure TMain.IPClick(Sender: TObject);
begin
  DialogBox :=2; GoAhead:=True;
  GetConfiguration(Sender);
end;
procedure TMain.ISRClick(Sender: TObject);
begin
  DialogBox :=3; GoAhead:=True;
  GetConfiguration(Sender);
end;
procedure TMain.ISKClick(Sender: TObject);
begin
  DialogBox :=4; GoAhead:=True;
  GetConfiguration(Sender);
end;
procedure TMain.ISSClick(Sender: TObject);
begin
  DialogBox :=5; GoAhead:=True;
  GetConfiguration(Sender);
end;
procedure TMain.ISHClick(Sender: TObject);
begin
  DialogBox :=6; GoAhead:=True;
  GetConfiguration(Sender);
end;
procedure TMain.ISEClick(Sender: TObject);
begin
  DialogBox :=7; GoAhead:=True;
  GetConfiguration(Sender);
end;
procedure TMain.IWClick(Sender: TObject);
begin
  DialogBox :=8; GoAhead:=True;
  GetConfiguration(Sender);
end;
procedure TMain.IAClick(Sender: TObject);
begin
  DialogBox :=9; GoAhead:=True;
  GetConfiguration(Sender);
end;
procedure TMain.ISMClick(Sender: TObject);
begin
  DialogBox :=10; GoAhead:=True;
  GetConfiguration(Sender);
end;
procedure TMain.IIClick(Sender: TObject);
begin
  DialogBox  := 11; GoAhead:=True;
  GetConfiguration(Sender);
end;
//---------------------------------------------------------------------------
procedure TMain.Exit1Click(Sender: TObject);
begin
  Close;
end;
//----------------------------------------------------------
procedure TMain.TreatHistoryFile;
begin
  if rec <> 1 then Exit;
  dumstr := BaseDir + Slash + 'History' + Slash;
  dumstr := dumstr + ExtractFileName(CaseName) + '_001.out';
  if FileExists(dumstr) = False then Exit;
  {$ifdef Linux}
  if Application.MessageBox(PChar(Msg[3]), PChar(Msg[4]),
     [smbYes, smbNo]) = smbNo then
  {$else}
  if Application.MessageBox(PChar(Msg[3]), PChar(Msg[4]),
     mb_yesno or mb_iconquestion) = id_no then
  {$endif}
    DeleteHistoryFile
  else
    with ZipMaster do
    begin
      FSpecArgs.Clear;
      ZipFileName := CaseName + '_history.zip';
      dumstr := BaseDir + Slash + 'History' + Slash;
      if DirectoryExists(dumstr) = True then
        FSpecArgs.Add(dumstr);
      Add;
      Application.ProcessMessages;
      DeleteHistoryFile;
    end
end;

procedure TMain.DeleteHistoryFile;
var i: Integer;
begin
  for i := 0 to Ceil(t_end / int_rec) do
  begin
    dumstr := BaseDir + Slash + 'History' + Slash;
    dumstr := dumstr + ExtractFileName(CaseName) + '_' + FormatFloat('000', i) + '.out';
    if FileExists(dumstr) = True then
      DeleteFile(dumstr);
  end
end;

//------------------------------------------------------------------
procedure TMain.FormClose(Sender: TObject; var Action: TCloseAction);
var
  IniFile: TIniFile;
begin
  IniFile := TIniFile.Create(ChangeFileExt(Application.ExeName, '.ini'));
  try
    IniFile.WriteString('Options', 'CurrentFolder', GetRelativeDirectory(ExeDir, BaseDir));
  finally
    IniFile.Free;
  end;
  ShowResult.Timer1.Enabled := False;
  TreatHistoryFile;
  Soil.Release;
  ShowResult.Free;
  SL.Free;
  Simulator.Free;
  ZipMaster.Free;
  Application.Terminate;
end;
//----------------------------------------------------------
procedure TMain.SaveInformations(Sender: TObject);
var
  i: Integer;
begin
  AllowPerform := 0;
  with SaveDialog1 do
  begin
    InitialDir := BaseDir;
    FileName := ExtractFileName(CaseName) + '.in';
    if Execute = True then
    begin
   //   ShowMessage(IntToStr(Pos('Demo', FileName)));
      if (Pos('Demo', ExtractFileName(FileName)) <> 0) or (ExtractFileDir(FileName) = ExeDir + Slash + 'Examples') then
      begin
        ShowMessage(Msg[6]);
        Exit;
      end;
      {
      if AnsiLowerCase(ExtractFileDir(FileName)) = AnsiLowerCase(ExeDir + Slash + 'Examples') then
      begin
        dumstr3 := 'You cannot save the case file into "\Examples". Please save it into another directory.';
        if Application.MessageBox(PChar(dumstr3), PChar(dumstr2), MB_OK) = IDOK
          then Exit;
      end;
      }
      if FileExists(FileName) then
        {$ifdef Linux}
        if Application.MessageBox(PChar(Msg[5]), PChar(''), [smbYes, smbNo]) = smbNo then
        {$else}
        if Application.MessageBox(PChar(Msg[5]), PChar(''), MB_YESNO + MB_ICONQUESTION) = IDNO then
        {$endif}
          Exit;
      AllowPerform := 1;
      FileName := ChangeFileExt(FileName, '.in');
      CaseName := Copy(FileName,1,Length(FileName)-3);
      BaseDir := ExtractFileDir(CaseName);
      Caption := 'WASH_1D - ' + ExtractFileName(CaseName);
      if rec0 = 1 then
        rec := 1;
      SaveInFile(True);
      if (Water = 1) or (Mode = 2) then
        for i := 1 to NumLayer do
        begin
          SendDataToSoil;
          Soil.SaveSoilProperty(i, True);
          RetrieveDataFromSoil;
        end;
        //  dumstr := FileName;
        //  Delete(dumstr, 1, Length(ExeDir));
      if RecentFileName[1] <> dumstr then
      begin
        RecentFile := TRecentFile.Create(Self);
        dumint := 11;
        dumstr := FileName;
        //Delete(dumstr, 1, Length(ExeDir));
        RecentFileName[12] := dumstr;
        //RecentFile.ListBox1.ItemIndex := 11;
        RecentFile.Close;
        RecentFile.Release;
      end
      else
        RecentFile.SaveRecentFile;
    end;
  end;
  GetVirtualFile;
end;

procedure TMain.SaveInFile(WriteOnFile: Boolean);
var i: Integer;
begin
  with SL do
  begin
    Clear;
    Add('>>>>>>>>>  Case Information File for WASH_1D version 1.363 <<<<<<<<<<<');
    Add('');
    Add(comment);
    Add('');
    Add('============ General Information ======================');
    Add('Mode = ' + IntToStr(MODE));
    Add('water = ' + IntToStr(water));
    Add('solute = ' + IntToStr(solute));
    Add('heat = '+ IntToStr(heat));
    Add('--- Position Information ----');
    Add('depth of lower boundary = ' + FloatToStr(z_lb));
    Add('space increment at the top = ' + FloatToStr(z[1]));
    Add('space increment at the bottom = ' + FloatToStr(dz_bot));
    Add('number of layer = ' + IntToStr(NumLayer));
    if NumLayer >= 2 then
      for i := 1 to NumLayer - 1 do
        Add(' depth of ' + IntToStr(i) + PositionInfo.Suffix(i) + 'border = ' + FloatToStr(z_border[i]));
    Add('number of observation point = ' + IntToStr(NumObs));
    for i := 1 to NumObs do
      Add(' depth of ' + IntToStr(i) + PositionInfo.Suffix(i) + ' observation point = ' + FloatToStr(z_obs[i]));
    Add('--- time discretization ---- ');
    Add('unit of time = ' + IntToStr(t_unit));
    Add('final time = '+ FloatToStr(t_end));
    Add('initial time increment = ' + FloatToStr(dt_ini));
    Add('maximum time increment = ' + FloatToStr(dt_max));
    Add('interval of report = ' + FloatToStr(int_rec));
    Add('record profiles at the interval = ' + IntToStr(rec));
    if Water = 1 then
    begin
      Add('--- numerical detail ---- ');
      Add('handling of water capacity = ' + IntToStr(IterationScheme));
      Add('method for giving interblock conductivity = ' + IntToStr(InterHyCon));
      Add('maximum permissible difference of pressure head in a time step = ' + FloatToStr(TargetMaxDiff_logP));
      Add('target relative error in water budget  at each time step = ' + FloatToStr(TargetESRErrorW));
      Add('lower boundary of target range for Celia' + #39 + 's iteration = ' + IntToStr(LowerTargetIteration ));
      Add('upper boundary of target range for Celia' + #39 + 's iteration = ' + IntToStr(UpperTargetIteration ));
      Add('angle of soil surface = ' + IntToStr(Angle));
      Add('criteria for Celia' + #39 + 's iteration = ' + FloatToStr(CriteriaForCeliasIteration));
      Add('consider hysteresis = ' + IntToStr(ConsiderHysteresis));
    end;
    Add('--- name of the soil ---');
    for i := 1 to NumLayer do
      Add(IntToStr(i) + PositionInfo.Suffix(i) + ' layer = ' + SoilName[i]);
    //--- Water flow ---//
    Case ic_type of
    1: begin dumstr := 'initial volumetric water content = '; dum := W_ini; end;
    2: begin dumstr := 'initial pressure head(cm) = '; dum := P_ini; end;
    3: begin dumstr := 'initial pressure head(cm) at the top = '; dum := P_top_ini; end;
    4: begin dumstr := 'file name for water content profile = ' + GetRelativeDirectory(BaseDir, fl_profile); end;
    end;
    if (Mode = 2) and (IPET_type = 1) and (UseOutflowforK = 0) then
    begin dumstr := 'initial pressure head(cm) at the top = '; dum := P_top_ini; end;
    if (water = 1) or (Mode = 2) then
    begin
      Add('');
      Add('=========== Water Flow Information ==========');
      Add('type of initial condition for water = ' + IntToStr(ic_type));
      Add('type of upper boundary condition for water = ' + IntToStr(u_bc_type));
      Add('type of lower boundary condition for water = ' + IntToStr(l_bc_type));
      if ic_type <= 3 then
        Add(dumstr + FloatToStr(dum))
      else
        Add(dumstr);
      case u_bc_type of
      1: Add('solution flux at the top = ' + FloatToStr(ql_top));
      2: Add('pressure head(cm) at the top = ' + FloatToStr(Hpond));
      end;
      Add('pressure head(cm) at the bottom = ' + FloatToStr(p_bot));
      Add('hydraulic conductance of the filter = ' + FormatFloat('0.#######', HC_filter));
      if fl_profile <> '' then
        Add('file name for initial VWC profile = ' + GetRelativeDirectory(BaseDir, fl_profile));
      if fl_ql_top <> '' then
        Add('file name for solution flux at the soil surface = ' + GetRelativeDirectory(BaseDir, fl_ql_top));
      case l_bc_type of
      4: Add('file name for lower pressure head change = ' + GetRelativeDirectory(BaseDir, fl_p_bot));
      5: Add('file name for measured outflow data = ' + GetRelativeDirectory(BaseDir, fl_outflow));
      end;
      Add('initially drying? = ' + BoolToStr(IniDrying));
      Add('>>-- Atmospheric Boundary Condition --<<');
      Add('type of A.B.C. = ' + IntToStr(abc_type));
      Add('aerodynamic resistance = ' + FormatFloat('#0.000', ra));
      Add('temperature of air = '+ FloatToStr(Tair));
      Add('relative humidity of air = ' + FloatToStr(RHair));
      if abc_type = 3 then
        Add('file name for measured evaporation rate = ' + GetRelativeDirectory(BaseDir, fl_CumEvap));
      if fl_clmtc_con <> '' then
        Add('file name for climatic condition = ' + GetRelativeDirectory(BaseDir, fl_clmtc_con));
    end;
    //--- Solute Movement ---//
    if solute = 1 then
    begin
      Add('');
      Add('============ Solute Movement ===========');
      Add('Convective Random Walk Model = ' + IntToStr(CRWM));
      Add('mass simulated by a particle = ' + FloatToStr(MPP));
      Add('type of initial condition for solute = ' + IntToStr(s_ic_type));
      Add('type of upper boundary condition for solute = ' + IntToStr(s_u_bc_type));
      Add('type of lower boundary condition for solute = ' + IntToStr(s_l_bc_type));
      Add('type of solute = ' + IntToStr(s_type));
      Add('salty crust resistance = ' + IntToStr(S_crust));
      Add('Apply surface modification for CDE? = ' + BoolToStr(CDE_surface_modification));
      Add('initial concentraion = ' + FloatToStr(C_ini));
      Add('concentration of irrigation water = ' + FloatToStr(C_irg));
      Add('concentration at the lower boundary = '+ FloatToStr(C_bot));
      Add('crystallization rate constant = '+ FloatToStr(alpha_crys));
      if water <> 1 then
      begin
        Add('dispersion coefficient =' + FloatToStr(Ds));
        Add('average pore water velocity = ' + FloatToStr(Vfixed));
      end;
    if s_ic_type > 1 then
      Add('file name for initial concentration profile = ' + GetRelativeDirectory(BaseDir, fl_iniCprofile));
    if s_u_bc_type = 2 then
      Add('file name for concentration of irrigation water = ' + GetRelativeDirectory(BaseDir, fl_C_irg));
    if s_l_bc_type = 2 then
      Add('file name for concentration at the lower boundary = ' + GetRelativeDirectory(BaseDir, fl_C_bot));
    end;
    //--- Heat Movement ---//
    if heat = 1 then
    begin
      Add('');
      Add('============ Heat Movement ===========');
      Add('type of lower boundary condition for heat = ' + IntToStr(h_l_bc_type));
      Add('temperature at the lower boundary = '+ FloatToStr(Tbot));
    end;
    Add('initial temperature = ' + FloatToStr(Tini));
    //--- Inverse Parameter Estimation ---//
    if Mode = 2 then
    begin
      Add('');
      Add('============ Inverse Parameter Estimation ===========');
      Add('type of I.P.E. = '+ IntToStr(IPET_type));
      Add('use of tensiometer = ' + IntToStr(Tensio));
      if IPET_type <= 2 then
        Add('use of outflow data for estimating hydraulic conductivity function = ' + IntToStr(UseOutFlowForK));
      if IPET_type = 2 then
        Add('use of additional retention data = ' + IntToStr(AddRetData));
      if IPET_type = 3 then
      begin
        Add('Time when the slicing was performed = ' + FloatToStr(t_slicing));
        Add('Thickness of the sliced layer =' + FloatToStr(z_slice));
        Add('V.W.C. of the sliced layer = ' + FloatToStr(W_slice));
      end;
      if IPET_type = 11 then
        Add('file name for concentration profile = ' + GetRelativeDirectory(BaseDir, fl_c_profile));
      Add('independet determination of the retention curve = ' + IntToStr(independent));
      Add('volumetric water content at the end = ' + FloatToStr(W_end));
      Add('fixation of saturated volumetric water content = ' +  IntToStr(WsatFix));
      Add('fixation of pressure head(cm) at oven dry = ' + IntToStr(LlambdaFix));
      Add('linkage of m to n = ' + IntToStr(Linked_m));
      Add('fixation of weighting factor in the bimodal retention function = ' + IntToStr(spFix));
      Add('fixation of zeta in the retention function = ' + IntToStr(ZetaFix));
      Add('fixation of resident water content = ' + IntToStr(WrFix));
      Add('fixation of saturated hydraulic conductivity = ' + IntToStr(KsatFix));
      Add('fixation of ak value in the hydraulic conductivity function = ' + IntToStr(akFix));
      Add('fixation of bk value in the hydraulic conductivity function = ' + IntToStr(bkFix));
      if (IPET_type <= 3) or (IPET_type = 6) then
        Add('file name for measured outflow data = ' + GetRelativeDirectory(BaseDir, fl_outflow));
      if IPET_type = 1 then
      begin
        Add('file name for measured evaporation data = ' + GetRelativeDirectory(BaseDir, fl_CumEvap));
        Add('use of additional hydraulic conductivity data = ' + IntToStr(UseAdditionalHyConData));
        if UseAdditionalHyConData = 1 then
          Add('file name for additional hydraulic conductivity data = ' + GetRelativeDirectory(BaseDir, fl_HyConData));
      end
      else
        if Tensio >= 1 then
        begin
          Add('file name for pressure head measured by the tensiometer = ' + GetRelativeDirectory(BaseDir, fl_pressure));
        end;
      if (IPET_type = 2) and (l_bc_type = 5) then
        Add('file name for lower pressure head change = ' + GetRelativeDirectory(BaseDir, fl_p_bot));
      if (IPET_type = 1) or (IPET_type = 5) then
        Add('file name for measured water content profile = ' + GetRelativeDirectory(BaseDir, fl_profile));
      if fl_retention <> '' then
        Add('file name for additional retention data = ' + GetRelativeDirectory(BaseDir, fl_retention));
      if IPET_type = 5 then
      begin
        if fl_front = '' then
          UseFrontForK := 0
        else
          UseFrontForK := 1;
        if fl_profile = '' then
          UseProfileForK := 0
        else
          UseProfileForK := 1;
        Add('use of infiltrating front for estimating hydraulic conductivity function = ' + IntToStr(UseFrontForK));
        Add('use of final water content profile for estimating hydraulic conductivity function = ' + IntToStr(UseProfileForK));
        Add('file name for cumutlative infiltration = ' + GetRelativeDirectory(BaseDir, fl_outflow));
        Add('file name for depth of infiltrating front = ' + GetRelativeDirectory(BaseDir, fl_front));
        Add('V.W.C. of the wetting front = ' + FloatToStr(Wfront));
      end;
    end;
    if WriteOnFile then
      SaveToFile(SaveDialog1.FileName)
    else
      VirtualFile := Text;
  //  Clipboard.AsText := Text;
  end;
end;

function TMain.CheckModified: Boolean;
var
  OldVirtualFile: String;
  {$ifdef debugging}
  i: Integer;
  {$endif}
begin
  OldVirtualFile := VirtualFile;
  GetVirtualFile;
  {$ifdef debugging}
  for i := 1 to Length(OldVirtualFile) - 1 do
  begin
    if OldVirtualFile[i] <> VirtualFile[i] then
      ShowMessage('Old:' + #13#10 +  Copy(OldVirtualFile, i, 70) + #13#10  + #13#10 + 'New:' + #13#10 + Copy(VirtualFile, i, 70));
  end;
  {$endif}
  if OldVirtualFile = VirtualFile then
    Result := False
  else
    Result := True;
end;

procedure TMain.GetVirtualFile;
var i: Integer;
begin
  SaveInFile(False);
  for i := 1 to NumLayer do
  begin
    SendDataToSoil;
    Soil.SaveSoilProperty(i, False);
    VirtualFile := VirtualFile + Soil.VirtualFile;
    RetrieveDataFromSoil;
  end;
end;

function TMain.BoolToStr(V: Boolean): String;
begin
  if V = True then
    Result := 'True'
  else
    Result := 'False';
end;

function TMain.StrToBool(S: String): Boolean;
begin
  if S = 'True' then
    Result := True
  else
    Result := False;
end;
//----------------------------------------------------------
procedure TMain.About1Click(Sender: TObject);
begin
  GreetingBox:= TGreetingBox.Create(Self);
  with GreetingBox do
  begin
    ShowModal;
    Free;
  end;
end;
//----------------------------------------------------------
procedure TMain.ConvertToRateClick(Sender: TObject);
begin
  JustLoading := 0;
  ShowResult.ConvertToRate;
end;
////////////////////////////  Graphic Module  //////////////////////////////////
procedure TMain.Profile;
var
  Gheight, Gwidth, Glmargin, Grmargin, Gtmargin, Gbmargin, i: Integer;
//  GXmax, GXmin, GYmax, GYmin : Single;
begin
  Panel2.Left := Trunc(50*adjuster);
  Panel2.top  := Trunc(315*adjuster);
  Gheight  := Trunc(5*45*adjuster);
  Gwidth   := Trunc(6*50*adjuster);
  Glmargin := Trunc(50*adjuster);
  Grmargin := Trunc(45*adjuster);
  Gtmargin := Trunc(50*adjuster);
  Gbmargin := Trunc(40*adjuster);
  Image1.Width  := Gwidth  + Glmargin + Grmargin;
  Image1.Height := Gheight + Gtmargin + Gbmargin;
  Panel2.Width  := Image1.Width + 8;
  Panel2.Height := Image1.Height + 8;
  HyperText.TargetCanvas := Image1.Canvas;
  with Image1.Canvas do
  begin
    Brush.Color := clWhite;
    Brush.Style:= bsSolid;
    Rectangle(-1, -1, Image1.Width+1, Image1.Height+1);
    Pen.Color := clBlack;
    Image1.Canvas.Font.Size := Trunc(StdFontSize * adjuster);
    Rectangle (Glmargin, Gtmargin, Glmargin + Gwidth, Gtmargin + Gheight);
    //----  U axis ----//
    for i := 0 to 5 do
    begin
      Moveto(Glmargin + Gwidth div 6 * i, Gtmargin);
      Lineto(Glmargin + Gwidth div 6 * i, Gtmargin + 8);
    end;
    Font.Color := clBlue;
    SetDefaultFont;
    for i := 0 to 6 do
      TextOut(Glmargin + Gwidth div 6 * i - Trunc(4 *adjuster) , Gtmargin - Trunc(20*adjuster), FloatToStr(0.1*i));
    TextOut(Glmargin + Trunc(80*adjuster) , Gtmargin- Trunc(38*adjuster) , Msg[7]);
    //----  X axis ----//
    Pen.Color := clSilver;
    Pen.Style := psDot;
    for i := 1 to 5 do
    begin
      Moveto(Glmargin + Gwidth div 6 * i, Gtmargin);
      Lineto(Glmargin + Gwidth div 6 * i, Gtmargin + Gheight);
    end;
    if solute = 1 then
    begin
      Font.Color := $009090;
      for i := 0 to 6 do
        TextOut(Glmargin + Gwidth div 6 * i - 3 , Gtmargin  + Gheight + 1, FloatToStr(i));
      HyperText.Write(Msg[8], Glmargin + Trunc(70*adjuster) , Gtmargin + Gheight + Trunc(20*adjuster), 0);
      SetDefaultFont;
    //  TextOut(Glmargin + Trunc(75*adjuster) , Gtmargin + Gheight + Trunc(20*adjuster) , dumstr);
    end;
    if heat = 1 then
    begin
      Font.Color := $000080FF;
      for i := 1 to 5 do
        TextOut(Glmargin + Gwidth div 6 * i - 4 , Gtmargin  + Gheight - Trunc(22*adjuster) , FloatToStr(10*i));
      TextOut(Glmargin+ Trunc(100*adjuster) , Gtmargin + Gheight - Trunc(40*adjuster) , Msg[9]);
    end
    else
    begin
      Font.Color := clGray;
      if solute = 1 then
      begin
        for i := 1 to 5 do
          TextOut(Glmargin + Gwidth div 6 * i - 4 , Gtmargin  + Gheight - Trunc(18*adjuster) , FloatToStr(-200 + 40 * i));
        dumint := - Trunc(32*adjuster);
      end
      else
      begin
        for i := 0 to 6 do
          if P[n] > -150 then
            TextOut(Glmargin + Gwidth div 6 * i - 4 , Gtmargin  + Gheight + 2 , FloatToStr(-150 +  25 * i))
          else
            TextOut(Glmargin + Gwidth div 6 * i - 4 , Gtmargin  + Gheight + 2 , FloatToStr(-900 + 150 * i));
        dumint := Trunc(20*adjuster);
      end;
      TextOut(Glmargin+ Trunc(95*adjuster) , Gtmargin + Gheight + dumint , Msg[10]);
    end;
    //----- Y axis ----//
    Font.Color := clBlack;
    for i := 1 to 4 do
    begin
      Moveto(Glmargin          , Gtmargin + Gheight - Gheight * i div 5);
      Lineto(Glmargin + Gwidth , Gtmargin + Gheight - Gheight * i div 5);
    end;
    if z_lb < 25 then dumint := 10 else dumint := 25;
    dumint := (Ceil(z_lb / dumint) * dumint) div 5;
    for i := 0 to 5 do
      TextOut(Glmargin - Trunc(20*adjuster) , Gtmargin + Gheight * i div 5 - 5, FloatToStr(i*dumint));
    TextOut(Trunc(2*adjuster), Trunc(160*adjuster) , Msg[11]);
    TextOut(0,Trunc(180*adjuster) , '(cm)');
    Pen.Style := psSolid;
    if (Mode = 2) and (IPET_type = 1) then
    begin
      Pen.Color := clOlive;
      Moveto (Glmargin + 50 - 20, Gtmargin + Gheight * 3 div 4 - 11);
      Lineto (Glmargin + 50 +  5, Gtmargin + Gheight * 3 div 4 - 11);
      Font.Size := Trunc(StdFontSize * adjuster);
      TextOut(Glmargin + 50 + 10, Gtmargin + Gheight * 3 div 4 - 16, 'Measured water content');
    end;
    Pen.Color := cl3DLight;
    Moveto(Image1.Width - 1, 0);
    Lineto(Image1.Width - 1, Image1.Height - 1);
    Lineto(0, Image1.Height - 1);
  end;
  //sleep(1000);
  Panel2.Visible := True;
end;
//----------------------------------------------------------
procedure TMain.ProfileDraw(GX, GY : Array of Double; NumPoint: Integer; GXmin, GXmax :Double; Lcol: Integer);
var
  Gheight, Gwidth, Glmargin, Gtmargin,i: Integer;
  GYmax, GYmin : Single;
begin
  Gheight  := Trunc(5*45*adjuster);
  Gwidth   := Trunc(6*50*adjuster);
  Glmargin := Trunc(50*adjuster);
  Gtmargin := Trunc(50*adjuster);
  if z_lb < 25 then
    dumint := 10
  else
    dumint := 25;
  GYmax := Ceil(z_lb / dumint) * dumint;
  GYmin := 0;
  with Image1.Canvas do
  begin
    Pen.Color := Lcol;
    if GX[NumPoint] < GXmin then
      GX[NumPoint] := GXmin;
    Moveto(Glmargin + Trunc((GX[NumPoint] - GXmin)/(GXmax - GXmin) * Gwidth), Gtmargin + Trunc((GY[NumPoint] - GYmin)/(GYmax - GYmin) * Gheight));
    for i := NumPoint - 1 downto 1 do
    begin
      if GX[i] < GXmin then
        Moveto(Glmargin, Gtmargin + Trunc((GY[i] - GYmin)/(GYmax - GYmin) * Gheight))
      else
        Lineto(Glmargin + Trunc((GX[i] - GXmin)/(GXmax - GXmin) * Gwidth), Gtmargin + Trunc((GY[i] - GYmin)/(GYmax - GYmin) * Gheight));
    end;
  end;
end;
//----------------------------------------------------------
procedure TMain.FluxProfile;
var
  Gheight, Gwidth, Glmargin, Grmargin, Gtmargin, Gbmargin ,i: Integer;
  GXmax, GXmin: Single;
begin
  Panel3.Left := Trunc(480*adjuster);
  Panel3.top  := Trunc(315*adjuster);
  Gheight  := Trunc(5*45*adjuster);
  Gwidth   := Trunc(8*50*adjuster);
  Glmargin := Trunc(50*adjuster);
  Grmargin := Trunc(40*adjuster);
  Gtmargin := Trunc(50*adjuster);
  Gbmargin := Trunc(40*adjuster);
  if abc_type = 1 then
  begin
    GXmax := 0;
    GXmin := -100;
  end
  else
  begin
    GXmax := 40;
    GXmin := -60;
  end;
  Image2.Width  := Gwidth  + Glmargin + Grmargin ;
  Image2.Height := Gheight + Gtmargin + Gbmargin ;
  Panel3.Width  := Image2.Width  + 8;
  Panel3.Height := Image2.Height + 8;
  Image2.Canvas.Font.Assign(Image1.Canvas.Font);
  with Image2.Canvas do
  begin
    Brush.Color := clWhite;
    Pen.Color := clWhite;
    Rectangle(-1,-1,Image2.Width+1, Image2.Height+1);
    //----  X axis ----//
    Pen.Color := clBlack;
    Pen.Style := psSolid;
    Moveto(Glmargin         , Gtmargin);
    Lineto(Glmargin + Gwidth, Gtmargin);
    Pen.Style := psDot;
    Pen.Color := clSilver;
    for i := 0 to 10 do
    begin
      Moveto(Glmargin + Gwidth div 10 * i, Gtmargin);
      Lineto(Glmargin + Gwidth div 10 * i, Gtmargin + Gheight);
    end;
    for i := 0 to 10 do
      TextOut(Glmargin + Gwidth div 10 * i - Trunc(14 *adjuster) , Gtmargin - Trunc(20*adjuster), Simulator.SetLengthRJ( FloatToStr(GXmin + i * (GXmax - GXmin)/10), 4));
    TextOut(Glmargin+ Trunc(120*adjuster) , Gtmargin- Trunc(40*adjuster) , Msg[12]);
    //----- Y axis ----//
    for i := 0 to 4 do
    begin
      Moveto(Glmargin         , Gtmargin + Gheight - Gheight * i div 5);
      Lineto(Glmargin + Gwidth, Gtmargin + Gheight - Gheight * i div 5);
    end;
    Pen.Style := psSolid;
   {
    for i := 0 to 6 do
      TextOut(Glmargin - Trunc(20*adjuster) , Gtmargin + Gheight * i div 6 - 5, FloatToStr(i*10));
    TextOut(Trunc(8*adjuster) ,Trunc(190*adjuster) , 'z');
    TextOut(0,Trunc(205*adjuster) , '(cm)');
   }
    Font.Color := clBlack;
    SetDefaultFont;
    if abc_type <> 1 then
    begin
      Pen.Color := clAqua;
      Moveto (Glmargin + Gwidth * 4 div 5 - 30, Gtmargin + Gheight * 2 div 3);
      Lineto (Glmargin + Gwidth * 4 div 5     , Gtmargin + Gheight * 2 div 3);
      TextOut(Glmargin + Gwidth * 4 div 5 +  5, Gtmargin + Gheight * 2 div 3 - 4, Msg[13]);
      Pen.Color:= clNavy;
      Moveto (Glmargin + Gwidth * 4 div 5 - 30, Gtmargin + Gheight * 2 div 3 + 21);
      Lineto (Glmargin + Gwidth * 4 div 5     , Gtmargin + Gheight * 2 div 3 + 21);
      TextOut(Glmargin + Gwidth * 4 div 5 +  5, Gtmargin + Gheight * 2 div 3 + 17, Msg[14]);
      TextOut(10, Image2.Height - 50, Msg[15]);
      TextOut(140, Image2.Height - 50, '= '+ FormatFloat('##0.0',Evap[counter]) + 'mm/d     ');
    end;
    TextOut(10, Image2.Height - 38, Msg[16]);
    TextOut(140, Image2.Height - 38, '= '+ FormatFloat('##0.0', ql[1]) + 'mm/d     ');
    TextOut(10, Image2.Height - 25, Msg[17]);
    TextOut(140, Image2.Height - 25, '= '+ FormatFloat('##0.0', ql[n]) + 'mm/d     ');
    Pen.Color:= cl3DLight;
    Moveto(Image2.Width - 1, 0);
    Lineto(Image2.Width - 1, Image2.Height - 1);
    Lineto(0, Image2.Height - 1);
  end;
  Panel1.Visible:= False;
  Panel3.Visible:= True;
end;
//----------------------------------------------------------
procedure TMain.FluxProfileDraw(var GX, GY : Array of Double; Lcol: Integer);
var
  Gheight, Gwidth, Glmargin, Gtmargin,i: Integer;
  GXmax, GXmin, GYmax, GYmin: Single;
begin
  Gheight := Trunc(5*45*adjuster);
  Gwidth  := Trunc(8*50*adjuster);
  Glmargin:= Trunc(50*adjuster);
  Gtmargin:= Trunc(50*adjuster);
  if abc_type = 1 then
    begin
    GXmax:= 0; GXmin:= -100
    end
  else
    begin
    GXmax:= 40; GXmin:= -60;
    end;
  if z_lb < 25 then dumint:= 10 else dumint:= 25;
  GYmax:= Ceil(z_lb / dumint) * dumint;
  GYmin:= 0;
  with Image2.Canvas do
    begin
    Pen.Color:= Lcol;
    Moveto(Glmargin + Trunc((GX[1]   - GXmin)/(GXmax - GXmin) * Gwidth), Gtmargin + Trunc((GY[1]   - GYmin)/(GYmax - GYmin) * Gheight));
    for i :=1 to n-1 do
      Lineto(Glmargin + Trunc((GX[i+1] - GXmin)/(GXmax - GXmin) * Gwidth), Gtmargin + Trunc((GY[i+1] - GYmin)/(GYmax - GYmin) * Gheight));
    Pen.Color:= clBlack;
    Moveto(Glmargin + Trunc(Gwidth * (0 - GXmin)/(GXmax - GXmin)), Gtmargin);
    Lineto(Glmargin + Trunc(Gwidth * (0 - GXmin)/(GXmax - GXmin)), Gtmargin + Gheight);
    end;
end;
//----------------------------------------------------------
procedure TMain.History;
var
  Gheight, Gwidth, Glmargin, Grmargin, Gtmargin, Gbmargin, i, j: Integer;
  nday : Integer;
  GXmax: Integer;
  GXmin, GYmax, GYmin, GYmax_, GYmin_: Single;
  dumstr2 : String;
  procedure SetCharset;
  begin
    Image3.Canvas.Font.Assign(Image1.Canvas.Font);
  end;
begin
  Panel4.Left:= Trunc(400*adjuster);
  Panel4.top := Trunc( 45*adjuster);
  Gheight := Trunc(10*20*adjuster);
  Gwidth  := Trunc(480*adjuster);
  Glmargin:= Trunc(70*adjuster);
  Grmargin:= Trunc(20*adjuster);
  Gtmargin:= Trunc(15*adjuster);
  Gbmargin:= Trunc(22*adjuster);
  nday:=Ceil(time_ * t_unit/86400 - 0.01);
  if nday = 0 then
    nday:= 1;
  GXmax:= nday; //2 * (((nday - 1) div 2) + 1);
  GXmin:=  0;
  GYmax:= 40;
  GYmin:=-60;
  Image3.Width := Gwidth  + Glmargin + Grmargin ;
  Image3.Height:= Gheight + Gtmargin + Gbmargin + 5;
  Panel4.Width := Image3.Width  + 8;
  Panel4.Height:= Image3.Height + 8;
  HyperText.TargetCanvas:= Image3.Canvas;
 // HyperText.MagScreen:= 0.1;//1 / HyperText.Adjuster;
  with Image3.Canvas do
  begin
    Brush.Color:= clWhite;
    Brush.Style:= bsSolid;
    Pen.Color:= clWhite;
    Rectangle(-1,- 1, Image3.Width+1, Image3.Height+1);
    Brush.Style:= bsClear;
    Font.Size:= Trunc(0.92 * StdFontSize * adjuster) ;
    SetCharset;
    Font.Color:= clBlack;
    //----  X axis ----//
    Pen.Style:= psDot;
    Pen.Color:= clSilver;
    if nday > 1 then
    begin
      for i := 0 to nday do
      begin
        Moveto(Glmargin + Gwidth div nday * i, Gtmargin); //+ Gheight - Trunc(Gheight * (0 - GYmin)/(GYmax - GYmin)) - 4
        Lineto(Glmargin + Gwidth div nday * i, Gtmargin + Gheight);
      end;
      Font.Color:= clBlack;
      for i := 0 to nday do
        TextOut(Glmargin + Gwidth div nday * i + 1,
                Gtmargin + Gheight - Trunc(Gheight * (0 - GYmin)/(GYmax - GYmin)) + 1,
                Simulator.SetLengthRJ(IntToStr(GXmax div nday * i), 2));
      TextOut(Glmargin+ Trunc(220*adjuster) , Gtmargin + Gheight - Trunc(Gheight * (0 - GYmin)/(GYmax - GYmin)) + Trunc(12*adjuster), Msg[18]);
    end
    else
    begin
      for i := 0 to 6 do
      begin
        Moveto(Glmargin + Gwidth div 6 * i, Gtmargin);
        Lineto(Glmargin + Gwidth div 6 * i, Gtmargin + Gheight);
      end;
      Font.Color:= clBlack;
      for i := 0 to 6 do
        TextOut(Glmargin + Gwidth div 6 * i + 1,
                Gtmargin + Gheight - Trunc(Gheight * (0 - GYmin)/(GYmax - GYmin)) + 1,
                Simulator.SetLengthRJ(IntToStr(24 div 6 * i), 2));
    end;
    //----- Y axis ----//
    for i := 0 to 10 do
    begin
      Moveto(Glmargin         , Gtmargin + Gheight * i div 10);
      Lineto(Glmargin + Gwidth, Gtmargin + Gheight * i div 10);
    end;
    TextOut(Glmargin+ Trunc(220*adjuster) , Gtmargin + Gheight - Trunc(Gheight * (0 - GYmin)/(GYmax - GYmin)) + Trunc(12*adjuster), Msg[19]);
    Pen.Style:= psSolid;
    Pen.Color:= clBlack;
    Moveto(Glmargin + Trunc(Gwidth * (0 - GXmin)/(GXmax - GXmin)), Gtmargin);
    Lineto(Glmargin + Trunc(Gwidth * (0 - GXmin)/(GXmax - GXmin)), Gtmargin + Gheight);
    Pen.Color:= clBlue;
    //
    Moveto (Glmargin + Gwidth * 2 div 3 - 25, Gtmargin + Gheight * 1 div 5 + 8);
    Lineto (Glmargin + Gwidth * 2 div 3 +  5, Gtmargin + Gheight * 1 div 5 + 8);
    Font.Color:=clBlue;
    Font.Size:= Trunc(1.1 * StdFontSize * adjuster);
    dumstr:= ' [s]q[r] at [i]z[ ][a] = ' +  FormatFloat('#0.0', z_obs[1]) + 'cm';
    HyperText.Write(dumstr, Glmargin + Gwidth * 2 div 3 + 10, Gtmargin + Gheight * 1 div 5, 0);
    // cumulative outflow and evaporation //
    if Mode = 2 then
    begin
      Font.Color:=clNavy;
      Font.Size:= Trunc(0.9 * StdFontSize * adjuster);
      //Font.Size:= Trunc(8*adjuster);
      case IPET_type of
      5:begin
          GYmax_:=   8;
          GYmin_:= -12;
          j:= 17;
        end;
      6:begin
          GYmax_:= GYmax * 5;
          GYmin_:= GYmin * 5;
          j:= 22;
        end;
      else
        begin
          GYmax_:= GYmax / 20;
          GYmin_:= GYmin / 20;
          j:= 17;
        end;
      end;
      for i := 0 to 4 do
        TextOut(Glmargin + Trunc(Gwidth * (0 - GXmin)/(GXmax - GXmin)) - Trunc(j * adjuster),
                Gtmargin + Gheight * i div 10 - 3,
                Simulator.SetLengthRJ(FloatToStr(GYmax_ - (GYmax_ - GYmin_) / 10 * i), 3));
      //
      Pen.Color:= clOlive;
      Moveto (Glmargin + Gwidth * 2 div 3 - 25, Gtmargin + Gheight * 3 div 5 - 14);
      Lineto (Glmargin + Gwidth * 2 div 3 +  5, Gtmargin + Gheight * 3 div 5 - 14);
      Font.Color:=clOlive;
      Font.Size:= Trunc(1.1 * StdFontSize * adjuster);
      if IPET_type = 1 then
        dumstr:= ' or [s]S[r][i]E*'
      else
        if Tensio >= 1 then
          dumstr:= ' or [s]y[r]* at [i]z[ ][a] = ' + FormatFloat('#0.0', z_obs[1]) + 'cm'
        else
          dumstr:= '';
      HyperText.Write('[s]S[i][r][~]q[.][_]bot[-]*[ ]' + dumstr ,Glmargin + Gwidth * 2 div 3 + 10, Gtmargin + Gheight * 3 div 5 - 22, 0);
      //
      Pen.Color:= clNavy;
      Moveto (Glmargin + Gwidth * 2 div 3 - 25, Gtmargin + Gheight * 1 div 5 + 22);
      Lineto (Glmargin + Gwidth * 2 div 3 +  5, Gtmargin + Gheight * 1 div 5 + 22);
      Font.Color:=clNavy;
      HyperText.Write('[s]S[r][i][~]q[.][_]bot[-]', Glmargin + Gwidth * 2 div 3 + 10, Gtmargin + Gheight * 1 div 5 + 14, 0);
    end
    else
    // water flux //
    begin
      Font.Color:= clNavy;
      Pen.Color:= clNavy;
      if Mode <> 2 then dum:= 1 else dum:= 10;
      Font.Size:= Trunc(0.9 * StdFontSize * adjuster);
      for i := 0 to 10 do
        TextOut(Glmargin + Trunc(Gwidth * (0 - GXmin)/(GXmax - GXmin)) - Trunc(20*adjuster),
                Gtmargin + Gheight * i div 10 - 4,
                Simulator.SetLengthRJ(FloatToStr(GYmax - (GYmax - GYmin)/ 10 * i),3));
      Moveto (Glmargin + Gwidth * 2 div 3 - 25, Gtmargin + Gheight * 3 div 5 + 28);
      Lineto (Glmargin + Gwidth * 2 div 3 +  5, Gtmargin + Gheight * 3 div 5 + 28);
      Font.Size:= Trunc(StdFontSize * adjuster);
      HyperText.Write(' - [r][i]q[_][.] l bot[ ][-][a] (mm/d)', Glmargin + Gwidth * 2 div 3 + 10, Gtmargin + Gheight * 3 div 5 + 20, 0);
    end;
    if (IPET_type <> 2) then
    begin
      Pen.Color:= clAqua;
      Moveto (Glmargin + Gwidth * 2 div 3 - 25, Gtmargin + Gheight * 3 div 5 + 14);
      Lineto (Glmargin + Gwidth * 2 div 3 +  5, Gtmargin + Gheight * 3 div 5 + 14);
      HyperText.Write('[r][i]E[ ]',Glmargin + Gwidth * 2 div 3 + 10, Gtmargin + Gheight * 3 div 5 + 6, 0);
    end
    else
    begin
      Font.Color:= clTeal;  Pen.Color:= clTeal;  Pen.Style:= psDot;
      Moveto (Glmargin + Gwidth * 2 div 3 - 25, Gtmargin + Gheight * 3 div 5 + 14);
      Lineto (Glmargin + Gwidth * 2 div 3 +  5, Gtmargin + Gheight * 3 div 5 + 14);
      HyperText.Write('[ ][s]y[r][i][_] bot[ ]', Glmargin + Gwidth * 2 div 3 + 10, Gtmargin + Gheight * 3 div 5 + 6, 0);
    end;
    Font.Size:= Trunc(0.9 * StdFontSize * adjuster);
    dumint:= 20;
    // temperature //
    if heat = 1 then
    begin
      Font.Color:= $000080FF;
      dumint:= dumint + 13;
      for i := 0 to 4 do
        TextOut(Glmargin + Trunc(Gwidth * (0 - GXmin)/(GXmax - GXmin)) - Trunc(dumint*adjuster),
                Gtmargin + (Gheight - Trunc(Gheight * (0 - GYmin)/(GYmax - GYmin))) * i div 4 - 4,
                Simulator.SetLengthRJ(FloatToStr(10*(4-i)),2));
    end;
    // water content //
    Font.Color:= clBlue;
    dumint:= dumint + 16;
    Font.Style:= [];
    for i := 0 to 4 do
       TextOut(Glmargin + Trunc(Gwidth * (0 - GXmin)/(GXmax - GXmin)) - Trunc(dumint*adjuster),
               Gtmargin + (Gheight - Trunc(Gheight * (0 - GYmin)/(GYmax - GYmin))) * i div 4 - 4,
               Simulator.SetLengthRJ(FloatToStr(0.1*(4-i)),3));
    // concentration //
    dumint:= dumint + 16;
    if solute = 1 then
    begin
      Font.Color:= $009090;
      for i := 0 to 4 do
        TextOut(Glmargin + Trunc(Gwidth * (0 - GXmin)/(GXmax - GXmin)) - Trunc(dumint*adjuster),
                Gtmargin + (Gheight - Trunc(Gheight * (0 - GYmin)/(GYmax - GYmin))) * i div 4 - 4,
                FloatToStr(2*(4-i)));
    end;
    // pressure head //
    if Mode = 2 then dumint:= 30 else dumint:= 50;
    Font.Color:= clTeal;
    for i := 0 to 5 do
      TextOut(Glmargin + Trunc(Gwidth * (0 - GXmin)/(GXmax - GXmin)) - Trunc(dumint*adjuster),
              Gtmargin + Gheight - Gheight div 10 * i - 4,
              Simulator.SetLengthRJ(FloatToStr(-100*(6-i)),4));
    Pen.Color:= clTeal;  Pen.Style:= psSolid;
    Moveto (Glmargin + Gwidth * 2 div 3 - 25, Gtmargin + Gheight * 3 div 5);
    Lineto (Glmargin + Gwidth * 2 div 3 +  5, Gtmargin + Gheight * 3 div 5);
    Font.Size:= Trunc(1.1 * StdFontSize * adjuster);
    HyperText.Write('[s]y[r] at [i]z[ ][a] = ' + FormatFloat('#0.0', z_obs[1]) + 'cm', Glmargin + Gwidth * 2 div 3 + 10, Gtmargin + Gheight * 3 div 5 - 8, 0);
    Pen.Color:= cl3DLight;
    Moveto(Image3.Width - 1, 0);
    Lineto(Image3.Width - 1, Image3.Height - 1);
    Lineto(0, Image3.Height - 1);
  end;
  Panel4.Visible:= True;
end;
//----------------------------------------------------------
procedure TMain.HistoryDraw(GX, GY : Array of Double; StartPoint, EndPoint: Integer; GYmin, GYmax: Double; Lcol: Integer; PenStyle: TPenStyle);
var
  Gheight, Gwidth, Glmargin, Gtmargin, i: Integer;
  nday : Integer;
  GXmax, GXmin: Single;
begin
  Gheight := Trunc(10*20*adjuster);
  Gwidth  := Trunc(480*adjuster);
  Glmargin:= Trunc(70*adjuster);
  Gtmargin:= Trunc(15*adjuster);
  nday:= Ceil(time_ * t_unit/86400 - 0.01);
  if nday = 0 then nday:= 1;
  GXmax:= (86400/ t_unit) * nday; // (86400/ t_unit) * 2 * (((nday - 1) div 2) +1);
  GXmin:= 0;
  with Image3.Canvas do
  begin
    Pen.Color:= Lcol;
    Pen.Style:= PenStyle;
     Moveto(Glmargin + Trunc((GX[StartPoint] - GXmin)/(GXmax - GXmin) * Gwidth), Gtmargin + Gheight - Trunc((GY[StartPoint] - GYmin)/(GYmax - GYmin) * Gheight));
    for i := StartPoint to EndPoint-1 do
      if (Abs(GY[i+1]) < Abs(GYmin)*10) and (Abs(GY[i+1]) < Abs(GYmax)*10) then
        Lineto(Glmargin + Trunc((GX[i+1] - GXmin)/(GXmax - GXmin) * Gwidth), Gtmargin + Gheight - Trunc((GY[i+1] - GYmin)/(GYmax - GYmin) * Gheight))
      else
        Moveto(Glmargin + Trunc((GX[i+1] - GXmin)/(GXmax - GXmin) * Gwidth), Gtmargin + Gheight - Trunc((GY[i+1] - GYmin)/(GYmax - GYmin) * Gheight));
    Pen.Color:= clBlack;
    Pen.Style:= psSolid;
    Moveto(Glmargin         , Gtmargin + Gheight * 4 div 10);
    Lineto(Glmargin + Gwidth, Gtmargin + Gheight * 4 div 10);
      //Moveto(Glmargin,          Gtmargin + Gheight - Trunc(Gheight * (0 - GYmin)/(GYmax - GYmin)));
      //Lineto(Glmargin + Gwidth, Gtmargin + Gheight - Trunc(Gheight * (0 - GYmin)/(GYmax - GYmin)));
  end;
end;
//----------------------------------------------------------
procedure TMain.PropertyDraw;
var
  Gheight, Gwidth, Glmargin, Grmargin, Gtmargin, Gbmargin, i : Integer;
  GXmax, GXmin, GYmax, GYmin : Single;
  GX, GY: array[0..50] of Double;
begin
  Panel1.top := Trunc(315*adjuster);
  Gheight := Trunc(5*45*adjuster);
  Gwidth  := Trunc(7*47*adjuster);
  Glmargin:= Trunc(80*adjuster);
  Grmargin:= Trunc(80*adjuster);
  Gtmargin:= Trunc(50*adjuster);
  Gbmargin:= Trunc(40*adjuster);
  Image5.Width := Gwidth  + Glmargin + Grmargin ;
  Image5.Height:= Gheight + Gtmargin + Gbmargin ;
  Panel1.Width := Image5.Width + 8;
  Panel1.Height:= Image5.Height+ 8;
  Panel1.Left:= Panel4.Left + Panel4.Width - Panel1.Width;
  GXmax:= 0.7; GXmin:=0;
  Image5.Canvas.Font.Assign(Image1.Canvas.Font);
  with Image5.Canvas do
  begin
    Brush.Color:= clWhite;
    Rectangle(-1,-1,Image5.Width + 1, Image5.Height + 1);
    Pen.Style:= psSolid;
    Pen.Color:= clBlack;
    Font.Size:= Trunc(StdFontSize * adjuster) ;
    Rectangle (Glmargin, Gtmargin, Glmargin + Gwidth, Gtmargin + Gheight);
    //----  X axis ----//
    Pen.Style:= psDot;
    Pen.Color:= clSilver;
    for i := 1 to 6 do
    begin
      Moveto(Glmargin + Gwidth div 7 * i, Gtmargin);
      Lineto(Glmargin + Gwidth div 7 * i, Gtmargin + Gheight);
    end;
    for i := 0 to 7 do
      TextOut(Glmargin + Gwidth div 7 * i - 3 , Gtmargin  + Gheight + 2, FloatToStr(i/10));
    TextOut(Glmargin + Trunc(60*adjuster) , Gtmargin + Gheight + Trunc(20*adjuster) , Msg[7]);
    //----- Y axis ----//
    GYmax:= 7; GYmin:= 0;
    for i := 1 to 6 do
    begin
      Moveto(Glmargin         , Gtmargin + Gheight - Gheight * i div 7);
      Lineto(Glmargin + Gwidth, Gtmargin + Gheight - Gheight * i div 7);
    end;
    SetDefaultFont;
    for i := 0 to 7 do
      TextOut(Glmargin - Trunc(20*adjuster) , Gtmargin + Gheight * i div 7 - 5, IntToStr(7-i));
    TextOut(Trunc(16*adjuster) ,Trunc(150*adjuster) , 'pF');
    TextOut(0,Trunc(175*adjuster) , '');
   //----- R axis ----//
    for i := 1 to 5 do
    begin
      Moveto(Glmargin         , Gtmargin + Gheight - Gheight * i div 7);
      Lineto(Glmargin + Gwidth, Gtmargin + Gheight - Gheight * i div 7);
    end;
    for i := 0 to 6 do
      TextOut(Glmargin + Gwidth + Trunc(10*adjuster) , Gtmargin + Gheight * i div 7 - 5, IntToStr(-i*2));
    TextOut(Glmargin + Gwidth + 25 ,Trunc(150*adjuster) , 'log K');
    TextOut(Glmargin + Gwidth + 25 ,Trunc(170*adjuster) , '(cm/s)');
    //--- Retention Curve ---//
    Pen.Style:= psSolid;
    Pen.Color:= clBlack;
    with Soil do
      for i := 1 to 50 do
      begin
        GY[i]:= - Power(10, 7/50*i);
        GX[i]:= Soil.Water_Content(GY[i], Tref[1], Wsat[1], zeta[1], Wr[1], 1, Drying[1]);
      end;
    for i := 1 to 49 do
    begin
      if (IPET_type <> 3) and (IPET_type <> 5) and (GX[i+1] < W[1]) then
        Pen.Color:= clSilver
      else
        Pen.Color:= clBlack;
      if GX[i] > 0 then
      begin
        Moveto(Glmargin + Trunc((GX[i]  - GXmin)/(GXmax - GXmin) * Gwidth), Gtmargin + Gheight - Trunc((log10(-GY[i])  - GYmin)/(GYmax - GYmin) * Gheight));
        Lineto(Glmargin + Trunc((GX[i+1]- GXmin)/(GXmax - GXmin) * Gwidth), Gtmargin + Gheight - Trunc((log10(-GY[i+1])- GYmin)/(GYmax - GYmin) * Gheight));
      end;
    end;
    //-- Retension Data --//
    Pen.Color:= clBlack;
    if Wretm[1] > 0 then
    begin
      if (Tensio >= 1) and (independent <> 1) then
        dumint:= 2
      else
        dumint:= 1;
      if IPET_type = 1 then
        dumint:= 0;
      for i := 1 to NumAddRetData + dumint do
      begin
        if Pretm[i] <> 0 then
          Rectangle(-3 + Glmargin + Trunc((Wretm[i] - GXmin)/(GXmax - GXmin) * Gwidth), -3 +Gtmargin + Gheight - Trunc((log10(-Pretm[i]) - GYmin)/(GYmax - GYmin) * Gheight),
                    +3 + Glmargin + Trunc((Wretm[i] - GXmin)/(GXmax - GXmin) * Gwidth), +3 +Gtmargin + Gheight - Trunc((log10(-Pretm[i]) - GYmin)/(GYmax - GYmin) * Gheight));
      end;
    end;
    //--- Hydraulic Conductivity Curve ---//
    GYmax:= 0; GYmin:= -14;
    with Soil do
      for i := 1 to 50 do
      begin
        if KF[1] <> 2 then
          GX[i]:= (Wsat[1] - Wr[1]) * i / 50 + Wr[1]
        else
          if bk[1] < 0 then
            GX[i]:= (Wsat[1] + bk[1] * Wsat[1]) * i / 50 - bk[1] * Wsat[1]
          else
            GX[i]:= Wsat[1] * i / 50;
        dum:= HydraulicConductivity(GX[i] * 0.9999, Tref[1], 1) / t_unit;
        if dum > 0 then
          GY[i]:= log10(dum)
        else
          GY[i]:= -30;
      end;
    for i := 49 downto 1 do
    begin
      if GY[i] < -14 then break;
      if (IPET_type <> 3) and (IPET_type <> 5) and (GX[i+1] < W[1]) then
        Pen.Color:= clSilver
      else
        Pen.Color:= clBlack;
      Moveto(Glmargin + Trunc((GX[i]  - GXmin)/(GXmax - GXmin) * Gwidth), Gtmargin + Gheight - Trunc((GY[i]  - GYmin)/(GYmax - GYmin) * Gheight));
      Lineto(Glmargin + Trunc((GX[i+1]- GXmin)/(GXmax - GXmin) * Gwidth), Gtmargin + Gheight - Trunc((GY[i+1]- GYmin)/(GYmax - GYmin) * Gheight));
    end;
    //-- Hydraulic Conductivity Data --//
    Pen.Color:= clBlue;
    if Wkm[1] > 0 then
    begin
      for i := 1 to NumAddHyConData do
      begin
        Rectangle(-3 + Glmargin + Trunc((Wkm[i] - GXmin)/(GXmax - GXmin) * Gwidth), -3 + Gtmargin + Gheight - Trunc((LogKm[i] - GYmin)/(GYmax - GYmin) * Gheight),
                  +3 + Glmargin + Trunc((Wkm[i] - GXmin)/(GXmax - GXmin) * Gwidth), +3 + Gtmargin + Gheight - Trunc((LogKm[i] - GYmin)/(GYmax - GYmin) * Gheight));
      end;
    end;
    Pen.Color:= cl3DLight;
    Moveto(Image5.Width - 1, 0);
    Lineto(Image5.Width - 1, Image5.Height - 1);
    Lineto(0, Image5.Height - 1);
  end;
  Panel1.Visible:= True;
end;
//----------------------------------------------------------
procedure TMain.SetDefaultFont;
begin
  with HyperText.TargetCanvas.Font do
  begin
    Assign(Self.Font);
    Size := Trunc(StdFontSize * adjuster);
    Style:= [];
    HyperText.Shadow:= False;
    Color:= clBlack;
  end;
end;

procedure TMain.Report;
var
  i, j: Integer;
  S2, S3, S4: String;
  y: array[0..20] of Integer;
  procedure SetCharset;
  begin
    Image4.Canvas.Font.Assign(Image1.Canvas.Font);
  end;
begin
  Panel5.Left:= Trunc(50*adjuster);
  Panel5.top := Trunc(45*adjuster);
  Image4.Width := Trunc(320*adjuster);
  Image4.Height:= Trunc(243*adjuster);
  Panel5.Width := Image4.Width  + 8;
  Panel5.Height:= Image4.Height + 8;
  HyperText.TargetCanvas:= Image4.Canvas;
  with Image4.Canvas do
  begin
    SetCharset;
    Brush.Color:= clWindow; //cl3DLight;
    Brush.Style:= bsSolid;
    Pen.Color  := clWindow; //cl3DLight;
    Rectangle(0, 0, Image4.Width, Image4.Height);
    Pen.Color:= cl3DLight;
    Moveto(Image4.Width - 1, 0);
    Lineto(Image4.Width - 1, Image4.Height - 1);
    Lineto(0, Image4.Height - 1);
    Pen.Color := clBlack;
    Font.Color:= clBlack;
    Font.Size := Trunc(StdFontSize * adjuster);
    for i := 0 to 20 do
      y[i]:= 5 + Ceil(i * 1.6 * StdFontSize); // * adjuster);
    if Mode = 1 then
    begin
      case t_unit of
      1    :dumstr:='sec';
      60   :dumstr:='min';
      3600 :dumstr:='hour';
      86400:dumstr:='day';
      end;
      SetDefaultFont;
      TextOut(3, 5,'Time = '+ FormatFloat('########0.000', time_) + dumstr);
      if (time_ > 0) and (navdt > 0) then
        TextOut(3,y[1], Msg[20] + FormatFloat('########0.00####', RoundToDecimalSF(avdt/navdt, 3)) + dumstr);
      i := 2;
      TextOut(3, y[2], Msg[21]);
      if LANG = 128 then
        j := 90
      else
        j := 140;
      TextOut(j, y[2], '= '+ FormatFloat('0.0000', W[1]));
      if solute = 1 then
      begin
        i := i + 1;
        TextOut(3, y[i], Msg[22]);
        dumstr:= ' = '+ FormatFloat('##0.00', C[1]) + 'mg/cm[^]3[-]';
        // TextOut(140, y[i], '= '+ FormatFloat('##0.00',C[1])+'mg/cm3');
        HyperText.Write(dumstr, j, y[i], 0);
        SetDefaultFont
      end;
      if heat = 1 then
      begin
        i := i + 1;
        TextOut(3, y[i], Msg[23]);
        TextOut(j, y[i], ' = '+ FormatFloat('#0.0',T[1]-273.2) + 'C');
      end;
      i := i + 1;
      TextOut(3, y[i], Msg[24] + FormatFloat('#0.000', 100 * WCumRError) + '%');
      i := i + 1;
      TextOut(3, y[i], Msg[25] + FormatFloat('#0.000', Hpond) + 'cm');
      if solute = 1 then
      begin
        i := i + 1;
        TextOut(3, y[i], Msg[26] + FormatFloat('#0.000', 100 * SCumRError) + '%');
      end;
      if heat = 1 then
      begin
        i := i + 1;
        TextOut(3, y[i], Msg[27] + FormatFloat('#0.000', 100 * ECumRError) + '%');
      end;
      if NegativeDCwarning = 1 then
      begin
        Font.Name:= 'Arial Narrow';
        Font.Size:= Trunc(0.93 * StdFontSize * adjuster);
        Font.Color:= clRed;
        TextOut(0,y[8],'[ WARNING ]');
        TextOut(0,y[9],'Negative corrected-dispersion coefficient was induced!');
        TextOut(0,y[10],'Smaller space increment is recommended.');
      end;
    end
    else
    begin
      i := -1;
      if StdFontSize > 10 then
      begin
        S4:= '[4]';
        S3:= '[3]';
        S2:= '[2]';
      end
      else
      begin
        S4:= '[3]';
        S3:= '[2]';
        S2:= '[1]';
      end;
      if KsatFix <> 1 then
      begin
        i := i + 1;
        dumstr:=  S4 + '[i][r]K[_]sat[-]' + S3 + '[a][ ] = ' + FormatFloat('0.######', Soil.Ksat[1]) + ' cm/s';
        HyperText.Write(dumstr, 3, y[i], 0);
        SetDefaultFont;
      end;
      if Water = 1 then
      begin
        if (FitMode = 1) or (independent = 1) or (IPET_type = 5) then
        begin
          i := i + 1;
          dumstr:=  S4 + '[i][r]a[_]k[-]' + S3 + '[a][ ] = ' + FormatFloat('#0.00', Soil.ak[1]);
          HyperText.Write(dumstr, 3, y[i], 0);
          SetDefaultFont;
          i := i + 1;
          dumstr:=  S4 + '[i][r]b[_]k[-]' + S3 + '[a][ ] = ' + FormatFloat('#0.00', Soil.bk[1]);
          HyperText.Write(dumstr, 3, y[i], 0);
          SetDefaultFont;
          if (Soil.KF[1] = 1) or (Soil.KF[1] = 4) then
          begin
            i := i + 1;
            dumstr:=  S4 + '[i][r]c[_]k[-]' + S3 + '[a][ ] = ' + FormatFloat('#0.00', Soil.ck[1]);
            HyperText.Write(dumstr, 3, y[i], 0);
            SetDefaultFont;
          end;
        end
        else
        begin
          if akFix <> 1 then
          begin
            i := i + 1;
            dumstr:=  S4 + '[i][r]a[_][_]k[-][a]' + S3 + '[ ] = ' + FormatFloat('0.000', Soil.ak[1]);
            HyperText.Write(dumstr, 3, y[i], 0);
            SetDefaultFont;
          end;
          if bkFix <> 1 then
          begin
            i := i + 1;
            dumstr:=  S4 + '[i][r]b[_][_]k[-][a]' + S3 + '[ ] = ' + FormatFloat('0.000', Soil.bk[1]);
            HyperText.Write(dumstr, 3, y[i], 0);
            SetDefaultFont;
          end;
          if WsatFix <> 1 then
          begin
            i := i + 1;
            dumstr:=  S3 + '[s]q[r]' + S4 + '[i][_] sat[-]' + S3 + '[ ][a] = ' + FormatFloat('0.######', Soil.Wsat[1]);
            HyperText.Write(dumstr, 3, y[i], 0);
            SetDefaultFont;
          end;
          i := i + 1;
          dumstr:=  S3 + '[s]a[a][_]1[-]' + S3 + ' = ' + FormatFloat('0.000', Soil.alpha1[1]);
          HyperText.Write(dumstr, 3, y[i], 0);
          SetDefaultFont;
          i := i + 1;
          dumstr:=  S4 + '[r][i]n[a]' + S3 + '[ ][_][_][_]1[-]' + S3 + ' = ' + FormatFloat('0.000', Soil.np1[1]);
          HyperText.Write(dumstr, 3, y[i], 0);
          SetDefaultFont;
          if WrFix <> 1 then
          begin
            i := i + 1;
            dumstr:=  S3 + '[s]q[r]' + S3 + '[_][i] r[a][-][ ]' + S3 + ' = ' + FormatFloat('0.######', Soil.Wr[1]);
            HyperText.Write(dumstr, 3, y[i], 0);
            SetDefaultFont;
          end;
        end;
      end
      else
      begin
        i := i + 1;
        dumstr:=  S4 + '[s][.][.]l[~][~][a]' + S3 + '[ ] = ' + FormatFloat('0.000', Soil.dispersivity[1]);
        HyperText.Write(dumstr, 3, y[i], 0);
        SetDefaultFont;
      end;
      i := i + 1;
      SetCharset;
      if Water = 1 then
        TextOut(3, y[i] + 4, Msg[24] + FormatFloat('#0.000', 100 * WCumRError) + '%')
      else
        TextOut(3, y[i] + 4, Msg[26] + FormatFloat('#0.000', 100 * SCumRError) + '%');
      ColumnPosition:= i;
    end;
  end;
  Panel5.Visible:= True;
end;
//===============================================================================================================================
procedure TMain.AnimatedFigure1Click(Sender: TObject);
begin
  ShowResult.PrepareAnime;
end;
//----------------------------------------------------------
procedure TMain.Play_or_StopClick(Sender: TObject);
begin
  ShowResult.Play_or_StopClick;
end;
//----------------------------------------------------------
procedure TMain.SlowClick(Sender: TObject);
begin
  ShowResult.Timer1.Interval:= ShowResult.Timer1.Interval * 2
end;
//----------------------------------------------------------
procedure TMain.RewindClick(Sender: TObject);
begin
  ShowResult.RewindClick;
end;
//----------------------------------------------------------
procedure TMain.FastForwardClick(Sender: TObject);
begin
  ShowResult.FastForwardClick;
end;
//===============================================================================================================================
procedure TMain.Language;
var
  IniFile: TIniFile;
  S, ResourceFileName: String;
  i: Integer;
begin
  Msg[1]:= 'The information file has been modified. Do you want to save current informations?';
  Msg[2]:= 'If you want to abort the simulation, press [Esc] key.';
  Msg[3]:= 'Do you want to hold files for animation?';
  Msg[4]:= 'Files for animation occupy several MB.';
  Msg[5]:= 'File already exists, overwrite?';
  Msg[6]:= 'Demo file can not be overwritten. Please save with another name.';
  Msg[7]:= 'Volumetric water content';
  Msg[8]:= '[a]Solute concentration(mg/cm[^]3[-])';
  Msg[9]:= 'Temperature(C)';
  Msg[10]:= 'Pressure head(cm)';
  Msg[11]:= 'z';
  Msg[12]:= 'Water flux (mm/d, positive upward)';
  Msg[13]:= 'Water vapor';
  Msg[14]:= 'Liquid water';
  Msg[15]:= 'Evaporation rate';
  Msg[16]:= 'Liquid flux at the top    ';
  Msg[17]:= 'Liquid flux at the bottom ';
  Msg[18]:= 'Time(day)';
  Msg[19]:= 'Time(hour)';
  Msg[20]:= 'current average time increment = ';
  Msg[21]:= 'V.W.C. at the top';
  Msg[22]:= 'concentration at the top  ';
  Msg[23]:= 'temperature at the top    ';
  Msg[24]:= 'cumul. relative error for water  = ';
  Msg[25]:= 'ponding depth = ';
  Msg[26]:= 'cumul. relative error for solute = ';
  Msg[27]:= 'cumul. relative error for heat   = ';
  Msg[28]:= 'cumulatively relative error for water  = ';
  S:= Self.Name;
  ResourceFileName:= ChangeFileExt(Application.ExeName, '.lng');
  if FileExists(ResourceFileName) then
  begin
    IniFile:= TIniFile.Create(ResourceFileName);
    with IniFile do
      try
        File1.Caption           := ReadString(S, 'File1.Caption', '');
        Open1.Caption           := ReadString(S, 'Open1.Caption', '');
        SaveAs1.Caption         := ReadString(S, 'SaveAs1.Caption', '');
        Print1.Caption          := ReadString(S, 'Print1.Caption', '');
        Exit1.Caption           := ReadString(S, 'Exit1.Caption', '');
        Input1.Caption          := ReadString(S, 'Input1.Caption', '');
        IG.Caption              := ReadString(S, 'IG.Caption', '');
        II.Caption              := ReadString(S, 'II.Caption', '');
        IP.Caption              := ReadString(S, 'IP.Caption', '');
        ISP.Caption             := ReadString(S, 'ISP.Caption', '');
        ISR.Caption             := ReadString(S, 'ISR.Caption', '');
        ISK.Caption             := ReadString(S, 'ISK.Caption', '');
        ISS.Caption             := ReadString(S, 'ISS.Caption', '');
        ISH.Caption             := ReadString(S, 'ISH.Caption', '');
        ISE.Caption             := ReadString(S, 'ISE.Caption', '');
        IW.Caption              := ReadString(S, 'IW.Caption', '');
        IA.Caption              := ReadString(S, 'IA.Caption', '');
        ISM.Caption             := ReadString(S, 'ISM.Caption', '');
        Execute1.Caption        := ReadString(S, 'Execute1.Caption', '');
        Output.Caption          := ReadString(S, 'Output.Caption', '');
        ConvertToRate.Caption   := ReadString(S, 'ConvertToRate.Caption', '');
        AnimatedFigure1.Caption := ReadString(S, 'AnimatedFigure1.Caption', '');
        PlayorStop2.Caption     := ReadString(S, 'PlayorStop2.Caption', '');
        Slow2.Caption           := ReadString(S, 'Slow2.Caption', '');
        FastForward2.Caption    := ReadString(S, 'FastForward2.Caption', '');
        Rewind2.Caption         := ReadString(S, 'Rewind2.Caption', '');
        ShowObservationFigure.Caption:= ReadString(S, 'ShowObservationFigure.Caption', '');
        ShowProfileFigure.Caption:= ReadString(S, 'ShowProfileFigure.Caption', '');
        Help1.Caption           := ReadString(S, 'Help1.Caption', '');
        Contents1.Caption       := ReadString(S, 'Contents1.Caption', '');
        About1.Caption          := ReadString(S, 'About1.Caption', '');
        ToolButton1.Hint        := ReadString(S, 'ToolButton1.Hint', '');
        ToolButton2.Hint        := ReadString(S, 'ToolButton2.Hint', '');
        ToolButton3.Hint        := ReadString(S, 'ToolButton3.Hint', '');
        ToolButton4.Hint        := ReadString(S, 'ToolButton4.Hint', '');
        ToolButton5.Hint        := ReadString(S, 'ToolButton5.Hint', '');
        for i := 1 to 30 do
          Msg[i] := StringReplace(ReadString(S, 'Msg' + IntToStr(i), ''), '<br>', #13#10, [rfReplaceAll, rfIgnoreCase]);
      finally
        IniFile.Free;
      end;
    end;
end;

//----------------------------------------------------------
procedure TMain.Contents1Click(Sender: TObject);
begin
  HelpSearch.TabControl.TabIndex:= 0;
  Application.ProcessMessages;
  HelpSearch.Show;
end;
//----------------------------------------------------------
procedure TMain.ShowObservationFigureClick(Sender: TObject);
begin
  case IPET_type of
  1: ExecuteXYGrapher(7);
  2: ExecuteXYGrapher(1);
  3: ExecuteXYGrapher(2);
  4: ExecuteXYGrapher(9);
  5: ExecuteXYGrapher(3);
  end;
end;

procedure TMain.ShowProfileFigureClick(Sender: TObject);
begin
  ExecuteXYGrapher(8);
end;
//----------------------------------------------------------
procedure TMain.ExecuteXYGrapher(XYGrapherMode: Integer; Layer: Integer = 1);
begin
  with ShowResult do
    Case XYGrapherMode of
    1:SetProperty_of_MSO_ObservationFigure(CaseName + '_Outflow&Pressure');
    2:SetProperty_of_MSI_ObservationFigure(CaseName + '_Inflow');
    3:SetProperty_of_UIM_ObservationFigure(CaseName + '_Inflow');
    4:SetProperty_of_TherConCurve(Layer, CaseName + '_THC_Curve');
    5:SetProperty_of_AlbedoCurve(Layer, CaseName + '_AlbedoCurve');
    6:SetProperty_of_EnCurve(Layer, CaseName + '_Enhance_Curve');
    7:SetProperty_of_TSM_ObservationFigure(CaseName + '_observation');
    8:SetProperty_of_ProfileFigure(CaseName + '_profile');
    9:SetProperty_of_EM_ObservationFigure(CaseName + '_observation');
    end;
 //   ShowResult.Release;
end;

procedure TMain.FormKeyUp(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  {$ifdef Linux}
  Case Key of
  Key_ESCAPE: StopCalc:= 1;
  Key_F2: if Graph = 1 then Graph:= 0 else Graph:= 1;
  end;
  {$else}
  Case Key of
  VK_ESCAPE: StopCalc:= 1;
  VK_F2: if Graph = 1 then Graph:= 0 else Graph:= 1;
  end;
  {$endif}
end;

procedure TMain.AnimeCounterDblClick(Sender: TObject);
begin
  if Demonstration = False then
  begin
    ShowMessage('Demonstration mode on.');
    Demonstration:= True
  end
  else
  begin
    ShowMessage('Demonstration mode off.');
    Demonstration:= False;
  end;
end;

procedure TMain.SendDataToSoil;
var i: Integer;
begin
  Soil.Modified:= Modified;
  Soil.Mode:= Mode;
  Soil.CaseName:= CaseName;
  Soil.BaseDir:= BaseDir;
  Soil.NumLayer:= NumLayer;
  Soil.WsatFix:= WsatFix;
  Soil.WrFix:= WrFix;
  Soil.LlambdaFix:= LlambdaFix;
  Soil.spFix:= spFix;
  Soil.ZetaFix:= ZetaFix;
  Soil.Linked_m:= Linked_m;
  Soil.heat:= heat;
  Soil.fl_retention:= fl_retention;
  Soil.IPET_type:= IPET_type;
  Soil.Independent:= Independent;
  Soil.t_unit:= t_unit;
  Soil.LANG:= LANG;
  for i := 1 to NumLayer do
    Soil.SoilName[i]:= SoilName[i];
end;

procedure TMain.RetrieveDataFromSoil;
var i: Integer;
begin
  GoAhead:= Soil.GoAhead;
  dialogbox:= Soil.dialogbox;
  WsatFix:= Soil.WsatFix;
  WrFix:= Soil.WrFix;
  LlambdaFix:= Soil.LlambdaFix;
  spFix:= Soil.spFix;
  ZetaFix:= Soil.ZetaFix;
  Linked_m:= Soil.Linked_m;
  for i := 1 to NumLayer do
    SoilName[i]:= Soil.SoilName[i];
end;

procedure TMain.SendDataToKparams;
begin
  Kparams.t_unit:= t_unit;
  Kparams.FitMode:= FitMode;
  Kparams.KsatFix:= KsatFix;
  Kparams.akFix:= akFix;
  Kparams.bkFix:= bkFix;
end;

procedure TMain.RetrieveDataFromKparams;
begin
  GoAhead:= Kparams.GoAhead;
  KsatFix:= Kparams.KsatFix;
  akFix  := Kparams.akFix;
  bkFix  := Kparams.bkFix;
  dialogbox:= Kparams.dialogbox;
end;

function TMain.GetRelativeDirectory(Origin, S: String): String;
var
  S0, S1: String;
begin
  if S <> '' then
  begin
    if Pos(AnsiLowerCase(Origin), AnsiLowerCase(S)) > 0 then
      Result := StringReplace(S, Origin + Slash, '', [rfIgnoreCase])
    else
    begin
      S  := StringReplace(S, '..' + Slash, '', [rfReplaceAll]);
      S0 := '';
      S1 := Origin;
      repeat
        S0 := S0 + '..' + Slash;
        S1 := ExtractFileDir(S1);
      until (Pos(AnsiLowerCase(S1), AnsiLowerCase(S)) > 0) or ((Length(S1) = 3) and (Pos(':', S1) > 0));
      if ((Length(S1) = 3) and (Pos(':', S1) > 0)) then
        if S[1] <> Origin[1] then
          S0 := S0 + '..' + Slash;
      if S1 = Slash then
        S1 := ''
      else
        if S1[Length(S1)] = Slash then
          S1 := Copy(S1, 0, Length(S1)-1);
      if Pos(AnsiLowerCase(S1), AnsiLowerCase(S + Slash)) = 1 then
        S := StringReplace(S, S1 + Slash, '', [rfIgnoreCase]);
      if Pos(AnsiLowerCase(S1), AnsiLowerCase(S)) = 1 then
        S := StringReplace(S, S1, '', [rfIgnoreCase]);
      Result := S0 + S;
    end;
  end
  else
    Result := '';
end;

function TMain.GetAbsoluteDirectory(Origin, S: String): String;
begin
  if (Pos('..' + Slash, S) = 0) and (Pos(':', S) > 0) then
    Result:= S
  else
  begin
    while Pos('..' + Slash, S) > 0 do
    begin
      if ((Length(Origin) > 3) or (Pos(':', Origin) = 0)) then
        Origin:= ExtractFileDir(Origin)
      else
        Origin:= '';
      S:= StringReplace(S, '..' + Slash, '', []);
    end;
    if Length(Origin) <> 3 then
    begin
      if (Origin <> Slash) and (Origin <> '') then
        Result:= Origin + Slash + S
      else
        Result:= Origin + S;
    end
    else
      Result:= Origin + S;
  end;
end;

procedure TMain.SelectFile(var ObjectFileName: String; var ObjectEdit: TEdit);
begin
  with OpenDialog3 do
  begin
    if InitialDir = '' then
      InitialDir:= BaseDir;
    FileName  := ObjectFileName;
   // if FileName = '' then
    FileName:= 'Please double-click the file above.';
    if Execute = True then
    begin
      ObjectFileName:= FileName;
      InitialDir:= ExtractFileDir(FileName);
    end;
  end;
  ObjectEdit.Text:= Main.GetRelativeDirectory(BaseDir, ObjectFileName);
end;

end.



