{
_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/

        WASH_1D version 1.36

        Copyright(C) 2000-2004 Haruyuki FUJIMAKI and Mitsuhiro INOUE
        fujimaki@sakura.cc.tsukuba.ac.jp
        URL: http://www.geocities.jp/fujimaki691202/
        Distributed under the GPL

_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/
}

unit W_Information;

interface

uses
{$ifdef Linux}
  SysUtils, Classes, QGraphics, QControls, QForms, 
  QDialogs, QStdCtrls, QExtCtrls, QButtons, QMenus, 
  IniFiles, Buttons, StdCtrls, Controls, ExtCtrls;
{$else}  
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls, Buttons, Menus, IniFiles;
{$endif}

type
  TWaterInfo = class(TForm)
    Panel1: TPanel;
    Execute: TButton;
    Next: TButton;
    Back: TButton;
    GroupBox1: TGroupBox;
    cbIC: TComboBox;
    Label1: TLabel;
    Label2: TLabel;
    Edit1: TEdit;
    GroupBox2: TGroupBox;
    Label3: TLabel;
    cbUBC: TComboBox;
    Label4: TLabel;
    Edit2: TEdit;
    Label5: TLabel;
    GroupBox3: TGroupBox;
    Label6: TLabel;
    Label7: TLabel;
    cbLBC: TComboBox;
    Edit3: TEdit;
    TableEdit3: TBitBtn;
    FileSelect3: TBitBtn;
    Label8: TLabel;
    Edit4: TEdit;
    Label10: TLabel;
    Label11: TLabel;
    RadioButton1: TRadioButton;
    RadioButton2: TRadioButton;
    Label9: TLabel;
    BitBtn1: TBitBtn;
    btnNumericalDatail: TButton;
    BitBtn2: TBitBtn;
    procedure ExecuteClick(Sender: TObject);
    procedure BackClick(Sender: TObject);
    procedure NextClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure cbICChange(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure cbUBCChange(Sender: TObject);
    procedure cbLBCChange(Sender: TObject);
    procedure TableEdit3Click(Sender: TObject);
    procedure FileSelect3Click(Sender: TObject);
    procedure BitBtn1Click(Sender: TObject);
    procedure btnNumericalDatailClick(Sender: TObject);
    procedure BitBtn2Click(Sender: TObject);
    procedure FormShow(Sender: TObject);
  private
    procedure AlignComponents(Former, Latter: TControl; Space: Integer);
    procedure Localize;
  public
  end;

var
  WaterInfo: TWaterInfo;
  Msg: array[1..20] of String;

implementation

uses WASH1dMAIN, StringGrid, Simulation, I_Information, Numerical_Detail_of_Water_Flow;

{$R *.xfm}

procedure TWaterInfo.FormCreate(Sender: TObject);
begin
end;
//--------------------------------------------------------------
procedure TWaterInfo.cbICChange(Sender: TObject);
begin
  case cbIC.ItemIndex of
    0:begin
        Label2.Caption  := Msg[1];
        Edit1.Width  := 60;
        Edit1.Text := FloatToStr(w_ini);
      end;
    1:begin
        Label2.Caption  := Msg[2];
        Edit1.Width  := 70;
        Edit1.Text := FloatToStr(p_ini);
        BitBtn2.Visible := False;
      end;
    2:begin
        Label2.Caption  := Msg[3];
        Edit1.Width  := 50;
        Edit1.Text := FloatToStr(p_top_ini);
        BitBtn2.Visible := False;
      end;
    3:begin
        Label2.Caption  := Msg[4];
        Edit1.Width  := 330;
        BitBtn2.Visible := True;
        BitBtn2.Left := Edit1.Left + Edit1.Width + 2;
        if fl_profile = '' then
        begin
          ShowMessage(Msg[5]);
          BitBtn2Click(Sender);
        end
        else
          Edit1.Text := Main.GetRelativeDirectory(BaseDir, fl_profile);
      end;
  end;
  Edit1.Left := Label2.Left + Label2.Width + 10;
  BitBtn2.Left := Edit1.Left + Edit1.Width + 1;
end;
//--------------------------------------------------------------
procedure TWaterInfo.cbUBCChange(Sender: TObject);
begin
  u_bc_type := cbUBC.ItemIndex + 1;
  case u_bc_type of
    1:begin
        Label4.Caption  := Msg[7];
        Label5.Visible := True;
        case t_unit of
            1: Label5.caption := 'cm/s';
           60: Label5.caption := 'cm/min';
         3600: Label5.caption := 'cm/h';
        86400: Label5.caption := 'cm/d';
        end;
        Edit2.Width  := 70;
        Edit2.Font.size := Trunc(9*adjuster);
        Edit2.Text := FloatToStr(ql_top);
        BitBtn1.Visible := False;
      end;
    2:begin
        Label4.Caption  := Msg[8];
        Label5.Caption := 'cm';
        Label5.Visible := True;
        Edit2.Width  := 70;
        Edit2.Font.size := Trunc(9*adjuster);
        Edit2.Text := FloatToStr(Hpond);
        BitBtn1.Visible := False;
      end;
    3:begin
        Label4.Caption  := Msg[4];
        Label5.Visible := False;
        Edit2.Width  := 355;
        Edit2.Font.size := Trunc(9*adjuster);
        Edit2.Text := Main.GetRelativeDirectory(BaseDir, fl_ql_top);
       // BitBtn1.Left := Edit2.Left + Edit2.Width;
        BitBtn1.Visible := True;
        if fl_ql_top = '' then
        begin
          ShowMessage(Msg[9]);
          Main.SelectFile(fl_ql_top, Edit2);
        end;// if
      end;
  end;
  Edit2.Left := Label4.Left + Label4.Width + 10;
  Label5.Left := Edit2.Left + Edit2.Width + 5;
end;
//--------------------------------------------------------------
procedure TWaterInfo.cbLBCChange(Sender: TObject);
begin
  FileSelect3.Visible := False;
  TableEdit3.Visible := False;
  GroupBox3.Height :=   90;
  Label7.Visible  := False;
  Label8.Visible  := False;
  Label10.Visible := False;
  Label11.Visible := False;
  Edit3.Visible   := False;
  Edit4.Visible   := False;
  l_bc_type := cbLBC.ItemIndex + 1;
  case cbLBC.ItemIndex of
    0:begin
        Label7.Caption  := Msg[10];
        Edit3.Left  := 128;
        Edit3.Width  := 53;
        Edit3.Font.size := Trunc(9*adjuster);
        Edit3.Text := FloatToStr(p_bot);
        Label7.Visible  := true;
        Edit3.Visible  := true;
      end;
    3..4: begin
            Label7.Caption  := Msg[4];
            Edit3.Left  := 80;
            Edit3.Width  := 330;
            Edit3.Font.size := Trunc(9*adjuster);
            (*
            if (cbLBC.ItemIndex = 3) and (fl_p_bot = '') and ((Mode <> 2) or (IPET_type <> 2)) then
            begin
              if Mode = 2 then
                dumstr := Msg[11]
              else
                dumstr := Msg[12];
              {$ifdef Linux}
              if Application.MessageBox(PChar(dumstr), PChar(Msg[13]), [smbYes, smbNo]) = smbYes then
                FileSelect3Click(Sender)
              else
                TableEdit3Click(Sender);
              {$else}
              if Application.MessageBox(PChar(dumstr), PChar(Msg[13]), MB_YESNO + MB_ICONQUESTION) = ID_YES then
                FileSelect3Click(Sender)
              else
                TableEdit3Click(Sender);
              {$endif}
              Edit3.Text := Main.GetRelativeDirectory(BaseDir, fl_p_bot);
            end;
            *)
            if (cbLBC.ItemIndex = 4) and (fl_outflow = '') then
            begin
              ShowMessage(Msg[14]);
              FileSelect3Click(Sender);
            end;
            Label7.Visible := True;
            Edit3.Visible  := True;
            FileSelect3.Visible := True;
            TableEdit3.Visible := True;
          end;
    end;
    if (l_bc_type = 1) or (l_bc_type = 4) then
      if heat = 0 then
      begin
        case t_unit of
            1: Label10.caption := '1/s';
           60: Label10.caption := '1/min';
         3600: Label10.caption := '1/h';
        86400: Label10.caption := '1/d';
        end;
        Edit4.Text := FloatToStr(HC_filter * t_unit);
        GroupBox3.Height :=  110;
        Label8.Visible  := True;
        Label10.Visible := True;
        Label11.Visible := True;
        Edit4.Visible   := True;
      end;
  Panel1.Top := GroupBox3.Top + GroupBox3.Height + 15;
  btnNumericalDatail.Top := Panel1.Top + 3;
  Height := Panel1.Top + Panel1.Height + 40;
end;
//--------------------------------------------------------------
procedure TWaterInfo.ExecuteClick(Sender: TObject);
begin
  DialogBox  := 0; Close;
end;
//--------------------------------------------------------------
procedure TWaterInfo.BackClick(Sender: TObject);
begin
  GoAhead := false; DialogBox := 7; Close;
end;
//--------------------------------------------------------------
procedure TWaterInfo.NextClick(Sender: TObject);
begin
  GoAhead := true; DialogBox := 9; Close;
end;
//--------------------------------------------------------------
procedure TWaterInfo.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  ic_type := cbIC.ItemIndex + 1;
  case ic_type of
  1: w_ini := StrToFloat(Edit1.Text);
  2: p_ini := StrToFloat(Edit1.Text);
  3: p_top_ini := StrToFloat(Edit1.Text);
  end;
  case u_bc_type of
  1: ql_top := StrToFloat(Edit2.Text);
  2: Hpond  := StrToFloat(Edit2.Text);
  end;
  if l_bc_type = 1 then
    P_bot := StrToFloat(Edit3.Text);
  if (l_bc_type=1) or (l_bc_type=4) then
    HC_filter := StrToFloat(Edit4.Text) / t_unit;
  if (IPET_Type = 1) and (UseOutFlowForK = 0) and (Mode = 2) then
    ic_type := 1;
  if RadioButton1.Checked then
    IniDrying := True
  else
    IniDrying := False;
end;
//--------------------------------------------------------------
procedure TWaterInfo.TableEdit3Click(Sender: TObject);
var
  i, j: Integer;
  SL1, SL2: TStringList;
  SaveDialog1: TSaveDialog;
  File_Name: String;
begin
  if cbLBC.ItemIndex = 3 then
    File_Name := fl_p_bot
  else
    File_Name := fl_outflow;
  if ((cbLBC.ItemIndex = 3) and (fl_p_bot <> '')) or ((cbLBC.ItemIndex = 4) and (fl_outflow <> '')) then
  begin
    SL1 := TStringList.Create;
    SL2 := TStringList.Create;
    i := 0;
    try
      SL1.LoadFromFile(File_Name);
      for j := 1 to SL1.Count do
      begin
        SL2.CommaText := SL1[j-1];
        try
          if cbLBC.ItemIndex = 3 then
          begin
            t_p_bot[i] := StrToFloat(SL2[0]);
            Pbot[i]    := StrToFloat(SL2[1]);
          end
          else
          begin
            t_outflow[i]  := StrToFloat(SL2[0]);
            CumOutFlow[i] := StrToFloat(SL2[1]);
          end;
          i := i + 1;
        except
        end;
      end;
    finally
      SL1.Free;
      SL2.Free;
    end;
  end
  else
    i := 20;
  Table.StringGrid1.ColCount := 2;
  Table.StringGrid1.RowCount := i+2;
  Table.StringGrid1.FixedRows := 2;
  Table.StringGrid1.Cells[0,0] := '   time';
  if cbLBC.ItemIndex = 3 then
    Table.StringGrid1.Cells[1,0] := ' Pressure'
  else
    Table.StringGrid1.Cells[1,0] := ' Outflow';
  case t_unit of
      1:dumstr := 'second';
     60:dumstr := 'min';
   3600:dumstr := 'hour';
  86400:dumstr := 'day';
  end;
  Table.StringGrid1.Cells[0,1] := '   ' + dumstr;
  Table.StringGrid1.Cells[1,1] := '    cm';
  if cbLBC.ItemIndex = 3 then
    for j := 0 to i+1 do
    begin
      Table.StringGrid1.Cells[0,j+2] := FormatFloat('######0.000',t_p_bot[j]);
      Table.StringGrid1.Cells[1,j+2] := FormatFloat('####0.0',Pbot[j]);
    end
  else
    for j := 0 to i+1 do
    begin
      Table.StringGrid1.Cells[0,j+2] := FormatFloat('######0.000',t_outflow[j]);
      Table.StringGrid1.Cells[1,j+2] := FormatFloat('####0.0', CumOutflow[j]);
    end;
  Table.StringGrid1.Width := 28;
  for j := 0 to 1 do
    Table.StringGrid1.Width := Table.StringGrid1.Width + Table.StringGrid1.ColWidths[j];
  Table.Width := Table.StringGrid1.Width + 32 * 2 ;
  Table.Panel1.Left := Table.Width div 2 - Table.Panel1.Width div 2;
  Table.Caption := Msg[15];
 //-----------------------------//
  if Table.ShowModal = mrOK then
 //----------------------------//
  begin
    SaveDialog1 := TSaveDialog.Create(self);
    with SaveDialog1 do
    begin
      FileName := File_Name;//Main.GetAbsoluteDirectory(BaseDir, File_Name);
      Filter   := 'text file|*.txt;*.csv';
      Options  := [ofOverwritePrompt];
      InitialDir := ExtractFileDir(FileName);
      if Execute <> True then
        Exit;
      dumstr := FileName;
      File_Name := ChangeFileExt(dumstr , '.csv');
      if cbLBC.ItemIndex = 3 then
        fl_p_bot   := File_Name
      else
        fl_outflow := File_Name;
      Edit3.Text := Main.GetRelativeDirectory(BaseDir, File_Name);
    end;
    SaveDialog1.Free;
    AssignFile(f, File_Name);
    Rewrite(f);
    if cbLBC.ItemIndex = 3 then
    begin
      Writeln(f, 'Time evolution of pressure head at the bottom');
      Writeln(f, '   time, pressure head(cm)');
      for j := 0 to Table.StringGrid1.RowCount - 3 do
        if Table.StringGrid1.Cells[0,j+2] <> '' then
        begin
          t_p_bot[j] := StrToFloat(Table.StringGrid1.Cells[0,j+2]);
          Pbot[j]    := StrToFloat(Table.StringGrid1.Cells[1,j+2]);
          if (j > 1) and (t_p_bot[j] = 0) then
            break;
          Writeln(f,
            Simulator.SetLengthRJ(FormatFloat('######0.00', t_p_bot[j]), 11) + ', ' +
            Simulator.SetLengthRJ(FormatFloat('####0.0', Pbot[j]), 10))
        end
    end
    else
    begin
      Writeln(f, 'Time evolution of cumulative outflow');
      Writeln(f, '   time, outflow(cm)');
      for j := 0 to Table.StringGrid1.RowCount - 3 do
        if Table.StringGrid1.Cells[0,j+2] <> '' then
        begin
          t_outflow[j] := StrToFloat(Table.StringGrid1.Cells[0,j+2]);
          CumOutflow[j]    := StrToFloat(Table.StringGrid1.Cells[1,j+2]);
          if (j > 1) and (t_p_bot[j] = 0) then
            break;
          Writeln(f,
            Simulator.SetLengthRJ(FormatFloat('######0.00', t_outflow[j]), 11) + ', ' +
            Simulator.SetLengthRJ(FormatFloat('####0.0', CumOutflow[j]), 10))
        end
    end;
    CloseFile(f);
  end;
end;
//----------------------------------------------------------
procedure TWaterInfo.FileSelect3Click(Sender: TObject);
begin
  if cbLBC.ItemIndex = 3 then
    Main.SelectFile(fl_p_bot, Edit3)
  else
    Main.SelectFile(fl_outflow, Edit3);
end;

procedure TWaterInfo.BitBtn1Click(Sender: TObject);
begin
  Main.SelectFile(fl_ql_top, Edit2);
end;

procedure TWaterInfo.btnNumericalDatailClick(Sender: TObject);
begin
  NumericalDetailOfWaterFlow := TNumericalDetailOfWaterFlow.Create(Self);
  try
    NumericalDetailOfWaterFlow.ShowModal;
  finally
    NumericalDetailOfWaterFlow.Release;
  end;
end;

procedure TWaterInfo.BitBtn2Click(Sender: TObject);
begin
  Main.SelectFile(fl_profile, Edit1);
end;

procedure TWaterInfo.Localize;
var
  IniFile: TIniFile;
  S, ResourceFileName: String;
  i: Integer;
  procedure GetComboBoxItems(CB: TComboBox );
  begin
    i := CB.ItemIndex;
    CB.Items.Text := StringReplace(IniFile.ReadString(S, CB.Name +  '.Items.Text', ''), '<br>', #13#10, [rfReplaceAll, rfIgnoreCase]);
    CB.ItemIndex := i;
  end;
begin
  Msg[1] := 'Initial volumetric water content =';
  Msg[2] := 'Initial pressure head =';
  Msg[3] := 'Initial pressure head at the soil surface =';
  Msg[4] := 'File name';
  Msg[5] := 'Please input name of the file which holds the water content profile.';
  Msg[6] := 'Atmospheric Boundary Condition';
  Msg[7] := 'Liquid water flux at the soil surface =' ;
  Msg[8] := 'Pressure head at the soil surface = ';
  Msg[9] := 'Please input name of the file which holds the time change.';
  Msg[10]:= 'Pressure head =';
  Msg[11]:= 'Do you input the time evolution of pressure at the bottom using a file which is already prepared?';
  Msg[12]:= 'Do you input the the data using a file which is already prepared?';
  Msg[13]:= 'If you use Table Editor, press [(N)] button.';
  Msg[14]:= 'Please select file which contain time evolution of lower boundary flux.';
  Msg[15]:= 'Pressure Head at the Lower B.C.';
  S := Self.Name;
  ResourceFileName := ChangeFileExt(Application.ExeName, '.lng');
  Font.Assign(Main.Font);
  if FileExists(ResourceFileName) then
  begin
    IniFile := TIniFile.Create(ResourceFileName);
    with IniFile do
      try
        Caption             := ReadString(S, 'WaterInfo.Caption', '');
        Execute.Caption     := ReadString(S, 'Execute.Caption', '');
        Next.Caption        := ReadString(S, 'Next.Caption', '');
        Back.Caption        := ReadString(S, 'Back.Caption', '');
        GroupBox1.Caption   := ReadString(S, 'GroupBox1.Caption', '');
        Label1.Caption      := ReadString(S, 'Label1.Caption', '');
        Label2.Caption      := ReadString(S, 'Label2.Caption', '');
        Label9.Caption      := ReadString(S, 'Label9.Caption', '');
        RadioButton1.Caption:= ReadString(S, 'RadioButton1.Caption', '');
        RadioButton2.Caption:= ReadString(S, 'RadioButton2.Caption', '');
        GroupBox2.Caption   := ReadString(S, 'GroupBox2.Caption', '');
        Label3.Caption      := ReadString(S, 'Label3.Caption', '');
        Label4.Caption      := ReadString(S, 'Label4.Caption', '');
        Label5.Caption      := ReadString(S, 'Label5.Caption', '');
        GroupBox3.Caption   := ReadString(S, 'GroupBox3.Caption', '');
        Label6.Caption      := ReadString(S, 'Label6.Caption', '');
        Label7.Caption      := ReadString(S, 'Label7.Caption', '');
        Label8.Caption      := ReadString(S, 'Label8.Caption', '');
        Label10.Caption     := ReadString(S, 'Label10.Caption', '');
        Label11.Caption     := ReadString(S, 'Label11.Caption', '');
        btnNumericalDatail.Caption:= ReadString(S, 'btnNumericalDatail.Caption', '');
        Font.Name           := ReadString(S, 'WaterInfo.Font.Name', '');
        Edit2.Font.Name     := ReadString(S, 'Edit2.Font.Name', '');
        Edit3.Font.Name     := ReadString(S, 'Edit3.Font.Name', '');
        Edit4.Font.Name     := ReadString(S, 'Edit4.Font.Name', '');
        GetComboBoxItems(cbIC);
        GetComboBoxItems(cbUBC);
        GetComboBoxItems(cbLBC);
        for i := 1 to 15 do
          Msg[i] := StringReplace(ReadString(S, 'Msg' + IntToStr(i), ''), '<br>', #13#10, [rfReplaceAll, rfIgnoreCase]);
      finally
        Free;
      end;
  end;
  RadioButton1.Left := Label9.Left + Label9.Width;
  RadioButton2.Left := RadioButton1.Left + RadioButton1.Width;
  AlignComponents(Label8, Edit4, 5);
  AlignComponents(Edit4, Label10, 5);
end;

procedure TWaterInfo.AlignComponents(Former, Latter: TControl; Space: Integer);
begin
  Latter.Left := Former.Left + Former.Width + Space;
end;


procedure TWaterInfo.FormShow(Sender: TObject);
begin
  DialogBox  := -1;
  if Mode = 2 then
  begin
    RadioButton1.Enabled := False;
    RadioButton2.Enabled := False;
  //  if (IPET_type = 1) and (UseOutFlowForK = 0) then
  //    begin
  //    ic_type := 1;
  //    Label2.Visible := False;
  //    Edit1.Visible  := False;
  //    end
  //  else
    if (IPET_type = 3) or (IPET_type = 5) then
    begin
      ic_type := 1;
      IniDrying := False
    end
    else
    begin
      if (IPET_type <> 6) then
        ic_type := 3;
      IniDrying := True
    end;
    u_bc_type := 1;
    ql_top := 0;
    Edit2.Enabled := False;
    case IPET_type of
    1: l_bc_type := 4;
    3: l_bc_type := 4;
    4: l_bc_type := 3;
    5:begin
        l_bc_type := 1;
        p_bot := 0.1;
        IniDrying := False;
      end;
    6: l_bc_type := 1;
    end;
    if IPET_type <> 6 then
      cbIC.Enabled := False;
    cbUBC.Enabled  := False;
    cbLBC.Enabled := False;
  end;
  if heat = 1 then
  begin
    RadioButton1.Enabled := True;
    RadioButton2.Enabled := True;
    cbUBC.Items.Add(Msg[6]);
    cbUBC.ItemIndex := 3;
    cbUBC.Enabled := False;
    Label4.Visible := False;
    Label5.Visible := False;
    Edit2.Visible  := False;
    BitBtn1.Visible := False;
  end
  else
    cbUBC.ItemIndex := u_bc_type - 1;
  cbIC.ItemIndex :=  ic_type-1;
  cbLBC.ItemIndex := l_bc_type - 1;
  Localize;
  cbICChange(Sender);
  cbUBCChange(Sender);
  cbLBCChange(Sender);
  if IniDrying then
    RadioButton1.Checked := True
  else
    RadioButton2.Checked := True;
  case l_bc_type of
  1: Edit3.Text := FloatToStr(p_bot);
  4: Edit3.Text := Main.GetRelativeDirectory(BaseDir, fl_p_bot);
  5: Edit3.Text := Main.GetRelativeDirectory(BaseDir, fl_outflow);
  end;
  Next.SetFocus;
end;

end.
